#pragma once

#ifndef _DEFINE_HPP_
#define _DEFINE_HPP_

#include "Types.hpp"

#define NUM_PARTICLES 510
// GENERAL DEFINES
const ap_uint<10> Num_Particles = 510; // 17 * 3 * 2 * 5
// Number of elements for the super cell
#define Elem_Numb  51 // IF YOU CHANGE THIS NUMBER YOU MUST ALSO CHANGE THE SIZE OF THE COUNTER !!!!!!
#define Bit_counters_Sort_cell  6
#define SortCellNumber (Num_Particles / Elem_Numb) // MUST BE INTEGER !!!!!!!!
#define Gauss_number_needed 1000
/*
 *
 *
 *
 *
 */

// Count for object model vertices
// EACH VERTICE HAS X Y Z ! SO THE TOTAL SIZE IS 3 TIMES
// DEFINES FOR THE OBJECTS
// Number of objects
#define OBJECTS 21

// Object Model limits
/* to be reblanded we want less than 1024 verteces ! */
#define OBJMODEL_V_MAX 1002
#define OBJMODEL_F_MAX 2000

#define OBJMODEL_MAXSIZE (3*(OBJMODEL_F_MAX+OBJMODEL_V_MAX))

// Count for object model vertices
// EACH VERTICE HAS X Y Z ! SO THE TOTAL SIZE IS 3 TIMES
#define OBJ_0V 1002
#define OBJ_1V 1002
#define OBJ_2V 1002
#define OBJ_3V 994
#define OBJ_4V 1002
#define OBJ_5V 1002
#define OBJ_6V 1002
#define OBJ_7V 1002
#define OBJ_8V 997
#define OBJ_9V 1002
#define OBJ_10V 1000
#define OBJ_11V 1002
#define OBJ_12V 1002
#define OBJ_13V 1000
#define OBJ_14V 1002
#define OBJ_15V 1002
#define OBJ_16V 996
#define OBJ_17V 977
#define OBJ_18V 993
#define OBJ_19V 995
#define OBJ_20V 1002

// Count for object model faces
#define OBJ_0F 2000
#define OBJ_1F 2000
#define OBJ_2F 2000
#define OBJ_3F 2000
#define OBJ_4F 2000
#define OBJ_5F 2000
#define OBJ_6F 2000
#define OBJ_7F 2000
#define OBJ_8F 2000
#define OBJ_9F 2000
#define OBJ_10F 2000
#define OBJ_11F 2000
#define OBJ_12F 2000
#define OBJ_13F 2000
#define OBJ_14F 2000
#define OBJ_15F 2000
#define OBJ_16F 2000
#define OBJ_17F 1979
#define OBJ_18F 2000
#define OBJ_19F 2000
#define OBJ_20F 2000

#define OBJ_V  OBJ_0V, OBJ_1V, OBJ_2V, OBJ_3V, OBJ_4V, \
			   OBJ_5V, OBJ_6V, OBJ_7V, OBJ_8V, OBJ_9V, \
			   OBJ_10V, OBJ_11V, OBJ_12V, OBJ_13V, OBJ_14V,\
			   OBJ_15V,  OBJ_16V, OBJ_17V, OBJ_18V,  OBJ_19V, OBJ_20V

#define OBJ_F  OBJ_0F, OBJ_1F, OBJ_2F, OBJ_3F, OBJ_4F, \
			   OBJ_5F, OBJ_6F, OBJ_7F, OBJ_8F, OBJ_9F, \
			   OBJ_10F, OBJ_11F, OBJ_12F, OBJ_13F, OBJ_14F,\
			   OBJ_15F,  OBJ_16F, OBJ_17F, OBJ_18F,  OBJ_19F, OBJ_20F

#define  OBJ_SIZE  (OBJ_0F + OBJ_0V), (OBJ_1F + OBJ_1V), (OBJ_2F + OBJ_2V), (OBJ_3F + OBJ_3V), (OBJ_4F + OBJ_4V), \
			   (OBJ_5F + OBJ_5V), (OBJ_6F + OBJ_6V), (OBJ_7F + OBJ_7V), (OBJ_8F + OBJ_8V), (OBJ_9F + OBJ_9V), \
			   (OBJ_10F + OBJ_10V), (OBJ_11F + OBJ_11V), (OBJ_12F + OBJ_12V), (OBJ_13F + OBJ_13V), (OBJ_14F + OBJ_14V),\
			   (OBJ_15F + OBJ_15V), (OBJ_16F + OBJ_16V), (OBJ_17F + OBJ_17V), (OBJ_18F + OBJ_18V), (OBJ_19F + OBJ_19V),\
				(OBJ_20F + OBJ_20V)
/*
 *
 *
 *
 *
 */

// DEFINES FOR GPU_CLASS
#define M_DIM 4 // 3bit
#define _2DIM M_DIM*M_DIM // 5bit
#define _3DIM _2DIM*M_DIM // 7bit
#define NSAMPL_2DIM  (Num_Particles)*_2DIM // 13 bit
/* IMAGE DIMENSIONS*********************************/
#define WIDTH 640
#define HEIGHT 480
const ap_uint<8> HEIGHT_HALF = 240;
const ap_uint<9> WIDTH_HALF = 320;
#define IMG_SIZE (WIDTH*HEIGHT)
/* CAMERA SETTINGS**********************************/
// Camera properties
#define NEAR 0.1
#define FAR 1000

// INVERSE PROJECTION
#define Pinv_0_0 1.0/FX
#define Pinv_0_1 0
#define Pinv_0_2 CX
#define Pinv_0_3 0

#define Pinv_1_0 0
#define Pinv_1_1 1.0/FY
#define Pinv_1_2 HEIGHT - CY
#define Pinv_1_3 0

#define Pinv_2_0 0
#define Pinv_2_1 0
#define Pinv_2_2 1
#define Pinv_2_3 0

#define Pinv_3_0 0
#define Pinv_3_1 0
#define Pinv_3_2 0
#define Pinv_3_3 1

// INT bit needed  2+1(sign)
// frac bit needed 12
#define P_0_0  (2.0 * FX / WIDTH )
#define P_0_1  0
#define P_0_2  (1.0 - (2.0 * CX / WIDTH))
#define P_0_3  0

#define P_1_0  0
#define P_1_1  (2.0 * FY / HEIGHT)// 2.260691667
#define P_1_2  ((2.0 * CY / HEIGHT)-1) //0.907441667
#define P_1_3  0

#define P_2_0  0
#define P_2_1  0
#define P_2_2  ( -(FAR + NEAR) / (FAR - NEAR) ) // -1.0002
#define P_2_3  ( -(2.0 * FAR * NEAR) / (FAR - NEAR) ) // - 0.20002

#define P_3_0  0;
#define P_3_1  0;
#define P_3_2  -1.0;
#define P_3_3  0;

// Camera intrinsic propteries
#define FX 542.556
#define FY 537.666
#define CX 325.065
#define CY 224.214

// Camera view Matrix
// 3  for int
// 12 for frac
#define C_0_0 -0.0089632 //UX
#define C_0_1 -0.9998826 //UY
#define C_0_2 0.0124269//UZ
#define C_0_3 0.00762554//UW // X TRASL
//  second row rotation
#define C_1_0 0.8500680 //VX
#define C_1_1 -0.0010746//VY
#define C_1_2 0.5266719//VZ
#define C_1_3 -0.793312//VW // Y TRASL
//  third row rotation
#define C_2_0 -0.5265967//NX
#define C_2_1 0.0152844//NY
#define C_2_2 0.8499779//NZ
#define C_2_3 -0.991729//NW // Z TRASL
// fouth row
#define C_3_0 0
#define C_3_1 0
#define C_3_2 0
#define C_3_3 1

// Objects in scene
typedef int ObjectName;

// define all object names
const ObjectName master_chef_can = 0;
const ObjectName cracker_box = 1;
const ObjectName sugar_box = 2;
const ObjectName tomato_soup_can = 3;
const ObjectName mustard_bottle = 4;
const ObjectName tuna_fish_can = 5;
const ObjectName pudding_box = 6;
const ObjectName gelatin_box = 7;
const ObjectName potted_meat_can = 8;
const ObjectName banana = 9;
const ObjectName pitcher_base = 10;
const ObjectName bleach_cleanser = 11;
const ObjectName bowl = 12;
const ObjectName mug = 13;
const ObjectName power_drill = 14;
const ObjectName wood_block = 15;
const ObjectName scissors = 16;
const ObjectName large_marker = 17;
const ObjectName large_clamp = 18;
const ObjectName extra_large_clamp = 19;
const ObjectName foam_brick = 20;

// ROM holding the names for each particle
const ObjectName object_list[OBJECTS] = { master_chef_can, cracker_box,
		sugar_box, tomato_soup_can, mustard_bottle, tuna_fish_can, pudding_box,
		gelatin_box, potted_meat_can, banana, pitcher_base, bleach_cleanser,
		bowl, mug, power_drill, wood_block, scissors, large_marker, large_clamp,
		extra_large_clamp, foam_brick };

// Load object vertices count ROM
const int vertices_num_[OBJECTS] = {
OBJ_V };

// Load object faces count ROM
const int tri_num_[OBJECTS] = {
OBJ_F };

// Load object faces count ROM
const int Object_size_mem_[OBJECTS] = {
OBJ_SIZE };

const int OBJ_RAM_DEPTH = 3 * (OBJMODEL_V_MAX + OBJMODEL_F_MAX);

const int Core_Number = 17;

#define CORE_NUMBER Core_Number

const int Num_Particle_Core = Num_Particles / Core_Number;

#define NUM_PARTICLE_CORE Num_Particle_Core

/*
 *
 *
 *
 *
 */

// DEFINES FOR THE INITIALIZER
// Heat map bounding box in each dimension
// Layer 1
const ap_uint<8> HEATMAP_H1 = 15;
const ap_uint<8> HEATMAP_W1 = 20;
// Layer 2
const ap_uint<8> HEATMAP_H2 = 30;
const ap_uint<8> HEATMAP_W2 = 40;
// Layer 3
const ap_uint<8> HEATMAP_H3 = 60;
const ap_uint<8>HEATMAP_W3 = 80;

// Number of bounding boxes in each heatmap
const ap_uint<13> HEATMAP_1 = (HEATMAP_H1 * HEATMAP_W1);
const ap_uint<13> HEATMAP_2 = (HEATMAP_H2 * HEATMAP_W2);
const ap_uint<13> HEATMAP_3 = (HEATMAP_H3 * HEATMAP_W3);


const int HEATMAP1_DEPTH = 7800;
const int HEATMAP2_DEPTH  = 31200;
const int HEATMAP3_DEPTH = 124800;

#define PYRAMID_HEATMAPS 3

const ap_uint<13> acc_dims_[PYRAMID_HEATMAPS] = { HEATMAP_1, (HEATMAP_1
		+ HEATMAP_2), (HEATMAP_1 + HEATMAP_2 + HEATMAP_3) }; // 126 , 942 , 4938
// Pyramid size by total pixels (bounding boxes in heatmap on all layers)

#define PYRAMID_PIXELS 6300 // (HEATMAP_1+HEATMAP_2+HEATMAP_3)

#define TWO_PYRAMID_PIXELS 2*PYRAMID_PIXELS

enum {
	Read_area = 0, Read_d_i = 1, End_raster = 2
};

const ap_uint<1> forward = 1;
const ap_uint<1> backword = 0;

// CHANGE == 1
// KEEP == 0
const ap_uint<1> change = 1;
const ap_uint<1> keep = 0;

// No_rast
// Yes_rast
const ap_uint<1> no_raster = 0;
const ap_uint<1> yes_raster = 1;

const ap_uint<1> no_diagonal = 0;
const ap_uint<1> yes_diagonal = 1;

const ap_uint<1> continue_raster = 0;
const ap_uint<1> end_raster = 1;

const ap_uint<8> BB_MAX_SIZE = 200;
const ap_uint<8> BB_MAX_HALF_SIZE = 100;

#endif
