#pragma once

#ifndef _DIFFUSE_HPP_
#define _DIFFUSE_HPP_
#include "hls_stream.h"
#include "Define.hpp"
#include "GRN.hpp"

void Diffuse(weight_address_Data_T Resampled_Addresses[NUM_PARTICLES],
		Mem_SAMPLE Samples_in[NUM_PARTICLES],
		Mem_SAMPLE Samples_out[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		Mem_Heuristic Heuristics[6300],
		BBOX all_box[6300],
		std_dev_Data_T trans_var,
		std_dev_Data_T rot_var);
void diffuse_type_generator(hls::stream<u4_Data_T> & diffuse_type_stream);

void diffuse_case(hls::stream<u4_Data_T> & diffuse_type_stream,
		weight_address_Data_T Resampled_Addresses[NUM_PARTICLES],
		Mem_SAMPLE Samples_in[NUM_PARTICLES],
		Mem_SAMPLE Samples_out[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		Mem_Heuristic Heuristics[6300],
		BBOX all_box[6300],
		hls::stream<Gauss_Data_T> &Trans_Rand,
		hls::stream<Gauss_Data_T> &Rot_Rand);
void diffuse_translation(xyz_Data_T t_in, xyz_Data_T &t_out,
		xyz_Data_T work_space_min, xyz_Data_T work_space_max,
		hls::stream<Gauss_Data_T> &Trans_Rand);
void diffuse_rotation(angle_Data_T r_in, angle_Data_T &r_out,
		hls::stream<Gauss_Data_T> &Rot_Rand);
void check_heuristic(Mem_SAMPLE & sample, Mem_Heuristic & heuristic);
void round_angle(ap_fixed<14 + 5, 6> &r_out);
u2_Data_T uniform_single_generator(u3_Data_T val);

#endif
