#pragma once

#ifndef _FT_CRE_MOD_HPP_
#define _FT_CRE_MOD_HPP_

#include "Define.hpp"
#include "hls_stream.h"
#include "hls_math.h"

using namespace hls;

void FT_Generator(Mem_SAMPLE Samples[NUM_PARTICLES],
		stream<MatFT_Data_T> & FT_stream);
void PrjInit(stream<MatP_Data_T> & Left_stream) ;
void Projection_MSet_Static(MatP_Data_T P[M_DIM][M_DIM]);
void CamInit(stream<MatC_Data_T> & RightMat_stream) ;
void Camera_MSet_Static(MatC_Data_T C[M_DIM][M_DIM]);
void PCNode(stream<MatP_Data_T> & Left_stream,
		stream<MatC_Data_T> & Right_stream,
		stream<MatPC_Trunc_Data_T> & Out_stream);
void FTGen_LD_Samples(Mem_SAMPLE Samples[NUM_PARTICLES],
		stream<angle_Data_T> & Angle_stream, stream<xyz_Data_T> & Pose_stream);
void AngleStrm(stream<angle_Data_T> & Angle_stream,
		stream<sincos_Struct> & z_angle_stream,
		stream<sincos_Struct> & yx_angle_stream);
void RestreamPC(stream<MatPC_Trunc_Data_T> & PC_stream,
		stream<MatPC_Trunc_Data_T> & PC_restream);
void TrRzInit(stream<xyz_Data_T> & Pose_stream,
		stream<RowTrRz_Mat_Data_T> & TrRz_stream,
		stream<sincos_Struct> & z_angle_stream);
void PCTrRzNode(stream<MatPC_Trunc_Data_T> & PC_stream,
		stream<RowTrRz_Mat_Data_T> & TrRz_stream,
		stream<Row_MatPCTrRz_Data_T> & PCTrRz_stream);
void RyRxInit(stream<sincos_Struct> & yx_angle_stream,
		stream<Col_MatRyRx_Data_T> & RyRx_stream);
void FTNode(stream<Row_MatPCTrRz_Data_T> & PCTrRz_stream,
		stream<Col_MatRyRx_Data_T> & RyRx_stream,
		stream<MatFT_Data_T> & FT_stream);
#ifdef NDEBUG
void MatrixMult_DEBUG(float A[M_DIM][M_DIM], float B[M_DIM][M_DIM], float C[M_DIM][M_DIM])
#endif

#endif
