#include "GPU.hpp"

void GPU(u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX], ObjectName Obj_Under_Test,
		stream<MatFT_Data_T> &FT_stream, Depth_Data_T Depth_scene[480][640],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		FS_W_fix_Data_T all_prob[6300], BBOX all_box[6300],
		stream<Inlier_Output> & Inl_Out) {

#pragma HLS INLINE
#pragma HLS DATAFLOW
	static stream<Vertice_Data_T> ObjectModel_stream("Obj_MODEL_STREAM");
#pragma HLS STREAM variable=ObjectModel_stream depth=1 dim=1
	static stream<Vertice> Vertice_stream("VT_STREAM");
#pragma HLS STREAM variable=Vertice_stream depth=1 dim=1
	static stream<Vertice> VT_stream_distr[10];
#pragma HLS STREAM variable=VT_stream_distr depth=1 dim=1
	static stream<MatFT_Data_T> FT_stream_distr[10];
#pragma HLS STREAM variable=FT_stream_distr depth=1 dim=1
	static stream<Center_SAMPLE> Center_SAMPLE_stream[10];
#pragma HLS STREAM variable=Center_SAMPLE_stream depth=1 dim=1
	static stream<Depth_Data_T> Depth_stream[10];
#pragma HLS STREAM variable=Depth_stream depth=1 dim=1
	static stream<size_BB> Size_BB_stream[10];
#pragma HLS STREAM variable=Size_BB_stream depth=1 dim=1
	static stream<Raster_Core_Output> Serial_weights[10];
#pragma HLS STREAM variable=Serial_weights depth=1 dim=1

	std::cout << " OBJ_DISTR" << std::endl;
	Distribute_ObjectModel(Tri_Mem, V_Mem, Obj_Under_Test, Vertice_stream);
	std::cout << " VT DISTR" << std::endl;
	Distribute_VT(Vertice_stream, Obj_Under_Test, VT_stream_distr);
	std::cout << " FT_DISTR" << std::endl;
	Distribute_FT(FT_stream, FT_stream_distr);
	std::cout << " DEPTH DISTR" << std::endl;
	Depth_distr(Depth_scene, Center_SAMPLE_stream, Depth_stream,
			Sample_abs_indx, all_box, Size_BB_stream);

	std::cout << " Raster_CORE 0" << std::endl;
	Raster_core<0>(FT_stream_distr[0], Obj_Under_Test, VT_stream_distr[0],
			Center_SAMPLE_stream[0], Depth_stream[0], Size_BB_stream[0],
			Serial_weights[0]);
	std::cout << " Raster_CORE 1" << std::endl;
	Raster_core<1>(FT_stream_distr[1], Obj_Under_Test, VT_stream_distr[1],
			Center_SAMPLE_stream[1], Depth_stream[1], Size_BB_stream[1],
			Serial_weights[1]);
	std::cout << " Raster_CORE 2" << std::endl;
	Raster_core<2>(FT_stream_distr[2], Obj_Under_Test, VT_stream_distr[2],
			Center_SAMPLE_stream[2], Depth_stream[2], Size_BB_stream[2],
			Serial_weights[2]);
	std::cout << " Raster_CORE 3" << std::endl;
	Raster_core<3>(FT_stream_distr[3], Obj_Under_Test, VT_stream_distr[3],
			Center_SAMPLE_stream[3], Depth_stream[3], Size_BB_stream[3],
			Serial_weights[3]);
	std::cout << " Raster_CORE 4" << std::endl;
	Raster_core<4>(FT_stream_distr[4], Obj_Under_Test, VT_stream_distr[4],
			Center_SAMPLE_stream[4], Depth_stream[4], Size_BB_stream[4],
			Serial_weights[4]);
	std::cout << " Raster_CORE 5" << std::endl;
	Raster_core<5>(FT_stream_distr[5], Obj_Under_Test, VT_stream_distr[5],
			Center_SAMPLE_stream[5], Depth_stream[5], Size_BB_stream[5],
			Serial_weights[5]);
	std::cout << " Raster_CORE 6" << std::endl;
	Raster_core<6>(FT_stream_distr[6], Obj_Under_Test, VT_stream_distr[6],
			Center_SAMPLE_stream[6], Depth_stream[6], Size_BB_stream[6],
			Serial_weights[6]);
	std::cout << " Raster_CORE 7" << std::endl;
	Raster_core<7>(FT_stream_distr[7], Obj_Under_Test, VT_stream_distr[7],
			Center_SAMPLE_stream[7], Depth_stream[7], Size_BB_stream[7],
			Serial_weights[7]);
	std::cout << " Raster_CORE 8" << std::endl;
	Raster_core<8>(FT_stream_distr[8], Obj_Under_Test, VT_stream_distr[8],
			Center_SAMPLE_stream[8], Depth_stream[8], Size_BB_stream[8],
			Serial_weights[8]);
	std::cout << " Raster_CORE 9" << std::endl;
	Raster_core<9>(FT_stream_distr[9], Obj_Under_Test, VT_stream_distr[9],
			Center_SAMPLE_stream[9], Depth_stream[9], Size_BB_stream[9],
			Serial_weights[9]);
	std::cout << " weight_merger" << std::endl;
	weight_merger(Serial_weights, Sample_abs_indx_CPY, all_prob, Inl_Out);
}

/*
 *
 *This actually collect and streams the information about the object it self
 *
 */

void Distribute_ObjectModel(u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX], ObjectName Obj_Under_Test,
		stream<Vertice> & Vertice_stream) {

	u11_Data_T ext_select = 0;
	u30_Data_T Vert_address;
	u2_Data_T case_select = 0;
// MUST WRITE THE ENTIRE OBJ * NUM_SAMPLE_PER_RASTER_CORE
// WHICH IS EQUAL NUM TRIANGLE*NUM_SAMPLE_PER_RASTER_CORE
// FOR EACH TRIANGLE MUST WRITE 3 POINTS
// LEADING TO AN OVERALL WRITE OF
// EQUAL NUM TRIANGLE*NUM_SAMPLE_PER_RASTER_CORE*3
	LoadObjectModel_distribute: for (u19_Data_T x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_sample_x_raster_core * 3);
			x++) {
#pragma HLS PIPELINE II=1
		// READ SEVERAL TIMES THE MODEL
		// LOAD FACE
		Vertice Vert;
		switch (case_select) {
		case 0:
			Vert_address = Tri_Mem[ext_select];
			Vert.x = V_Mem[0][Vert_address.range(9, 0)];
			Vert.y = V_Mem[1][Vert_address.range(9, 0)];
			Vert.z = V_Mem[2][Vert_address.range(9, 0)];
			case_select = 1;
			break;
		case 1:
			Vert.x = V_Mem[0][Vert_address.range(19, 10)];
			Vert.y = V_Mem[1][Vert_address.range(19, 10)];
			Vert.z = V_Mem[2][Vert_address.range(19, 10)];
			case_select = 2;
			break;
		case 2:
			Vert.x = V_Mem[0][Vert_address.range(29, 20)];
			Vert.y = V_Mem[1][Vert_address.range(29, 20)];
			Vert.z = V_Mem[2][Vert_address.range(29, 20)];
			case_select = 0;
			break;
		}
		Vertice_stream.write(Vert);

		if (ext_select < tri_num_[Obj_Under_Test] - 1) {
			ext_select++;
		} else {
			ext_select = 0;
		}
	}

}

void Distribute_FT(stream<MatFT_Data_T> & FT_stream,
		stream<MatFT_Data_T> (&FT_stream_distr)[10]) {
	u6_Data_T ext_sel = 0;

	flat_loop: for (u14_Data_T index_flat = 0; index_flat < NSAMPL_2DIM;
			index_flat++) {

#pragma HLS PIPELINE II=1

		MatFT_Data_T FT_stream_fill = FT_stream.read();
		FT_stream_distr[ext_sel].write(FT_stream_fill);

		if (index_flat.range(3, 0) == 15) {	// wait till 15
			if (ext_sel < NUM_RENDER_CORES - 1) {	// write the FT to next core
				ext_sel++;
			} else {
				ext_sel = 0;
			}
		}
	}

}

void Distribute_VT(stream<Vertice> & VT_stream, ObjectName Obj_Under_Test,
		stream<Vertice> (&VT_stream_distr)[10]) {

	LoadObjectModel_distribute: for (int x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_raster_core_tri); x++) {

#pragma HLS PIPELINE II=1
		Vertice VT_stream_fill = VT_stream.read();

		VT_stream_distr[0].write(VT_stream_fill);
		VT_stream_distr[1].write(VT_stream_fill);
		VT_stream_distr[2].write(VT_stream_fill);
		VT_stream_distr[3].write(VT_stream_fill);
		VT_stream_distr[4].write(VT_stream_fill);
		VT_stream_distr[5].write(VT_stream_fill);
		VT_stream_distr[6].write(VT_stream_fill);
		VT_stream_distr[7].write(VT_stream_fill);
		VT_stream_distr[8].write(VT_stream_fill);
		VT_stream_distr[9].write(VT_stream_fill);

	}
}
void Insertion_sort(Center_SAMPLE Centre_ysorted[10], Center_SAMPLE new_Centre,
		u4_Data_T & real_size) {
// sort by y ascend
// the actual size goes from 0 to 9 !
	if (real_size > 0) {
		// starting from the max index
		if (Centre_ysorted[real_size - 1].y_px_centre
				< new_Centre.y_px_centre) {
			// if the max element (actual _size -1 ) has lower y than the new
			// just store the new value in the max location
			Centre_ysorted[real_size] = new_Centre;
		} else {
			// if the new has lower y it means that it is in the middle of the array
			// directly shift the max element
			Centre_ysorted[real_size] = Centre_ysorted[real_size - 1];
			int j = real_size - 2;
			while (j >= 0
					&& Centre_ysorted[j].y_px_centre > new_Centre.y_px_centre) {
				// if the new element is lower continue to shift
				Centre_ysorted[j + 1] = Centre_ysorted[j];
				--j;
			}
			// save in the current location the new value
			Centre_ysorted[j + 1] = new_Centre;
		}
	} else {
		// save the first element
		// because the array is empty
		Centre_ysorted[0] = new_Centre;
	}
}

// A sort of merge sort to create the map with indices
void merge_row_indices(ap_uint<BIT_CENTRE> y_begin[10],
		ap_uint<BIT_CENTRE> y_final[10], ap_uint<10> ch_sel_begin[10],
		ap_uint<10> ch_sel_final[10], ap_uint<10> ch_selector[20],
		ap_uint<BIT_CENTRE> row_interval_list[20], u5_Data_T & real_size,
		u5_Data_T & row_interval_size) {
	int right = 0;
	int left = 1;
	row_interval_size = 1;
	row_interval_list[0] = y_begin[0];
	ch_selector[0] = ch_sel_begin[0];
	for (; right < real_size;) {
		if (y_begin[left] == y_final[right]) {
			// here start and end a BB
			ch_selector[row_interval_size] = (ch_selector[row_interval_size - 1]
					| ch_sel_begin[left]) & (~ch_sel_final[right]);
			row_interval_list[row_interval_size] = y_begin[left];
			row_interval_size++;
			left++;
			right++;
		} else if ((y_begin[left] < y_final[right]) && (left != real_size)) {
			//here a new BB is present
			ch_selector[row_interval_size] = ch_selector[row_interval_size - 1]
					| ch_sel_begin[left];
			row_interval_list[row_interval_size] = y_begin[left];
			row_interval_size++;
			if (left < real_size) {
				left++;
			}
		} else {
			// here I close the BBs
			ch_selector[row_interval_size] = ch_selector[row_interval_size - 1]
					& ~ch_sel_final[right];
			row_interval_list[row_interval_size] = y_final[right];
			row_interval_size++;
			right++;
		}
	}
	row_interval_size--;
}

void merge_col_indices(ap_uint<2> col_interval_size[20],
		intervals col_interval_list[20][3], ap_uint<10> ch_selector[20],
		u5_Data_T & row_interval_size, Center_SAMPLE Centre_ysorted[10]) {
	for (int reset_index = 0; reset_index < 20; reset_index++) {
		col_interval_list[reset_index][0].min = 0;
		col_interval_list[reset_index][0].max = 0;
		col_interval_list[reset_index][1].min = 0;
		col_interval_list[reset_index][1].max = 0;
		col_interval_list[reset_index][2].min = 0;
		col_interval_list[reset_index][2].max = 0;
		col_interval_size[reset_index] = 0;

	}

// find the X intervals
// since the BB max is 200 we can have at least 2gaps which means that we have at least three intervals
	for (int index = 0; index < row_interval_size; index++) {
		for (int bit_counter = 0; bit_counter < Num_Core_Raster;
				bit_counter++) {
			if (ch_selector[index].range(bit_counter, bit_counter)) {
				// if is in the interval we must add its colums
				ap_uint<BIT_CENTRE> current_centre =
						Centre_ysorted[bit_counter].x_px_centre;
				ap_uint<BIT_CENTRE> current_min;
				ap_uint<BIT_CENTRE> current_max;
				if (current_centre < BB_MAX_HALF_SIZE) {
					current_min = 0;
					current_max = BB_MAX_SIZE;
				} else if (current_centre > WIDTH - BB_MAX_HALF_SIZE) {
					current_min = WIDTH - BB_MAX_SIZE;
					current_max = WIDTH;
				} else {
					current_min = current_centre - BB_MAX_HALF_SIZE;
					current_max = current_centre + BB_MAX_HALF_SIZE;
				}

				if (col_interval_size[index] == 0) {
					// NO ITERVAL
					col_interval_list[index][0].min = current_min;
					col_interval_list[index][0].max = current_max;
					col_interval_size[index] = 1;

				} else if (col_interval_size[index] == 1) {
					if (current_min > col_interval_list[index][0].max) { // 0
						// if the new min is higher than the max the two interval have a gap
						// we have new interval
						col_interval_list[index][1].min = current_min;
						col_interval_list[index][1].max = current_max;
						col_interval_size[index] = 2;
					} else if (current_max >= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { // 1
						col_interval_list[index][0].max = current_max;
					} else if (current_max <= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { //2
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][0].min
							&& current_min <= col_interval_list[index][0].min) { //3
						col_interval_list[index][0].min = current_min;
					} else if (current_max < col_interval_list[index][0].min) { // 4
						// lower interval
						col_interval_list[index][1].min =
								col_interval_list[index][0].min;
						col_interval_list[index][1].max =
								col_interval_list[index][0].max;
						col_interval_list[index][0].min = current_min;
						col_interval_list[index][0].max = current_max;
						col_interval_size[index] = 2;
					}

					//////////////
					/////////////////////////

				} else if (col_interval_size[index] == 2) {

					if (current_min > col_interval_list[index][1].max) { // 0
						// if the new min is higher than the max the two interval have a gap
						// we have new interval
						col_interval_list[index][2].min = current_min;
						col_interval_list[index][2].max = current_max;
						col_interval_size[index] = 3;
					} else if (current_max >= col_interval_list[index][1].max
							&& current_min >= col_interval_list[index][1].min) { // 1
						col_interval_list[index][1].max = current_max;
					} else if (current_max <= col_interval_list[index][1].max
							&& current_min >= col_interval_list[index][1].min) { //2
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][1].min
							&& current_min > col_interval_list[index][0].max) { //3
						col_interval_list[index][1].min = current_min;
					} else if (current_max >= col_interval_list[index][1].min
							&& current_min <= col_interval_list[index][0].max) { //4
							// MERGE INTERVALS 0 and 1
						col_interval_list[index][0].max =
								col_interval_list[index][1].max; // update the max
						col_interval_list[index][1].min = 0;	// reset the min
						col_interval_list[index][1].max = 0;	// reset the max
						col_interval_size[index] = 1;

					} else if (current_max >= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { // 5
						col_interval_list[index][0].max = current_max;
					} else if (current_max <= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { //6
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][0].min
							&& current_min <= col_interval_list[index][0].min) { //7
						col_interval_list[index][0].min = current_min;
					} else if (current_max < col_interval_list[index][1].min) { // 8
						// lower interval
						col_interval_list[index][2].min =
								col_interval_list[index][1].min;
						col_interval_list[index][2].max =
								col_interval_list[index][1].max;
						col_interval_list[index][1].min =
								col_interval_list[index][0].min;
						col_interval_list[index][1].max =
								col_interval_list[index][0].max;
						col_interval_list[index][0].min = current_min;
						col_interval_list[index][0].max = current_max;
						col_interval_size[index] = 3;
					}

				} else { // this is the case 3

					if (current_max >= col_interval_list[index][2].max
							&& current_min >= col_interval_list[index][2].min) { // 0
						col_interval_list[index][2].max = current_max;
					} else if (current_max <= col_interval_list[index][2].max
							&& current_min >= col_interval_list[index][2].min) { //1
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][2].min
							&& current_min > col_interval_list[index][1].max) { //2
						col_interval_list[index][2].min = current_min;
					} else if (current_max >= col_interval_list[index][2].min
							&& current_min <= col_interval_list[index][1].max) { //3
							// MERGE INTERVALS 2 and 1
						col_interval_list[index][1].max =
								col_interval_list[index][2].max; // update the max
						col_interval_list[index][2].min = 0;	// reset the min
						col_interval_list[index][2].max = 0;	// reset the max
						col_interval_size[index] = 2;

					} else if (current_max >= col_interval_list[index][1].max
							&& current_min >= col_interval_list[index][1].min) { // 4
						col_interval_list[index][1].max = current_max;
					} else if (current_max <= col_interval_list[index][1].max
							&& current_min >= col_interval_list[index][1].min) { //5
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][1].min
							&& current_min > col_interval_list[index][0].max) { //6
						col_interval_list[index][1].min = current_min;
					} else if (current_max >= col_interval_list[index][1].min
							&& current_min <= col_interval_list[index][0].max) { //7
							// MERGE INTERVALS 0 and 1
						col_interval_list[index][0].max =
								col_interval_list[index][1].max; // update the max
						col_interval_list[index][1].min =
								col_interval_list[index][2].min;
						col_interval_list[index][1].max =
								col_interval_list[index][2].max;
						col_interval_list[index][2].min = 0;	// reset the min
						col_interval_list[index][2].max = 0;	// reset the max
						col_interval_size[index] = 1;

					} else if (current_max >= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { // 8
						col_interval_list[index][0].max = current_max;
					} else if (current_max <= col_interval_list[index][0].max
							&& current_min >= col_interval_list[index][0].min) { //9
							// inside.. do nothing
					} else if (current_max >= col_interval_list[index][0].min
							&& current_min <= col_interval_list[index][0].min) { //10
						col_interval_list[index][0].min = current_min;
					}
				}
			}
		}
	}

}

void Depth_distr(Depth_Data_T Depth_scene[480][640],
		stream<Center_SAMPLE> (&Center_SAMPLE_stream)[10],
		stream<Depth_Data_T> (&Depth_stream)[10],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		BBOX all_box[6300], stream<size_BB> (&Size_BB_stream)[10]) {

#ifdef NDEBUG
	Center_SAMPLE curr_centre_array[51][10];
	int count[10];
	for (int indice = 0; indice < Num_Core_Raster; indice++) {
		count[indice] = 0;
	}

#endif

	for (u6_Data_T x = 0; x < Num_sample_x_raster_core; x++) {
		Center_SAMPLE curr_centre[10];
		Center_SAMPLE Centre_ysorted[10];
		ap_uint<10> ch_sel_begin[10];
		ap_uint<10> ch_sel_final[10];
		ap_uint<BIT_CENTRE> y_begin[10];
		ap_uint<BIT_CENTRE> y_final[10];
		ap_uint<BIT_CENTRE> x_begin[10];
		ap_uint<BIT_CENTRE> x_final[10];

		Sample_abs_indx_Data_T current_index;

		u5_Data_T real_size = 1;

		// DISTRIBUTE THE CENTRE TO ALL OF THE RASTER CORE
		for (u4_Data_T indice = 0; indice < Num_Core_Raster; indice++) {

			current_index = Sample_abs_indx[indice + x * Num_Core_Raster];
			BBOX curr_BB = all_box[current_index];
			curr_centre[indice].x_px_centre = curr_BB.x_centre_width.range(
			BIT_CENTRE + BIT_BB_IMG - 1,
			BIT_BB_IMG);
			curr_centre[indice].y_px_centre = curr_BB.y_centre_height.range(
			BIT_CENTRE + BIT_BB_IMG - 1, BIT_BB_IMG);
			size_BB current_size;
			current_size.width = curr_BB.x_centre_width.range(
			BIT_BB_IMG - 1, 0);
			current_size.height = curr_BB.y_centre_height.range(
			BIT_BB_IMG - 1, 0);
			Size_BB_stream[indice].write(current_size);
			Center_SAMPLE_stream[indice].write(curr_centre[indice]);
			Insertion_sort(Centre_ysorted, curr_centre[indice], indice);
			// reset the channel selectors and deltas
			ch_sel_begin[indice] = 0;
			ch_sel_final[indice] = 0;
			y_begin[indice] = 0;
			y_final[indice] = 0;
			x_begin[indice] = 0;
			x_final[indice] = 0;
#ifdef NDEBUG
			curr_centre_array[x][indice] = curr_centre[indice];
#endif
		}

		// SATURATE THE Y0
		if (Centre_ysorted[0].y_px_centre > HEIGHT - BB_MAX_HALF_SIZE) {
			// BECAUSE IF THE MAX SATURATE THE BOUNDARIES WE FIX THE DEPTH AND LET THE CENTER MOVE
			y_begin[0] = HEIGHT - BB_MAX_SIZE;
			y_final[0] = HEIGHT;
			ch_sel_begin[0] = 1023; // all channel are selected for this interval
			ch_sel_final[0] = 1023;
		} else {
			ap_uint<BIT_CENTRE> current_delta;
			ap_int<11> ymin = Centre_ysorted[0].y_px_centre - BB_MAX_HALF_SIZE;
			if (ymin < 0) {
				// if the y is below the minimum range we correct
				y_begin[0] = 0;
				y_final[0] = BB_MAX_SIZE;
				current_delta = BB_MAX_HALF_SIZE;
				ch_sel_begin[0].range(0, 0) = 1;
				ch_sel_final[0].range(0, 0) = 1;
			} else {
				y_begin[0] = ymin;
				y_final[0] = ymin + BB_MAX_SIZE;
				current_delta = ymin + BB_MAX_HALF_SIZE;
				ch_sel_begin[0].range(0, 0) = 1;
				ch_sel_final[0].range(0, 0) = 1;
			}
			for (int index = 1; index < Num_Core_Raster; index++) {

				if (Centre_ysorted[index].y_px_centre <= current_delta) {
					// if the new value is equal to the precedent
					// select the channel to be stream
					ch_sel_begin[real_size - 1].range(index, index) = 1;
					ch_sel_final[real_size - 1].range(index, index) = 1;
				} else if (Centre_ysorted[index].y_px_centre
						> HEIGHT - BB_MAX_HALF_SIZE) {
					y_begin[real_size] = HEIGHT - BB_MAX_SIZE;
					y_final[real_size] = HEIGHT;
					current_delta = Centre_ysorted[index].y_px_centre;
					ch_sel_begin[real_size].range(index, index) = 1;
					ch_sel_final[real_size].range(index, index) = 1;
					real_size++;
				} else {
					y_begin[real_size] = Centre_ysorted[index].y_px_centre
							- BB_MAX_HALF_SIZE;
					y_final[real_size] = Centre_ysorted[index].y_px_centre
							+ BB_MAX_HALF_SIZE;
					current_delta = Centre_ysorted[index].y_px_centre;
					ch_sel_begin[real_size].range(index, index) = 1;
					ch_sel_final[real_size].range(index, index) = 1;
					real_size++;
				}

			}
		}

#ifdef NDEBUG
		for (int index = 0; index < Num_Core_Raster; index++) {
			std::cout << index << ") \t y : "
			<< Centre_ysorted[index].y_px_centre << " \t x : "
			<< Centre_ysorted[index].x_px_centre << std::endl;
		}
		for (int index = 0; index < real_size; index++) {
			for (int bit_counter = 0; bit_counter < Num_Core_Raster;
					bit_counter++) {
				std::cout << ch_sel_begin[index].range(bit_counter, bit_counter)
				<< " ";
			}
			std::cout << " |" << y_begin[index] << "| ";
			for (int bit_counter = 0; bit_counter < Num_Core_Raster;
					bit_counter++) {
				std::cout << ch_sel_begin[index].range(bit_counter, bit_counter)
				<< " ";
			}
			std::cout << " |" << y_final[index] << "| " << std::endl;
		}
#endif
		// THESE INFORMATION WILL BE USED TO DIVIDE THE DEPTH
		ap_uint<10> ch_selector[20];
		ap_uint<BIT_CENTRE> row_interval_list[20];
		u5_Data_T row_interval_size;
		intervals col_interval_list[20][3];
		ap_uint<2> col_interval_size[20];

		merge_row_indices(y_begin, y_final, ch_sel_begin, ch_sel_final,
				ch_selector, row_interval_list, real_size, row_interval_size);

		merge_col_indices(col_interval_size, col_interval_list, ch_selector,
				row_interval_size, Centre_ysorted);

		// SATURATE THE Y0
		// SATURATE THE X0
		for (u4_Data_T index = 0; index < Num_Core_Raster; index++) {
			if (curr_centre[index].x_px_centre > WIDTH - BB_MAX_HALF_SIZE) {
				// BECAUSE IF THE MAX SATURATE THE BOUNDARIES WE FIX THE DEPTH AND LET THE CENTER MOVE
				x_begin[index] = WIDTH - BB_MAX_SIZE;
				x_final[index] = WIDTH;
			} else {
				ap_int<11> xmin = curr_centre[index].x_px_centre
						- BB_MAX_HALF_SIZE;
				if (xmin < 0) {
					// if the y is below the minimum range we correct
					x_begin[index] = 0;
					x_final[index] = BB_MAX_SIZE;
				} else {
					x_begin[index] = xmin;
					x_final[index] = xmin + BB_MAX_SIZE;
				}
			}
			if (curr_centre[index].y_px_centre > HEIGHT - BB_MAX_HALF_SIZE) {
				// BECAUSE IF THE MAX SATURATE THE BOUNDARIES WE FIX THE DEPTH AND LET THE CENTER MOVE
				y_begin[index] = HEIGHT - BB_MAX_SIZE;
				y_final[index] = HEIGHT;
			} else {
				ap_int<11> ymin = curr_centre[index].y_px_centre
						- BB_MAX_HALF_SIZE;
				if (ymin < 0) {
					// if the y is below the minimum range we correct
					y_begin[index] = 0;
					y_final[index] = BB_MAX_SIZE;
				} else {
					y_begin[index] = ymin;
					y_final[index] = ymin + BB_MAX_SIZE;
				}
			}
		}

#ifdef NDEBUG

		for (int index = 0; index < Num_Core_Raster; index++) {
			std::cout << index << ") \t y : " << curr_centre[index].y_px_centre
			<< " \t y_delta : " << y_begin[index] << " , "
			<< y_final[index] - 1 << " \t x : "
			<< curr_centre[index].x_px_centre << " \t x_delta : "
			<< x_begin[index] << " , " << x_final[index] - 1
			<< std::endl;
		}
#endif
#ifdef NDEBUG
		for (int index = 0; index < row_interval_size; index++) {

			std::cout << index << ") \n row : " << row_interval_list[index]
			<< " , " << row_interval_list[index + 1] - 1 << std::endl;

			for (int interval_index = 0;
					interval_index < col_interval_size[index];
					interval_index++) {

				std::cout << " col : "
				<< col_interval_list[index][interval_index].min << " , "
				<< col_interval_list[index][interval_index].max - 1
				<< "\t ";
			}
			std::cout << std::endl << " ";
			for (int bit_counter = 0; bit_counter < Num_Core_Raster;
					bit_counter++) {

				std::cout << ch_selector[index].range(bit_counter, bit_counter)
				<< " ";
			}
			std::cout << std::endl;
			for (int bit_counter = 0; bit_counter < Num_Core_Raster;
					bit_counter++) {

				if (ch_selector[index].range(bit_counter, bit_counter)) {
					std::cout << " y : " << curr_centre[bit_counter].y_px_centre
					<< " \t x : "
					<< curr_centre[bit_counter].x_px_centre
					<< " \t y_delta : " << y_begin[bit_counter] << " , "
					<< y_final[bit_counter] - 1 << " \t x_delta : "
					<< x_begin[bit_counter] << " , "
					<< x_final[bit_counter] - 1 << std::endl;
				}
			}
			std::cout << std::endl;
		}
#endif

		for (int index = 0; index < row_interval_size; index++) {
			for (int row = row_interval_list[index];
					row < row_interval_list[index + 1]; row++) {

				for (int interval_index = 0;
						interval_index < col_interval_size[index];
						interval_index++) {
					for (int col = col_interval_list[index][interval_index].min;
							col < col_interval_list[index][interval_index].max;
							col++) {
						// load the temporary depth

						// CHANNEL LINE BY LINE
						for (int bit_counter = 0; bit_counter < Num_Core_Raster;
								bit_counter++) {
#pragma HLS UNROLL
							// CHECK FOR ALL THE CHANNELS
							if (row >= y_begin[bit_counter]
									&& row < y_final[bit_counter]
									&& col >= x_begin[bit_counter]
									&& col < x_final[bit_counter]) {
								Depth_stream[bit_counter].write(
										Depth_scene[row][col]);
#ifdef NDEBUG
								count[bit_counter]++;
#endif

							}
						}
					}
				}
			}
		}

#ifdef NDEBUG

		for (int bit_counter = 0; bit_counter < Num_Core_Raster;
				bit_counter++) {
			std::cout << " y,x : " << y_begin[bit_counter] << " "
			<< y_final[bit_counter] << " " << x_begin[bit_counter]
			<< " " << x_final[bit_counter] << std::endl;

		}

		for (int index = 0; index < row_interval_size; index++) {
			std::cout << " row : " << row_interval_list[index] << " "
			<< row_interval_list[index + 1] << std::endl;

			for (int interval_index = 0;
					interval_index < col_interval_size[index];
					interval_index++) {
				std::cout << " col : "
				<< col_interval_list[index][interval_index].min << " "
				<< col_interval_list[index][interval_index].max
				<< std::endl;

			}
		}
		for (int indice = 0; indice < Num_Core_Raster; indice++) {
			std::cout << indice << " : " << count[indice] << std::endl;
			count[indice] = 0;
		}

#endif
#ifdef NDEBUG
		std::cout << "0 1 2 3 4 5 6 7 8 9" << std::endl;
		std::cout << "___________________" << std::endl;
		for (int index = 0; index < row_interval_size; index++) {
			for (int bit_counter = 0; bit_counter < Num_Core_Raster;
					bit_counter++) {
				std::cout << ch_selector[index].range(bit_counter, bit_counter)
				<< " ";
			}
			std::cout << " \t |" << row_interval_list[index] << "| \t --> \t |"
			<< row_interval_list[index + 1] << "|----- \t";

			std::cout << " \t |" << col_interval_list[index][0].min
			<< "| \t --> \t |" << col_interval_list[index][0].max
			<< "| ";
			std::cout << " \t |" << col_interval_list[index][1].min
			<< "| \t --> \t |" << col_interval_list[index][1].max
			<< "| ";
			std::cout << " \t |" << col_interval_list[index][2].min
			<< "| \t --> \t |" << col_interval_list[index][2].max
			<< "|----- \t " << col_interval_size[index] << std::endl;

		}
		std::cout << std::endl;
#endif
#ifdef NDEBUG
		////////////////////////////////////////////ACROSS CHANNEL ////////////////////////////////////////////
		std::stringstream ss_new;
		ss_new << "DEPTH_";
		ss_new << x;
		ss_new << "_ACROSS_CHANNELS_NEW.ppm";
		std::string str_new = ss_new.str();
		std::ofstream img_new(str_new.c_str());
		img_new << "P2" << std::endl;
		img_new << WIDTH << " " << HEIGHT << std::endl;
		img_new << "65535" << std::endl;
		float temp_new[HEIGHT][WIDTH];
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				temp_new[row][col] = 4.0;
			}
		}
		int OPT_TRANSMISSION = 0;

		for (int index = 0; index < row_interval_size; index++) {
			for (int row = row_interval_list[index];
					row < row_interval_list[index + 1]; row++) {

				for (int interval_index = 0;
						interval_index < col_interval_size[index];
						interval_index++) {
					for (int col = col_interval_list[index][interval_index].min;
							col < col_interval_list[index][interval_index].max;
							col++) {
						// load the temporary depth
						OPT_TRANSMISSION++;
						// CHANNEL LINE BY LINE
						for (int bit_counter = 0; bit_counter < Num_Core_Raster;
								bit_counter++) {
#pragma HLS UNROLL
							// CHECK FOR ALL THE CHANNELS
							if (row >= y_begin[bit_counter]
									&& row < y_final[bit_counter]
									&& col >= x_begin[bit_counter]
									&& col < x_final[bit_counter]) {
								temp_new[row][col] =
								Depth_scene[row][col].to_float();

							}
						}
					}
				}
			}
		}

		float max_D_F = 0;
		float min_D_F = 65535;
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (temp_new[row][col] > max_D_F && temp_new[row][col] <= 1.0) {
					max_D_F = temp_new[row][col];
				} else if (temp_new[row][col] < min_D_F) {
					min_D_F = temp_new[row][col];
				}
			}
		}

		float range_D_F = 1.0 / (max_D_F - min_D_F);

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (temp_new[row][col] >= max_D_F) {
					temp_new[row][col] = 0.0;
				} else {
					temp_new[row][col] = (max_D_F - temp_new[row][col])
					* range_D_F * 65534.0;
				}

			}
		}

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				img_new << (int) temp_new[row][col] << " ";

			}
			img_new << " \n ";
		}
		img_new.close();
		/////////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////ACROSS CHANNEL ////////////////////////////////////////////
		std::stringstream ss;
		ss << "DEPTH_";
		ss << x;
		ss << "_ACROSS_CHANNELS_.ppm";
		std::string str = ss.str();
		std::ofstream img(str.c_str());
		img << "P2" << std::endl;
		img << WIDTH << " " << HEIGHT << std::endl;
		img << "65535" << std::endl;
		int temp_BASE[HEIGHT][WIDTH];
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				temp_BASE[row][col] = 4;
			}
		}

		float max_depth = 0;
		float min_depth = 60000;

		int BASE_TRANSMISSION = 0;

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (Depth_scene[row][col].to_float() > max_depth
						&& Depth_scene[row][col].to_float() <= 1.0) {
					max_depth = Depth_scene[row][col].to_float();
				} else if (Depth_scene[row][col].to_float() < min_depth) {
					min_depth = Depth_scene[row][col].to_float();
				}
			}
		}

		float range_depth = 1.0 / (max_depth - min_depth);

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (Depth_scene[row][col].to_float() >= max_depth) {
					temp_BASE[row][col] = 0.0;
				} else {
					temp_BASE[row][col] = (max_depth
							- Depth_scene[row][col].to_float()) * range_depth
					* 65534.0;
				}

			}
		}

		for (int indice = 0; indice < Num_Core_Raster; indice++) {
			offset_position Offset;

			create_offsets(Offset, curr_centre_array[x][indice]);
			for (int row = 0; row < BB_MAX_SIZE; row++) {
				for (int col = 0; col < BB_MAX_SIZE; col++) {
					BASE_TRANSMISSION++;
					if (row == 0 || row == BB_MAX_SIZE - 1) {
						temp_BASE[row + Offset.offset_row][col
						+ Offset.offset_col] = 65534;

					} else {
						if (col == 0 || col == BB_MAX_SIZE - 1) {
							temp_BASE[row + Offset.offset_row][col
							+ Offset.offset_col] = 65534;
						}
					}
					if (col == BB_MAX_HALF_SIZE - 1
							&& row == BB_MAX_HALF_SIZE - 1) {
						temp_BASE[row + Offset.offset_row][col
						+ Offset.offset_col] = 65534;
					}
				}
			}
		}
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				img << (int) temp_BASE[row][col] << " ";

			}
			img << " \n ";
		}
		img.close();
		/////////////////////////////////////////////////////////////////////////////////////////////////////

//		std::cout << x << ") BASE_TRANSMISSION : " << BASE_TRANSMISSION
//				<< std::endl;
//		std::cout << x << ") OPT_TRANSMISSION : " << OPT_TRANSMISSION
//				<< std::endl;
//		std::cout << std::endl
//				<< "------------------------------------------------";
//		std::cout << std::endl;
#endif
	}

#ifdef NDEBUG
	for (int indice = 0; indice < Num_Core_Raster; indice++) {
		////////////////////////////////////////////SAME CHANNEL ////////////////////////////////////////////

		std::stringstream ss2;
		ss2 << "DEPTH_";
		ss2 << indice;
		ss2 << "_SAME_CHANNEL_.ppm";
		std::string str2 = ss2.str();
		std::ofstream img2(str2.c_str());
		img2 << "P1" << std::endl;
		img2 << WIDTH << " " << HEIGHT << std::endl;
		int temp[HEIGHT][WIDTH];
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				temp[row][col] = 0;
			}
		}
		for (int x = 0; x < Num_sample_x_raster_core; x++) {
			offset_position Offset;

			create_offsets(Offset, curr_centre_array[x][indice]);
//			std::cout << indice << ") \t y : "
//					<< curr_centre[x][indice].y_px_centre << " \t y_offset : "
//					<< Offset.offset_row << " \t x : "
//					<< curr_centre[x][indice].x_px_centre << " \t x_offset : "
//					<< Offset.offset_col << std::endl;
			for (int row = 0; row < BB_MAX_SIZE; row++) {
				for (int col = 0; col < BB_MAX_SIZE; col++) {

					if (row == 0 || row == BB_MAX_SIZE - 1) {
						temp[row + Offset.offset_row][col + Offset.offset_col] =
						1;

					} else {
						if (col == 0 || col == BB_MAX_SIZE - 1) {
							temp[row + Offset.offset_row][col
							+ Offset.offset_col] = 1;
						}
					}
					if (col == BB_MAX_HALF_SIZE - 1
							&& row == BB_MAX_HALF_SIZE - 1) {
						temp[row + Offset.offset_row][col + Offset.offset_col] =
						1;
					}
				}
			}
		}
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				img2 << temp[row][col] << " ";

			}
			img2 << " \n ";
		}
		img2.close();
		/////////////////////////////////////////////////////////////////////////////////////////////////////
	}
#endif
}

template<int ID>

void Raster_core(stream<MatFT_Data_T> & FT_stream_distr,
		ObjectName Obj_Under_Test, stream<Vertice> & Vertice_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<Depth_Data_T> & Depth_stream, stream<size_BB> & Size_BB_stream,
		stream<Raster_Core_Output> & Serial_weights) {
#pragma HLS DATAFLOW
#pramga HLS INLINE
	static stream<MatFT_Data_T> FT_stream_SEQ[M_DIM][M_DIM]; // check what is the best
#pragma HLS STREAM variable=FT_stream_SEQ depth=4 dim=1 // we can rethink about the write ! only one dimention
#pragma HLS STREAM variable=FT_stream_SEQ depth=4 dim=2

	static stream<Vec_4D_Data_T> V_w_stream("V_w_stream");
#pragma HLS STREAM variable=V_w_stream depth=1 dim=1
	static stream<Vec_4D_Data_T> V_xyz_stream("V_xyz_stream");
#pragma HLS STREAM variable=V_xyz_stream depth=1 dim=1
	static stream<V_w_rec_Data_T> V_w_recipr_stream("V_w_recipr_stream");
#pragma HLS STREAM variable=V_w_recipr_stream depth=1 dim=1
	static stream<Vertice_final> Vertice_final_stream("Vertice_final_stream");
#pragma HLS STREAM variable=Vertice_final_stream depth=1 dim=1
	static stream<Vertice_final> Vertice_z_correct_stream(
			"Vertice Depth correct");
#pragma HLS STREAM variable=Vertice_z_correct_stream depth=1 dim=1
	static stream<Vec_Norm_Data_T> Area_stream("Area_stream");
#pragma HLS STREAM variable=Area_stream depth=1 dim=1
	static stream<Depth_Non_Norm_Data_T> z_stream("z_stream");
#pragma HLS STREAM variable=z_stream depth=1 dim=1
	static stream<position> index_stream("index_stream");
#pragma HLS STREAM variable=index_stream depth=1 dim=1
	static stream<u2_Data_T> comand_stream("comand_stream");
#pragma HLS STREAM variable=comand_stream depth=1 dim=1
	static stream<count_pixel_Data_T> V_R_stream("V_R_stream");
#pragma HLS STREAM variable=V_R_stream depth=1 dim=1
	static stream<count_pixel_Data_T> V_D_stream("V_D_stream");
#pragma HLS STREAM variable=V_D_stream depth=1 dim=1
	static stream<Inlier_Data_T> Inlier_stream("Inlier_stream");
#pragma HLS STREAM variable=Inlier_stream depth=1 dim=1

	static stream<Center_SAMPLE> Center_SAMPLE_stream_tri("Centre Tri");
#pragma HLS STREAM variable=Center_SAMPLE_stream_tri depth=1 dim=1
	static stream<size_BB> Size_BB_stream_tri("Size Tri");
#pragma HLS STREAM variable=Size_BB_stream_tri depth=1 dim=1
	static stream<Center_SAMPLE> Center_SAMPLE_stream_dep("Centre Depth");
#pragma HLS STREAM variable=Center_SAMPLE_stream_dep depth=1 dim=1
	static stream<size_BB> Size_BB_stream_dep("Size Depth");
#pragma HLS STREAM variable=Size_BB_stream_dep depth=1 dim=1

	std::cout << "RC_FT_Storing" << std::endl;
	RC_FT_Storing(FT_stream_distr, FT_stream_SEQ);

	std::cout << "Vector_Transformation" << std::endl;
	Vector_Transformation(FT_stream_SEQ, Obj_Under_Test, Vertice_stream,
			V_w_stream, V_xyz_stream);
	std::cout << "reciprocal" << std::endl;
	reciprocal(V_w_stream, Obj_Under_Test, V_w_recipr_stream);
	std::cout << "Vector_normalisation" << std::endl;
	Vector_normalisation(V_xyz_stream, Obj_Under_Test, V_w_recipr_stream,
			Vertice_final_stream);
	std::cout << "Vector_Z_recover" << std::endl;
	Vector_Z_recover(Vertice_final_stream, Obj_Under_Test,
			Vertice_z_correct_stream);
	std::cout << "C_BB_duplicate" << std::endl;
	C_BB_duplicate(Center_SAMPLE_stream, Size_BB_stream,
			Center_SAMPLE_stream_tri, Size_BB_stream_tri,
			Center_SAMPLE_stream_dep, Size_BB_stream_dep);
	std::cout << "triangle_set" << std::endl;
	triangle_set(Vertice_z_correct_stream, Obj_Under_Test, Area_stream,
			z_stream, index_stream, comand_stream, Center_SAMPLE_stream_tri,
			Size_BB_stream_tri);
	std::cout << "depth_substitution" << std::endl;
	depth_substitution(Center_SAMPLE_stream_dep, Area_stream, z_stream,
			index_stream, comand_stream, ID, Obj_Under_Test, Depth_stream,
			Size_BB_stream_dep, V_R_stream, V_D_stream, Inlier_stream);
	std::cout << "inlier_evaluator" << std::endl;
	inlier_evaluator(ID, V_R_stream, V_D_stream, Inlier_stream, Serial_weights);
	std::cout << "EXIT_RASTER_CORE" << ID << std::endl;

}

void weight_merger(stream<Raster_Core_Output> (&Serial_weights)[10],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		FS_W_fix_Data_T all_prob[6300], stream<Inlier_Output> & Inl_Out) {
	for (int x = 0; x < Num_sample_x_raster_core; x++) {
		for (int core = 0; core < Num_Core_Raster; core++) {
#pragma HLS PIPELINE
			weight_address_Data_T address = core + x * Num_Core_Raster;
			Sample_abs_indx_Data_T curr_abs_index = Sample_abs_indx_CPY[address];
			Raster_Core_Output Serial_weights_fill =
					Serial_weights[core].read();
			FS_W_fix_Data_T curr_probability = all_prob[curr_abs_index];
			Inlier_Output Outfill;
			Outfill.weight =
					Numerator_Data_T(
							((Serial_weights_fill.Numerator)
									/ Serial_weights_fill.Denominator
									+ curr_probability) >> 2);
//			std::cout << core << "_" << x << Outfill.weight << "   "
//					<< Numerator_Data_T(
//							Serial_weights_fill.Numerator
//									/ Serial_weights_fill.Denominator)
//					<< std::endl;
			Outfill.address = address;
			Inl_Out.write(Outfill);
		}
	}

}
