#pragma once

#ifndef _GPU_HPP_
#define _GPU_HPP_

#include "Define.hpp"
#include "hls_stream.h"
#include "Raster_core.hpp"
using namespace hls;

void GPU(u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX], ObjectName Obj_Under_Test,
		stream<MatFT_Data_T> &FT_stream, Depth_Data_T Depth_scene[480][640],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		FS_W_fix_Data_T all_prob[6300], BBOX all_box[6300],
		stream<Inlier_Output> & Inl_Out);

void Distribute_ObjectModel(u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX], ObjectName Obj_Under_Test,
		stream<Vertice> & Vertice_stream);
void Distribute_FT(stream<MatFT_Data_T> & FT_stream,
		stream<MatFT_Data_T> (&FT_stream_distr)[10]);
void Distribute_VT(stream<Vertice> & VT_stream, ObjectName Obj_Under_Test,
		stream<Vertice> (&VT_stream_distr)[10]);
template<int ID>

void Raster_core(stream<MatFT_Data_T> & FT_stream, ObjectName Obj_Under_Test,
		stream<Vertice> & Vertice_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<Depth_Data_T> & Depth_stream, stream<size_BB> & Size_BB_stream,
		stream<Raster_Core_Output> & Serial_weights);
void Insertion_sort(Center_SAMPLE Centre_ysorted[10], Center_SAMPLE new_Centre,
		u4_Data_T & actual_size);
void merge_row_indices(ap_uint<BIT_CENTRE> y_begin[10],
		ap_uint<BIT_CENTRE> y_final[10], ap_uint<10> ch_sel_begin[10],
		ap_uint<10> ch_sel_final[10], ap_uint<10> ch_selector[20],
		ap_uint<BIT_CENTRE> interval_list[20], u5_Data_T & real_size,
		u5_Data_T & final_real_size);
void merge_col_indices(ap_uint<2> col_interval_list_elem_numb[20],
		intervals col_interval_list[20][3], ap_uint<10> ch_selector[20],
		u5_Data_T & final_real_size, Center_SAMPLE Centre_ysorted[10]);
void Depth_distr(Depth_Data_T Depth_scene[480][640],
		stream<Center_SAMPLE> (&Center_SAMPLE_stream)[10],
		stream<Depth_Data_T> (&Depth)[10],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		BBOX all_box[6300], stream<size_BB> (&Size_BB_stream)[10]);

void weight_merger(stream<Raster_Core_Output> (&Serial_weights)[10],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		FS_W_fix_Data_T all_prob[6300], stream<Inlier_Output> & Inl_Out);
#endif
