#include "GRN.hpp"
/* MODEL 2 */
void LFSR01(stream<Usquare_Data_T> & U_square) {
	static u18_Data_T lfsr = 1786;
	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
#ifdef NDEBUG
	std::string fileFS = "U_square.txt";
	std::ofstream file(fileFS.c_str());
	file << "U_square = np.array([";
#endif
	for (u11_Data_T i = 0; i < Gauss_number_needed; i++) {
#pragma HLS PIPELINE II=1
		ap_uint<1> b_18 = lfsr.get_bit(18 - 18);
		ap_uint<1> b_11 = lfsr.get_bit(18 - 11);
		ap_uint<1> new_bit = b_18 ^ b_11;
		lfsr = lfsr >> 1;
		lfsr.set_bit(17, new_bit);

		ap_ufixed<18, 0> U18_fix;
		U18_fix.range(17, 0) = lfsr.range(17, 0);
		ap_ufixed<36, 0> result = U18_fix * U18_fix;
		Usquare_Data_T lfsr_f = result;
		U_square.write(lfsr_f);
#ifdef NDEBUG
		if (i < Gauss_number_needed - 1) {
			file << lfsr_f << ", ";
		} else {
			file << lfsr_f << "])" << std::endl;
		}
#endif
	}
#ifdef NDEBUG
	file.close();
#endif
}
void LFSR02pi(stream<angle_Data_T> & angle_stream) {
	static u15_Data_T lfsr = 11681;
#ifdef NDEBUG
	std::string fileFS = "angle_stream.txt";
	std::ofstream file(fileFS.c_str());
	file << "angle_stream = np.array([";
#endif
	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u11_Data_T i = 0; i < Gauss_number_needed; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_15 = lfsr.get_bit(15 - 15);
		u1_Data_T b_14 = lfsr.get_bit(15 - 14);
		u1_Data_T new_bit = b_15 ^ b_14;
		lfsr = lfsr >> 1;
		lfsr.set_bit(14, new_bit);
		ap_fixed<15, 1> rand_angle_temp;
		rand_angle_temp.range() = lfsr;
		angle_Data_T rand_angle_fill = (angle_Data_T) angle_Data_T(
				3.14159265359) * rand_angle_temp;
		angle_stream.write(rand_angle_fill);
#ifdef NDEBUG
		if (i < Gauss_number_needed - 1) {
			file << rand_angle_fill << ", ";
		} else {
			file << rand_angle_fill << "])" << std::endl;
		}
#endif
	}
#ifdef NDEBUG
	file.close();
#endif
}
void GRN(stream<Usquare_Data_T> & U_square, stream<angle_Data_T> & angle_stream,
		stream<Gauss_Data_T> & Gauss_number) {
#ifdef NDEBUG
	std::string fileU01_logs = "U01_log.txt";
	std::ofstream fileU01_log(fileU01_logs.c_str());
	fileU01_log << "U01_log = np.array([";

	std::string fileU01_log_radicals = "U01_log_radical.txt";
	std::ofstream fileU01_log_radical(fileU01_log_radicals.c_str());
	fileU01_log_radical << "U01_log_radical = np.array([";

	std::string fileU01_sins = "U01_sin.txt";
	std::ofstream fileU01_sin(fileU01_sins.c_str());
	fileU01_sin << "U01_sin = np.array([";

	std::string fileFS = "Gauss_number.txt";
	std::ofstream file(fileFS.c_str());
	file << "Gauss_number = np.array([";
#endif
	for (u11_Data_T i = 0; i < Gauss_number_needed; i++) {
		angle_Data_T angle_fill = angle_stream.read();
		ap_fixed<23, 5> U_square_fill = U_square.read();
		ap_fixed<23, 5> U01_log;
		if (U_square_fill != 0) {
			U01_log = hls::log(U_square_fill);
		} else {
			U01_log = 0;
		}
		ap_ufixed<18, 4> U01_fix = -U01_log;
		trigono_Data_T U01_sin = hls::sin(angle_fill);
		ap_ufixed<18, 4> U01_log_radical = hls::sqrt(U01_fix);
		ap_fixed<21, 4> Gauss_fill_h = U01_log_radical * U01_sin;
		Gauss_Data_T Gauss_fill = Gauss_fill_h;
		Gauss_number.write(Gauss_fill);
#ifdef NDEBUG
		if (i < Gauss_number_needed - 1) {
			fileU01_log << U01_log << ", ";
			fileU01_log_radical << U01_log_radical << ", ";
			fileU01_sin << U01_sin << ", ";
			file << Gauss_fill << ", ";
		} else {
			fileU01_log << U01_log << "])" << std::endl;
			fileU01_log_radical << U01_log_radical << "])" << std::endl;
			fileU01_sin << U01_sin << "])" << std::endl;
			file << Gauss_fill << "])" << std::endl;
		}
#endif
	}
#ifdef NDEBUG
	fileU01_log.close();
	fileU01_log_radical.close();
	fileU01_sin.close();
	file.close();
#endif
}

void Translate_Deviate(std_dev_Data_T & std_rot, std_dev_Data_T & std_pos,
		stream<Gauss_Data_T> & Gauss_number, stream<Gauss_Data_T> & G_Rand_pos,
		stream<Gauss_Data_T> & G_Rand_rot) {
#ifdef NDEBUG

	std::string fileFS_rot = "G_Rand_rot.txt";
		std::ofstream file_rot(fileFS_rot.c_str());
		file_rot << "G_Rand_rot = np.array([";

		std::string fileFS_pos = "G_Rand_pos.txt";
			std::ofstream file_pos(fileFS_pos.c_str());
			file_pos << "G_Rand_pos = np.array([";
#endif
	for (u11_Data_T i = 0; i < Gauss_number_needed; i++) {
		Gauss_Data_T G_fill = Gauss_number.read();
		Gauss_Data_T Gout_pos = G_fill * std_pos;
		G_Rand_pos.write(Gout_pos);
		Gauss_Data_T Gout_rot = G_fill * std_rot;
		G_Rand_rot.write(Gout_rot);
#ifdef NDEBUG
		if (i < Gauss_number_needed - 1) {
			file_rot << Gout_rot << ", ";
			file_pos << Gout_pos << ", ";
		} else {
			file_rot << Gout_rot << "])" << std::endl;
			file_pos << Gout_pos << "])" << std::endl;
		}
#endif
	}
#ifdef NDEBUG
	file_rot.close();
	file_pos.close();
#endif
}

void Box_muller(std_dev_Data_T std_rot, std_dev_Data_T std_pos,
		stream<Gauss_Data_T> & G_Rand_pos, stream<Gauss_Data_T> & G_Rand_rot) {

#pragma HLS DATAFLOW
	static stream<Usquare_Data_T> U_square("U_square");
#pragma HLS STREAM variable=U_square depth=1 dim=1
	static stream<angle_Data_T> angle_stream("angle_stream");
#pragma HLS STREAM variable=angle_stream depth=1 dim=1
	static stream<Gauss_Data_T> Gauss_number("Gauss_number");
#pragma HLS STREAM variable=Gauss_number depth=1 dim=1

	LFSR01(U_square);
	LFSR02pi(angle_stream);
	GRN(U_square, angle_stream, Gauss_number);
	Translate_Deviate(std_rot, std_pos, Gauss_number, G_Rand_pos, G_Rand_rot);
}

