#include "GenSample.hpp"
void Gen_Sample(stream<u13_Data_T> & sample_indx_stream,
		stream<angle_Data_T> & x_angle_stream,
		stream<angle_Data_T> & y_angle_stream,
		stream<angle_Data_T> & z_angle_stream,
		Mem_SAMPLE Samples[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		BBOX all_box[6300], Mem_Heuristic Heuristics[6300],
		stream<randZ01> & random_z01) {

	// NOW I LOAD THE NEW ADDRESS
	for (u10_Data_T y = 0; y < Num_Particles; y++) {
		u13_Data_T sample_indx_fill = sample_indx_stream.read();
		Sample_abs_indx[y] = sample_indx_fill;
		Sample_abs_indx_CPY[y] = sample_indx_fill;
		BBOX current_box = all_box[sample_indx_fill];
		ap_uint<BIT_CENTRE> y_px = current_box.y_centre_height.range(
		BIT_CENTRE + BIT_BB_IMG - 1, BIT_BB_IMG);
		ap_uint<BIT_CENTRE> x_px = current_box.x_centre_width.range(
		BIT_CENTRE + BIT_BB_IMG - 1, BIT_BB_IMG);
		ap_ufixed<18, 0> rand01 = random_z01.read();
		Mem_Heuristic curr_Heuristics = Heuristics[sample_indx_fill];
		if (current_box.y_centre_height.range(BIT_BB_IMG - 1, 0) > 200) {
			all_box[sample_indx_fill].y_centre_height.range(BIT_BB_IMG - 1, 0) =
					200;
		}
		if (current_box.x_centre_width.range(BIT_BB_IMG - 1, 0) > 200) {
			all_box[sample_indx_fill].x_centre_width.range(BIT_BB_IMG - 1, 0) =
					200;
		}

		Samples[y].x_S = (ap_fixed<18 + BIT_POSE_INT, BIT_POSE_INT + 1>(
				curr_Heuristics.x_min + curr_Heuristics.x_max) >> 1);
		Samples[y].y_S = (ap_fixed<18 + BIT_POSE_INT, BIT_POSE_INT + 1>(
				curr_Heuristics.y_min + curr_Heuristics.y_max) >> 1);
		Samples[y].z_S = (ap_fixed<18 + BIT_POSE_INT, BIT_POSE_INT + 1>(
				curr_Heuristics.z_min
						+ (curr_Heuristics.z_max - curr_Heuristics.z_min)
								* rand01));
		Samples[y].xroll_S = x_angle_stream.read();
		Samples[y].ypitch_S = y_angle_stream.read();
		Samples[y].zyaw_S = z_angle_stream.read();


//		std::cout << y << " " << sample_indx_fill << " " << Samples[y].x_S
//				<< " " << Samples[y].y_S << " " << Samples[y].z_S << " " << Samples[y].xroll_S
//				<< " " << Samples[y].ypitch_S << " " << Samples[y].zyaw_S << " " << x_px
//				<< " " << y_px << std::endl;
	}
}

void Angle_Genx(stream<angle_Data_T> & angle_stream) {

	static u15_Data_T lfsr = 6326;

	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < Num_Particles; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_15 = lfsr.get_bit(15 - 15);
		u1_Data_T b_14 = lfsr.get_bit(15 - 14);
		u1_Data_T new_bit = b_15 ^ b_14;
		lfsr = lfsr >> 1;
		lfsr.set_bit(14, new_bit);
		ap_fixed<15, 1> rand_angle_temp;
		rand_angle_temp.range() = lfsr;
		angle_Data_T rand_angle_fill = (angle_Data_T) angle_Data_T(
				3.14159265359) * rand_angle_temp;

		angle_stream.write(rand_angle_fill);
	}
}
void Angle_Geny(stream<angle_Data_T> & angle_stream) {

	static u15_Data_T lfsr = 30120;

	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < Num_Particles; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_15 = lfsr.get_bit(15 - 15);
		u1_Data_T b_14 = lfsr.get_bit(15 - 14);
		u1_Data_T new_bit = b_15 ^ b_14;
		lfsr = lfsr >> 1;
		lfsr.set_bit(14, new_bit);
		ap_fixed<15, 1> rand_angle_temp;
		rand_angle_temp.range() = lfsr;
		angle_Data_T rand_angle_fill = (angle_Data_T) angle_Data_T(
				3.14159265359) * rand_angle_temp;

		angle_stream.write(rand_angle_fill);
	}
}
void Angle_Genz(stream<angle_Data_T> & angle_stream) {

	static u15_Data_T lfsr = 18164;

	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < Num_Particles; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_15 = lfsr.get_bit(15 - 15);
		u1_Data_T b_14 = lfsr.get_bit(15 - 14);
		u1_Data_T new_bit = b_15 ^ b_14;
		lfsr = lfsr >> 1;
		lfsr.set_bit(14, new_bit);
		ap_fixed<15, 1> rand_angle_temp;
		rand_angle_temp.range() = lfsr;
		angle_Data_T rand_angle_fill = (angle_Data_T) angle_Data_T(
				3.14159265359) * rand_angle_temp;

		angle_stream.write(rand_angle_fill);
	}
}

void RandZ(stream<randZ01> & random_z01) {

	static u18_Data_T lfsr = 5275;

	//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < Num_Particles; i++) {
#pragma HLS PIPELINE II=1
		ap_uint<1> b_18 = lfsr.get_bit(18 - 18);
		ap_uint<1> b_11 = lfsr.get_bit(18 - 11);
		ap_uint<1> new_bit = b_18 ^ b_11;
		lfsr = lfsr >> 1;
		lfsr.set_bit(17, new_bit);

		randZ01 U18_fix;
		U18_fix.range(17, 0) = lfsr.range(17, 0);

		random_z01.write(U18_fix);
	}
}

