#include "Inlier.hpp"

void Inlier(Mem_SAMPLE Samples[NUM_PARTICLES],
		u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX], ObjectName Obj_Under_Test,
		Depth_Data_T Depth_scene[480][640],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		FS_W_fix_Data_T all_prob[6300], BBOX all_box[6300],
		weight_address_Data_T Resampled_Addresses[510], u18_Data_T rand_seed,
		Norm_weights_Data_T acc_norm_weights_[1200], Inlier_Output & winner) {
#pragma HLS DATAFLOW
	static hls::stream<MatFT_Data_T> FT_stream("FT STREAM");
#pragma HLS STREAM variable=FT_stream depth=1 dim=1
	static stream<Inlier_Output> Inl_Out("INLIER OUTPUT");
#pragma HLS STREAM variable=Inl_Out depth=1 dim=1

	std::cout << " FT" << std::endl;
	FT_Generator(Samples, FT_stream);

	std::cout << " GPU " << std::endl;
	GPU(Tri_Mem, V_Mem, Obj_Under_Test, FT_stream, Depth_scene, Sample_abs_indx,
			Sample_abs_indx_CPY, all_prob, all_box, Inl_Out);

	std::cout << " SCR " << std::endl;
	Module_SCR(Inl_Out, Resampled_Addresses, rand_seed, acc_norm_weights_,
			winner);

}
