
#include "LD_Obj.hpp"
/*
 *
 *This actually collect and streams the information about the object it self
 *
 */

void Load_ObjectModel(const volatile float * object_RAM,
		ObjectName Obj_Under_Test, u30_Data_T Tri_Mem[OBJMODEL_F_MAX],
		Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX]) {

	u2_Data_T ext_cnt = 0;
	u30_Data_T Tri_Mem_Fill;
	u11_Data_T address_cnt = 0;

	// ITS 30 BITS BECUASE I COMPRESS THE INFORMATION
	// Tri contain the information

#pragma HLS ARRAY_PARTITION variable=V_Mem complete dim=1
	Rast_FullBurst: for (u14_Data_T i = 0;
			i < 3 * Object_size_mem_[Obj_Under_Test]; i++) {
#pragma HLS PIPELINE II=1

		if (i == 3 * vertices_num_[Obj_Under_Test]) {
			address_cnt = 0;
		}
		if (i < 3 * vertices_num_[Obj_Under_Test]) {

			Vertice_Data_T ObjModel_Fill = object_RAM[i];

			switch (ext_cnt) {
			case 0:
				V_Mem[0][address_cnt] = ObjModel_Fill;
				ext_cnt++;
				break;
			case 1:
				V_Mem[1][address_cnt] = ObjModel_Fill;
				ext_cnt++;
				break;
			case 2:
				V_Mem[2][address_cnt] = ObjModel_Fill;
				address_cnt++;
				ext_cnt = 0;
				if (i == 3 * vertices_num_[Obj_Under_Test] - 1) {
					address_cnt = 0;
				}
				break;

			}
		} else {

			ap_uint<10> ObjModel_Fill_indx = object_RAM[i];

			switch (ext_cnt) {
			case 0:
				// DO THIS BECAUSE WE SAVE A BRAM! TWO INSTEAD OF 3
				// 3*10 or 2*30
				Tri_Mem_Fill.range(9, 0) = ObjModel_Fill_indx;
				ext_cnt++;
				break;
			case 1:
				Tri_Mem_Fill.range(19, 10) = ObjModel_Fill_indx;
				ext_cnt++;
				break;
			case 2:
				Tri_Mem_Fill.range(29, 20) = ObjModel_Fill_indx;
				Tri_Mem[address_cnt] = Tri_Mem_Fill;
				address_cnt++;
				ext_cnt = 0;
				break;
			}
		}
	}

#ifdef NDEBUG
	for (int x = 0; x < vertices_num_[Obj_Under_Test]; x++) {
		std::cout << "Vertex " << x << std::endl;

		std::cout << "X : " << V_Mem[0][x] << std::endl;
		std::cout << " Y : " << V_Mem[1][x] << std::endl;
		std::cout << " Z : " << V_Mem[2][x] << std::endl;
		std::cout << "---------------------------------" << std::endl;

	}
	for (int x = 0; x < tri_num_[Obj_Under_Test]; x++) {
		std::cout << "Triangle " << x << std::endl;
		std::cout << Tri_Mem[x].range(9, 0) << " ";
		std::cout << Tri_Mem[x].range(19, 10) << " ";
		std::cout << Tri_Mem[x].range(29, 20) << std::endl;
		std::cout << "---------------------------------" << std::endl;

	}

#endif

}
