#include "Post_inlier_CSNR.hpp"

void Module_SCR(hls::stream<Inlier_Output> & input_s,
		weight_address_Data_T Resampled_Addresses[510], u18_Data_T seed,
		Norm_weights_Data_T acc_norm_weights_[1200], Inlier_Output & winner) {

#pragma HLS INLINE
//array of stream declaration
#pragma HLS DATAFLOW
	static hls::stream<Struct_Sorter> Splitter2Sort("Splitter2Sort");
#pragma HLS STREAM variable=Splitter2Sort depth=1 dim=1

	static hls::stream<Struct_Sorter> BUS[9];
#pragma HLS ARRAY_PARTITION variable=BUS complete dim=1
#pragma HLS STREAM variable=BUS depth= 1 dim=1

	static hls::stream<FR_SUM_Data_T> Splitter2Div("Splitter2Div");
#pragma HLS STREAM variable=Splitter2Div depth=1 dim=1

	static hls::stream<Struct_Sorter> Sort2CSN("Sort2CSN");
#pragma HLS STREAM variable=Sort2CSN depth=1 dim=1

	static hls::stream<FR_Norm_Data_T> Div2CSN("Div2CSN");
#pragma HLS STREAM variable=Div2CSN depth=1 dim=1

	static hls::stream<Norm_weights_Data_T> CSN2Thr("CSN2Thr");
#pragma HLS STREAM variable=CSN2Thr depth=1 dim=1
	static hls::stream<weight_address_Data_T> CSN2Resample_addr(
			"CSN2Resample_addr");
#pragma HLS STREAM variable=CSN2Resample_addr depth=1 dim=1

	static hls::stream<Norm_weights_Data_T> Norm_weights_CPY;
#pragma HLS STREAM variable=Norm_weights_CPY depth=1 dim=1
	static hls::stream<THR_Resample_INFO_Data_T> THR_INFO;
#pragma HLS STREAM variable=THR_INFO depth=1 dim=1
	static hls::stream<BOUNDS_Resample_RAND_Data_T> Bounds_stream;
#pragma HLS STREAM variable=Bounds_stream depth=1 dim=1
	static hls::stream<u18_Data_T> RAND_stream;
#pragma HLS STREAM variable=RAND_stream depth=1 dim=1

	static stream<weight_address_Data_T> sample_indx_stream;
#pragma HLS STREAM variable=sample_indx_stream depth=1 dim=1

// Guarantee the single consumer dataflow constrain

	Splitter(input_s, Splitter2Sort, Splitter2Div); //,Splitter2Accum,Splitter2MaxTraker);

//___________________________________________________
// THIS IS THE FIRST LEVEL

	Divisor(Splitter2Div, Div2CSN);
	Sort<0>(Splitter2Sort, BUS[0]);
	Sort<1>(BUS[0], BUS[1]);
	Sort<2>(BUS[1], BUS[2]);
	Sort<3>(BUS[2], BUS[3]);
	Sort<4>(BUS[3], BUS[4]);
	Sort<5>(BUS[4], BUS[5]);
	Sort<6>(BUS[5], BUS[6]);
	Sort<7>(BUS[6], BUS[7]);
	Sort<8>(BUS[7], BUS[8]);
	Sort<9>(BUS[8], Sort2CSN);

	CSN(Sort2CSN, Div2CSN, CSN2Thr, CSN2Resample_addr, winner);
//	std::cout << " LFSR" << std::endl;
	LFSR18_AFT_INLIER(seed, RAND_stream);
//
//	std::cout << " THR" << std::endl;
	Thr_Analizer_inlier(CSN2Thr, Norm_weights_CPY, THR_INFO);
//
//	std::cout << " GEN_RANDBOUND" << std::endl;
	Init_gen_rand_bound_Inlier(THR_INFO, RAND_stream, Bounds_stream);
//
//	std::cout << " GEN INDX" << std::endl;
	Init_gen_sampleindx_aft_inlier(Norm_weights_CPY, Bounds_stream,
			Resampled_Addresses, CSN2Resample_addr, acc_norm_weights_);

}

void Splitter(hls::stream<Inlier_Output> & input,
		hls::stream<Struct_Sorter> & Splitter2Sort,
		hls::stream<FR_SUM_Data_T> & Splitter2Div) {

//#pragma HLS INTERFACE ap_ctrl_chain register port=return

	FR_SUM_Data_T full_res_sum = 0;
#ifdef NDEBUG
	std::string fileFS = "FS_Prob.txt";
	std::ofstream FS_PROB(fileFS.c_str());
	FS_PROB << "FS_Prob = np.array([";
#endif
	for (ap_uint<10> i = 0; i < 2 * Num_Particles; i++) {
#pragma HLS PIPELINE II=1

		Struct_Sorter Splitter2Sort_Fill;
		if (i < Num_Particles) {

			Inlier_Output input_fill;
//Blocking write command to inStream
			//Splitter2Div << Splitter2Div_Fill;
			input_fill = input.read();
			Splitter2Sort_Fill.flush = 0;

			weight_Data_T new_weight = input_fill.weight;

			Splitter2Sort_Fill.weight = input_fill.weight;
			Splitter2Sort_Fill.address = input_fill.address;
			if (i == 0) {
				full_res_sum = new_weight;
			} else {
				full_res_sum += new_weight;
			}
			Splitter2Sort << Splitter2Sort_Fill;

//			std::cout << "SPLITTER weight : " << Splitter2Sort_Fill.weight
//					<< std::endl;
//			std::cout << "SPLITTER full_res_sum : " << full_res_sum
//					<< std::endl;

#ifdef NDEBUG
			FS_PROB << Splitter2Sort_Fill.weight << ", ";
#endif
		} else {
			if (i == Num_Particles) {
#ifdef NDEBUG
				FS_PROB << Splitter2Sort_Fill.weight << "])" << std::endl;
				FS_PROB.close();
#endif
				Splitter2Sort_Fill.flush = 1;
				Splitter2Sort_Fill.weight = 0;
				Splitter2Sort_Fill.address = 0;
				Splitter2Div << full_res_sum;
			}

			Splitter2Sort << Splitter2Sort_Fill;

		}
	}
}

void Divisor(hls::stream<FR_SUM_Data_T> & Splitter2Div,
		hls::stream<FR_Norm_Data_T> & Div2CSN) {

	FR_SUM_Data_T Splitter2Div_Fill;

	Splitter2Div_Fill = Splitter2Div.read();

//	std::cout << "DIVISOR full_res_sum : " << Splitter2Div_Fill << std::endl;
	FR_SUM_RECIPR_Data_T reciprocal_FR = Splitter2Div_Fill;

	FR_SUM_RECIPR_Data_T reciprocal = hls::recip(reciprocal_FR);

//	std::cout << "DIVISOR reciprocal : " << reciprocal << std::endl;
	FR_Norm_Data_T Div2CSN_Fill = reciprocal;
	Div2CSN.write(Div2CSN_Fill);

}

/*
 * this is the last multiplexer
 * I do first because I know that the output can be only one of these
 * if the the last gtr is zero means that the input data is smaller
 * than the smallest of the set so I'll push it away
 *
 * this is the first multiplexer
 *			currWord    Stored[0]
 * 		  ____|_________|_____
 * 		  \   1  		0	 /-- gtr[0]
 * 		   \________________/
 * 		   		   |
 * 		   		new_v[0]
 * 			_______|______
 * 			|			 |
 * 			|			 |
 * 			|  Register  |
 * 			|	 [0]	 |
 * 			|			<|
 * 			|____________|
 * 				  |
 * 			   stored[0]
 *
 *
 *
 * this is the i basecell
 *
 * 	currWord    	Stored[i]
 * 		  ____|_________|_____
 * 		  \   1  		0	 /-- gtr[i]
 * 		   \________________/
 * 		   			|
 * 		   	  ______|
 * 		   	  |
 * 		   	  |		currWord    Stored[i-1]
 * 		  ____|_________|_____
 * 		  \   0  		1	 /-- gtr[i-1]
 * 		   \________________/
 * 		   		   |
 * 		   		new_v[i]
 * 			_______|______
 * 			|			 |
 * 			|			 |
 * 			|  Register  |
 * 			|	 [i]	 |
 * 			|			<|
 * 			|____________|
 * 				  |
 * 			   stored[i]
 *
 *
 *
 * If the input is not larger than the biggest
 * evaluate which part of the chain I have to move
 * if you are here gtr[Elem_Numb - 1] == 1
 */
template<int ID>

void Sort(hls::stream<Struct_Sorter> &Input,
		hls::stream<Struct_Sorter> &Output) {

	ap_uint<1> gtr[Elem_Numb];
#pragma HLS ARRAY_PARTITION variable=gtr complete dim=1

	static Inlier_Output stored[Elem_Numb] = { 0, 0 };
#pragma HLS ARRAY_PARTITION variable=stored complete dim=1

	for (ap_uint<10> i = 0; i < 2 * Num_Particles; i++) {
//#pragma HLS PIPELINE II=1

// Blocking read for the input

		Struct_Sorter outFill;
		Struct_Sorter currWord;
		weight_Data_T value;
		Input.read(currWord);

		// extract the value of the input that will be used after
		value = currWord.weight;

		/* LAST ONE
		 * if we are not in flush condition we must evaluate all the comparisons
		 *
		 *			currWord    Stored[Elem_Numb-1]
		 * 		   ____|_________|____
		 * 		   \   0  		 1	 /-- (gtr[Elem_Numb - 1])
		 * 		    \_______________/
		 * 		   			|
		 * 		   		new_v[Elem_numb]
		 *
		 * output = new_v[Elem_numb] to the fifo // if the input is the smallest it goes out
		 * knowing the flush we already know ho will be the output
		 */

		outFill.flush = currWord.flush;

		gtr[Elem_Numb - 1] = (value >= stored[Elem_Numb - 1].weight);

		gtr[Elem_Numb - 1] = (gtr[Elem_Numb - 1] || currWord.flush);
		// if the new value is higher than the smallest or we are in flush
		// the smallest element must shift
		// otherwise skip the module
		if (gtr[Elem_Numb - 1]) {
			outFill.weight = stored[Elem_Numb - 1].weight;
			outFill.address = stored[Elem_Numb - 1].address;
		} else {

			outFill.weight = currWord.weight;
			outFill.address = currWord.address;
		}

		Output.write(outFill);
		for (ap_uint<Bit_counters_Sort_cell> index = Elem_Numb - 1; index > 0;
				index--) {
#pragma HLS UNROLL
			gtr[index - 1] = (value >= stored[index - 1].weight);

			gtr[index - 1] = (gtr[index - 1] || currWord.flush);
			if (gtr[index - 1]) {
				stored[index] = stored[index - 1];

			} else if (gtr[index]) {
				stored[index].weight = currWord.weight;
				stored[index].address = currWord.address;
			}
		}
		if (gtr[0]) {
			stored[0].weight = currWord.weight;
			stored[0].address = currWord.address;
		}

	}
}

void CSN(hls::stream<Struct_Sorter> & Sort2CSN,
		hls::stream<FR_Norm_Data_T> & Div2CSN,
		hls::stream<Norm_weights_Data_T> & CSN2Thr,
		hls::stream<weight_address_Data_T> & CSN2Resample_addr,
		Inlier_Output & winner) {
#ifdef  NDEBUG
	std::string fileFS = "Sorted.txt";
	std::ofstream Sorted(fileFS.c_str());
	Sorted << "Sorted = np.array([";
#endif
	Struct_Sorter Sort_in;
	FR_SUM_Data_T full_res_sum = 0;
	FR_Norm_Data_T Norm_Factor;
	FR_WN_Data_T MaxPrecisionMULT;
	for (ap_uint<10> i = 0; i < 2 * Num_Particles; i++) {
#pragma HLS PIPELINE II=1

		Sort2CSN.read(Sort_in);

		if (i >= Num_Particles) {

			if (i == Num_Particles) {
				Div2CSN.read(Norm_Factor);

			}

			weight_Data_T new_weight = Sort_in.weight;
//			std::cout << " new_weight" << new_weight << std::endl << " address "
//					<< Sort_in.address << std::endl;
			CSN2Resample_addr.write(Sort_in.address);
			if (i == 0) {
				full_res_sum = new_weight;
			} else {
				full_res_sum += new_weight;
			}
			if (i == 2 * Num_Particles - 1) {
				winner.address = Sort_in.address;
				winner.weight = new_weight;

			}

#ifdef NDEBUG
			if (i < 2 * NUM_PARTICLES - 1) {
				Sorted << new_weight << ", ";
			} else {
				Sorted << new_weight << "])" << std::endl;
			}
#endif
//
//			std::cout << " Norm_Factor : " << Norm_Factor << std::endl;
//			std::cout << " full_res_sum : " << full_res_sum << std::endl;
			Norm_weights_Data_T weights2nsgen_fill;

			MaxPrecisionMULT = (Norm_Factor * full_res_sum);

			if (i == 2 * Num_Particles - 1) {
				weights2nsgen_fill.range(BIT_WEIGHT_NORM - 1, 0) =
				ONE_TRUNC_INIT;	// set to one
			} else {
				weights2nsgen_fill = MaxPrecisionMULT;
			}

//			std::cout << " weights2nsgen_fill : " << weights2nsgen_fill
//					<< std::endl << std::endl;
			CSN2Thr.write(weights2nsgen_fill);
		}
	}
#ifdef NDEBUG
	Sorted.close();
#endif
}

void Thr_Analizer_inlier(stream<Norm_weights_Data_T> & Norm_weights,
		stream<Norm_weights_Data_T> & Norm_weights_out,
		stream<THR_Resample_INFO_Data_T> & THR_INFO) {

	THR_Data_T past_thr = 0;
	THR_P_Data_T Sent_cnt = 0;
	Init_wr_weights: for (u10_Data_T norm_ind = 0; norm_ind < Num_Particles;
			norm_ind++) {
#pragma HLS PIPELINE II=1
		Norm_weights_Data_T weights2nsgen_fill;

		// Just copy temporary the information
		Norm_weights.read(weights2nsgen_fill);
		Norm_weights_out.write(weights2nsgen_fill);

		THR_Data_T curr_thr = weights2nsgen_fill.range(BIT_WEIGHT_NORM - 1,
		BIT_WEIGHT_NORM - BIT_THR);
		if (curr_thr - past_thr >= 1) {

			// AGGIUNGI UN COUNTER DI QUANTI THR HAI COSI"' SE PER CASO SONO TROPPI
			// POCHI LO DICI AL PROSSIMO MODULO
			THR_Resample_INFO_Data_T THR_INFO_fill = curr_thr.concat(norm_ind);
			THR_INFO.write(THR_INFO_fill);
			past_thr = curr_thr;
			Sent_cnt++;
		}

	}

	for (; Sent_cnt < SIZE_ARR_THR; Sent_cnt++) {
#pragma HLS PIPELINE II=1
#pragma HLS LOOP_TRIPCOUNT min=1 max=32 avg=16
		THR_INFO.write(0);
	}

}

/*
 *
 * LFSR18 ( 5.0 )
 *
 */

void LFSR18_AFT_INLIER(u18_Data_T & seed, stream<u18_Data_T> & RAND_stream) {
	u18_Data_T lfsr;
	if (seed == 0) {
		lfsr = 6326;
	} else {
		lfsr = seed;
	}
#ifdef  NDEBUG
	std::string fileFS = "RAND_NUMBERS.txt";
	std::ofstream RAND_NUMBERS(fileFS.c_str());
	RAND_NUMBERS << "RAND_NUMBERS = np.array([";
#endif
//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < NUM_PARTICLES - 1; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_18 = lfsr.get_bit(18 - 18);
		u1_Data_T b_11 = lfsr.get_bit(18 - 11);
		u1_Data_T new_bit = b_18 ^ b_11;
		lfsr = lfsr >> 1;
		lfsr.set_bit(17, new_bit);
		RAND_stream.write(lfsr);
#ifdef NDEBUG
		if (i < NUM_PARTICLES - 2) {
			ap_ufixed<18, 0> temp;
			temp.range() = lfsr;
			RAND_NUMBERS << temp << ", ";
		} else {
			ap_ufixed<18, 0> temp;
			temp.range() = lfsr;
			RAND_NUMBERS << temp << "])" << std::endl;
		}
#endif

	}
#ifdef NDEBUG
	RAND_NUMBERS.close();
#endif

}

/*
 *
 * Init_gen_rand_bound ( 5.1 )
 *
 */

void Init_gen_rand_bound_Inlier(stream<THR_Resample_INFO_Data_T> & THR_INFO,
		stream<u18_Data_T> & RAND_stream,
		stream<BOUNDS_Resample_RAND_Data_T> & Bounds_stream) {

	// CURRENT THR concat to the address  ( 5 + 13 )
	THR_Resample_INFO_Data_T thr_array[SIZE_ARR_THR];
#pragma HLS ARRAY_PARTITION variable=thr_array cyclic factor=2 dim=1

	THR_P_Data_T zero_thr_counter;
	for (THR_P_Data_T counter = 0; counter < SIZE_ARR_THR; counter++) {
#pragma HLS PIPELINE II=1
		THR_Resample_INFO_Data_T THR_INFO_fill;
		THR_INFO.read(THR_INFO_fill);
		thr_array[counter] = THR_INFO_fill;
		// THE FIRST THR CAN HAPPEN IN THE ZERO POSITION BUT NOT THE ZERO THR
		if (counter == 0) {
			zero_thr_counter = 0;
		} else if (!THR_INFO_fill.or_reduce()) { // THIS IS THE CONDITION TO MARK
			zero_thr_counter++;
		}

	}
#ifdef NDEBUG
	std::string thr_value_s = "thr_value.txt";
	std::ofstream thr_value(thr_value_s.c_str());
	thr_value << "thr_value = np.array([";
	for (int index = 0; index < SIZE_ARR_THR; index++) {
		if (index < SIZE_ARR_THR - 1) {
			ap_ufixed<BIT_THR, 0> temp;
			temp.range() = thr_array[index].range(
			15 - 1,
			15 - BIT_THR);
			thr_value << temp << ", ";
		} else {
			ap_ufixed<BIT_THR, 0> temp;
			temp.range() = thr_array[index].range(
			15 - 1,
			15 - BIT_THR);
			thr_value << temp << "])" << std::endl;
		}
	}
	thr_value.close();

	std::string thr_index_s = "thr_index.txt";
	std::ofstream thr_index(thr_index_s.c_str());
	thr_index << "thr_index = np.array([";
	for (int index = 0; index < SIZE_ARR_THR; index++) {
		if (index < SIZE_ARR_THR - 1) {
			thr_index << thr_array[index].range(9, 0) << ", ";
		} else {
			thr_index << thr_array[index].range(9, 0) << "])"
					<< std::endl;
		}
	}
	thr_index.close();
#endif
	Init_new_sampl_generation: for (u10_Data_T i = 0; i < NUM_PARTICLES - 1;
			i++) {
#pragma HLS PIPELINE II=1

		u18_Data_T rand_numb_fill;
		u13_Data_T bottom_stream_fill;
		u13_Data_T top_stream_fill;
		rand_numb_fill = RAND_stream.read();

		THR_Data_T thr_local = rand_numb_fill.range(BIT_WEIGHT_NORM - 1,
		BIT_WEIGHT_NORM - BIT_THR);
		if (!thr_local.or_reduce()) { // this fix the lower intervall
			bottom_stream_fill = 0;
			top_stream_fill = thr_array[0].range(10 - 1, 0);
		} else if (thr_local == 31) { // this fix the upper intervall
			bottom_stream_fill =
					thr_array[SIZE_ARR_THR - 1 - zero_thr_counter].range(
					10 - 1, 0); //from 31 downto
			top_stream_fill = NUM_PARTICLES - 1;
		} else {

			Init_gen_rand_bound_trk: for (THR_P_Data_T counter = 2;
					counter < SIZE_ARR_THR; counter++) {
#pragma HLS UNROLL
				THR_INFO_Data_T temporaneo_Prec = thr_array[counter - 1];
				THR_INFO_Data_T temporaneo_act = thr_array[counter];
				if (thr_local < temporaneo_act.range(BIT_THR + 10 - 1,
				10)) {

					bottom_stream_fill = temporaneo_Prec.range(
					10 - 1, 0);
					top_stream_fill = temporaneo_act.range(
					10 - 1, 0);
					break;
				} else if (counter == SIZE_ARR_THR - zero_thr_counter - 1) {
					break;
				}

			}
		}

		BOUNDS_Resample_RAND_Data_T FIll;
		FIll.range(BIT_RANDOM_NUMBER + 10 + 10 - 1,
		BIT_RANDOM_NUMBER + 10) = top_stream_fill;
		FIll.range(BIT_RANDOM_NUMBER + 10 - 1, BIT_RANDOM_NUMBER) =
				bottom_stream_fill;
		FIll.range(BIT_RANDOM_NUMBER - 1, 0) = rand_numb_fill;
		Bounds_stream.write(FIll);
	}

}

/*
 *
 * Init_gen_sampleindx ( 5.2 )
 *
 */

void Init_gen_sampleindx_aft_inlier(stream<Norm_weights_Data_T> & Norm_weights,
		stream<BOUNDS_Resample_RAND_Data_T> & Bounds_stream,
		weight_address_Data_T Resampled_Addresses[510],
		hls::stream<weight_address_Data_T> & CSN2Resample_addr,
		Norm_weights_Data_T acc_norm_weights_[6300]) {

	u10_Data_T saver_counter = 0;
	Init_wr_weights: for (u13_Data_T norm_ind = 0; norm_ind < Num_Particles;
			norm_ind++) {

#pragma HLS PIPELINE II=1

		Norm_weights_Data_T Norm_weights_fill;
		Norm_weights.read(Norm_weights_fill);
		weight_address_Data_T Address;
		CSN2Resample_addr.read(Address);
		acc_norm_weights_[norm_ind] = Norm_weights_fill;
		acc_norm_weights_[norm_ind + Num_Particles].range(BIT_ADDRESS - 1, 0) =
				Address;

	}
#ifdef NDEBUG
	std::string fileFS = "CSN.txt";
	std::ofstream CSN(fileFS.c_str());
	CSN << "CSN = np.array([";
	for (int index = 0; index < NUM_PARTICLES; index++) {
		if (index < NUM_PARTICLES - 1) {
			CSN << acc_norm_weights_[index] << ", ";
		} else {
			CSN << acc_norm_weights_[index] << "])" << std::endl;
		}
	}
	CSN.close();
	std::string Sampl_indx_s = "Sampl_indx.txt";
	std::ofstream Sampl_indx(Sampl_indx_s.c_str());
	Sampl_indx << "Sampl_indx = np.array([";
#endif

	Init_new_sampl_generation: for (u10_Data_T i = 0; i < NUM_PARTICLES - 1;
			i++) {
		BOUNDS_Resample_RAND_Data_T Bounds_stream_fill;
		Bounds_stream.read(Bounds_stream_fill);

		ap_uint<10> TOP = Bounds_stream_fill.range(
		BIT_RANDOM_NUMBER + 10 + 10 - 1,
		BIT_RANDOM_NUMBER + 10);
		ap_uint<10> BOTTOM = Bounds_stream_fill.range(
		BIT_RANDOM_NUMBER + 10 - 1, BIT_RANDOM_NUMBER);
		ap_ufixed<BIT_RANDOM_NUMBER, 0> RAND;
		RAND.range() = Bounds_stream_fill.range(BIT_RANDOM_NUMBER - 1, 0);

// To reduce the loop iterations from NUM_PARTICLES to NUM_PARTICLES/4
		for (u13_Data_T index = BOTTOM; index <= TOP; index++) {
#pragma HLS PIPELINE II=1
#pragma HLS LOOP_TRIPCOUNT min=1 max=1200 avg=16

			Norm_weights_Data_T temp_value = acc_norm_weights_[index];
			if (temp_value >= RAND) {
				Resampled_Addresses[saver_counter] = acc_norm_weights_[index
						+ Num_Particles].range(BIT_ADDRESS - 1, 0);
				saver_counter++;
#ifdef NDEBUG
				Sampl_indx << acc_norm_weights_[index + Num_Particles].range(
				BIT_ADDRESS - 1, 0) << ", ";

#endif
				break;
			}
		}
	}

	weight_address_Data_T Address_out = acc_norm_weights_[1019].range(
	BIT_ADDRESS - 1, 0);

	for (; saver_counter < NUM_PARTICLES; saver_counter++) {
		Resampled_Addresses[saver_counter] = Address_out;
#ifdef NDEBUG
		Sampl_indx << acc_norm_weights_[1019].range(BIT_ADDRESS - 1, 0) << "])"
				<< std::endl;
#endif
	}

#ifdef NDEBUG

	Sampl_indx.close();
#endif
}

