#include"Raster_core.hpp"

void RC_FT_Storing(stream<MatFT_Data_T> & FT_stream_distr,
		stream<MatFT_Data_T> (&FT_stream_SEQ)[M_DIM][M_DIM]) {

	MatFT_Data_T FT_local[51][M_DIM][M_DIM];

	for (u10_Data_T index_flat = 0; index_flat < FT_STREAM_DEPTH;
			index_flat++) { // FT_STREAM_DEPTH = NUM_PARTICLES/NUM_RENDER_STG*4*4 = 816

#pragma HLS PIPELINE II=1

		MatFT_Data_T FT_stream_fill = FT_stream_distr.read();
		FT_local[index_flat.range(9, 4)][index_flat.range(3, 2)][index_flat.range(
				1, 0)] = FT_stream_fill;
		if (index_flat == 15) { // this check if the 4 lsb are equal to 15
			FT_stream_SEQ[0][0].write(FT_local[0][0][0]); // only one time index_flat==16
			FT_stream_SEQ[0][1].write(FT_local[0][0][1]); // only one time index_flat==16
			FT_stream_SEQ[0][2].write(FT_local[0][0][2]); // only one time index_flat==16
			FT_stream_SEQ[0][3].write(FT_local[0][0][3]); // only one time index_flat==16

			FT_stream_SEQ[1][0].write(FT_local[0][1][0]); // only one time index_flat==16
			FT_stream_SEQ[1][1].write(FT_local[0][1][1]); // only one time index_flat==16
			FT_stream_SEQ[1][2].write(FT_local[0][1][2]); // only one time index_flat==16
			FT_stream_SEQ[1][3].write(FT_local[0][1][3]); // only one time index_flat==16

			FT_stream_SEQ[2][0].write(FT_local[0][2][0]); // only one time index_flat==16
			FT_stream_SEQ[2][1].write(FT_local[0][2][1]); // only one time index_flat==16
			FT_stream_SEQ[2][2].write(FT_local[0][2][2]); // only one time index_flat==16
			FT_stream_SEQ[2][3].write(FT_local[0][2][3]); // only one time index_flat==16
			FT_stream_SEQ[3][0].write(FT_local[0][3][0]); // only one time index_flat==16
			FT_stream_SEQ[3][1].write(FT_local[0][3][1]); // only one time index_flat==16
			FT_stream_SEQ[3][2].write(FT_local[0][3][2]); // only one time index_flat==16
			FT_stream_SEQ[3][3].write(FT_stream_fill); // only one time index_flat==16
		}

	}
	_Distr_rest_FT: for (u6_Data_T counter_Transm = 1;
			counter_Transm < Num_sample_x_raster_core; counter_Transm++) {
#pragma HLS PIPELINE II=1
		FT_stream_SEQ[0][0].write(FT_local[counter_Transm][0][0]);
		FT_stream_SEQ[0][1].write(FT_local[counter_Transm][0][1]);
		FT_stream_SEQ[0][2].write(FT_local[counter_Transm][0][2]);
		FT_stream_SEQ[0][3].write(FT_local[counter_Transm][0][3]);

		FT_stream_SEQ[1][0].write(FT_local[counter_Transm][1][0]);
		FT_stream_SEQ[1][1].write(FT_local[counter_Transm][1][1]);
		FT_stream_SEQ[1][2].write(FT_local[counter_Transm][1][2]);
		FT_stream_SEQ[1][3].write(FT_local[counter_Transm][1][3]);

		FT_stream_SEQ[2][0].write(FT_local[counter_Transm][2][0]);
		FT_stream_SEQ[2][1].write(FT_local[counter_Transm][2][1]);
		FT_stream_SEQ[2][2].write(FT_local[counter_Transm][2][2]);
		FT_stream_SEQ[2][3].write(FT_local[counter_Transm][2][3]);

		FT_stream_SEQ[3][0].write(FT_local[counter_Transm][3][0]);
		FT_stream_SEQ[3][1].write(FT_local[counter_Transm][3][1]);
		FT_stream_SEQ[3][2].write(FT_local[counter_Transm][3][2]);
		FT_stream_SEQ[3][3].write(FT_local[counter_Transm][3][3]);
	}

#ifdef NDEBUG
	for (u10_Data_T counter_Transm = 0;
			counter_Transm < Num_sample_x_raster_core; counter_Transm++) {
		std::cout << "FT : " << counter_Transm << std::endl;
		for (int row = 0; row < 4; row++) {
			std::cout << "| ";
			for (int col = 0; col < 4; col++) {
				std::cout << FT_local[counter_Transm][row][col] << ", ";
			}

			std::cout << " |" << std::endl;
		}

	}
#endif
}

void Vector_Transformation(stream<MatFT_Data_T> (&FT_stream_SEQ)[M_DIM][M_DIM],
		ObjectName Obj_Under_Test, stream<Vertice> & Vertice_stream,
		stream<Vec_4D_Data_T> & V_w_stream,
		stream<Vec_4D_Data_T> & V_xyz_stream) {
	Vertice Vert;
	u3_Data_T counter_case = 0;
	for (u6_Data_T ft_cnt = 0; ft_cnt < Num_sample_x_raster_core; ft_cnt++) {

		MatFT_Data_T FT_current[M_DIM][M_DIM];

		FT_stream_SEQ[0][0].read(FT_current[0][0]);
		FT_stream_SEQ[0][1].read(FT_current[0][1]);
		FT_stream_SEQ[0][2].read(FT_current[0][2]);
		FT_stream_SEQ[0][3].read(FT_current[0][3]);
		FT_stream_SEQ[1][0].read(FT_current[1][0]);
		FT_stream_SEQ[1][1].read(FT_current[1][1]);
		FT_stream_SEQ[1][2].read(FT_current[1][2]);
		FT_stream_SEQ[1][3].read(FT_current[1][3]);
		FT_stream_SEQ[2][0].read(FT_current[2][0]);
		FT_stream_SEQ[2][1].read(FT_current[2][1]);
		FT_stream_SEQ[2][2].read(FT_current[2][2]);
		FT_stream_SEQ[2][3].read(FT_current[2][3]);
		FT_stream_SEQ[3][0].read(FT_current[3][0]);
		FT_stream_SEQ[3][1].read(FT_current[3][1]);
		FT_stream_SEQ[3][2].read(FT_current[3][2]);
		FT_stream_SEQ[3][3].read(FT_current[3][3]);

#ifdef NDEBUG

		std::cout << "FT : " << ft_cnt << std::endl;
		for (int row = 0; row < 4; row++) {
			std::cout << "| ";
			for (int col = 0; col < 4; col++) {
				std::cout << FT_current[row][col] << ", ";
			}

			std::cout << " |" << std::endl;
		}

#endif

		// THIS IS THE LOOP FOR EACH FT
		// FOR EACH FACE -> EACH FACE
		flat_loop: for (u15_Data_T x = 0;
				x < (tri_num_[Obj_Under_Test] * 3 * 4); x++) {
#pragma HLS PIPELINE

			FR_Vec_4D_Data_T Vec_4D_fill;

			// process w x y z  to reduce the fifo depth of the division

			switch (counter_case) {
			case 0:
				// THIS IS W
				Vert = Vertice_stream.read(); // load one verice at time
				Vec_4D_fill = FT_current[3][0] * Vert.x
						+ FT_current[3][1] * Vert.y + FT_current[3][2] * Vert.z
						+ FT_current[3][3];
				counter_case = 1;
				V_w_stream.write(Vec_4D_fill);
				break;
			case 1:
				// THIS is x
				Vec_4D_fill = FT_current[0][0] * Vert.x
						+ FT_current[0][1] * Vert.y + FT_current[0][2] * Vert.z
						+ FT_current[0][3];
				counter_case = 2;
				V_xyz_stream.write(Vec_4D_fill);
				break;
			case 2:
				//THIS IS y
				Vec_4D_fill = FT_current[1][0] * Vert.x
						+ FT_current[1][1] * Vert.y + FT_current[1][2] * Vert.z
						+ FT_current[1][3];
				counter_case = 3;
				V_xyz_stream.write(Vec_4D_fill);
				break;
			case 3:
				//THIS IS Z
				Vec_4D_fill = FT_current[2][0] * Vert.x
						+ FT_current[2][1] * Vert.y + FT_current[2][2] * Vert.z
						+ FT_current[2][3];
				counter_case = 0;
				V_xyz_stream.write(Vec_4D_fill);
				break;
			}

		}
	}
}

void reciprocal(stream<Vec_4D_Data_T> & V_w_stream, ObjectName Obj_Under_Test,
		stream<V_w_rec_Data_T> & V_w_recipr_stream) {
	//w must be evaluated for all the 3 point in the vert
	flat_loop: for (u19_Data_T x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_raster_core_tri); x++) {
#pragma HLS PIPELINE
		Vec_4D_Data_T V_w_fill;
		V_w_fill = V_w_stream.read();
		V_w_rec_full_Data_T w_rec = V_w_fill;
		w_rec = hls::recip(w_rec);
		V_w_rec_Data_T out_fill = w_rec;
		V_w_recipr_stream.write(out_fill);

#ifdef NDEBUG

		std::cout << "Input w " << V_w_fill << std::endl;
		std::cout << "1/w fp " << w_rec << std::endl;
		std::cout << "1/w fp trunc " << out_fill << std::endl;
		std::cout << "1/w float " << 1.0 / V_w_fill.to_float() << std::endl;

#endif

	}

}

void Vector_normalisation(stream<Vec_4D_Data_T> & V_xyz_stream,
		ObjectName Obj_Under_Test, stream<V_w_rec_Data_T> & V_w_recipr_stream,
		stream<Vertice_final> & Vertice_final_stream) {

	u3_Data_T counter_case = 0;
	V_w_rec_Data_T w_norm_fill;

	Vertice_final Vertix;

	// THE ORDER  is x y z

	Vec_4D_Data_T V_xyz_fill;
	FRV_final_Data_T V_zyx_current;

	V_final_Data_T V_zyx_current_tru;

	flat_loop: for (u20_Data_T x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_raster_core_tri * 3); x++) {

#pragma HLS LOOP_TRIPCOUNT min=918000 max=918000 avg=918000

		// THE BODY PROCESS Oss_allY ONE VERTICE
		// NEEDS TREE CYCLES TO HAVE HA FACE
#pragma HLS PIPELINE

		switch (counter_case) {
		case 0:
			w_norm_fill = V_w_recipr_stream.read();
			V_xyz_fill = V_xyz_stream.read();
			V_zyx_current = V_xyz_fill * w_norm_fill;
			V_zyx_current_tru = V_zyx_current;
			Vertix.x_px = WIDTH_HALF * (1 + V_zyx_current_tru);
			counter_case = 1;
			break;
		case 1:
			V_xyz_fill = V_xyz_stream.read();
			V_zyx_current = V_xyz_fill * w_norm_fill;
			V_zyx_current_tru = V_zyx_current;
			Vertix.y_px = HEIGHT_HALF * (1 - V_zyx_current_tru);
			counter_case = 2;
			break;
		case 2:
			V_xyz_fill = V_xyz_stream.read();
			V_zyx_current = V_xyz_fill * w_norm_fill;
			V_zyx_current_tru = V_zyx_current;
			Vertix.z = V_zyx_current_tru;
			Vertice_final_stream.write(Vertix);
			counter_case = 0;
			break;
		}
	}
}

void Vector_Z_recover(stream<Vertice_final> & Vertice_final_stream,
		ObjectName Obj_Under_Test,
		stream<Vertice_final> & Vertice_z_correct_stream) {
	flat_loop: for (u19_Data_T x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_raster_core_tri); x++) {
#pragma HLS PIPELINE
		Vertice_final corrected_Vector;
		Vertice_final curr_Vert = Vertice_final_stream.read();
		Vz_T_Data_T real_z = (ap_ufixed<12 + 8, 8>(200.0)
				/ (ap_ufixed<12 + 10, 10>(1000.1)
						- curr_Vert.z * ap_ufixed<12 + 10, 10>(999.9)));
		corrected_Vector.x_px = curr_Vert.x_px;
		corrected_Vector.y_px = curr_Vert.y_px;
		corrected_Vector.z = real_z;
		Vertice_z_correct_stream.write(corrected_Vector);
	}
}

// find the min from 3 integers
bound_Data_T find_min(Vxy_T_Data_T & in0, Vxy_T_Data_T & in1,
		Vxy_T_Data_T & in2, u2_Data_T & V_min) {
#pragma HLS INLINE
	if (in0 < in1) {
		if (in0 < in2) {
			V_min = 0;
			return in0;
		} else {
			V_min = 2;
			return in2;
		}
	} else {
		if (in1 < in2) {
			V_min = 1;
			return in1;
		} else {
			V_min = 2;
			return in2;
		}
	}
}

// find the max from 3 integers
bound_Data_T find_max(Vxy_T_Data_T & in0, Vxy_T_Data_T & in1,
		Vxy_T_Data_T & in2, u2_Data_T & V_max) {
#pragma HLS INLINE
	if (in0 > in1) {
		if (in0 > in2) {
			V_max = 0;
			return in0;
		} else {
			return in2;
		}
	} else {
		if (in1 > in2) {
			V_max = 1;
			return in1;
		} else {
			V_max = 2;
			return in2;
		}
	}
}

void triangle_set(stream<Vertice_final> & Vertice_final_stream,
		ObjectName Obj_Under_Test, stream<Vec_Norm_Data_T> & Area_stream,
		stream<Depth_Non_Norm_Data_T> & z_stream,
		stream<position> &index_stream, stream<u2_Data_T> & comand_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream_tri,
		stream<size_BB> & Size_BB_stream_tri) {
// respect to the axis
// forward is ---> (go to the next)
// backward is <--- (go to the previous)

	intervals row_BB;
	intervals col_BB;
	size_BB current_Size_BB;
	Center_SAMPLE current_Centre_SAMPLE;

	flat_loop: for (u17_Data_T x = 0;
			x < (tri_num_[Obj_Under_Test] * Num_sample_x_raster_core); x++) {

		if (x % (tri_num_[Obj_Under_Test]) == 0) {

			current_Size_BB = Size_BB_stream_tri.read();
			current_Centre_SAMPLE = Center_SAMPLE_stream_tri.read();

			col_BB.min = current_Centre_SAMPLE.x_px_centre
					- (current_Size_BB.width >> 1);
			col_BB.max = current_Centre_SAMPLE.x_px_centre
					+ (current_Size_BB.width >> 1);

			row_BB.min = current_Centre_SAMPLE.y_px_centre
					- (current_Size_BB.height >> 1);
			row_BB.max = current_Centre_SAMPLE.y_px_centre
					+ (current_Size_BB.height >> 1);
		}

		Vertice_final V[3];

		V[0] = Vertice_final_stream.read();

		V[1] = Vertice_final_stream.read();

		V[2] = Vertice_final_stream.read();

		/// RASTER STANDARD
		u2_Data_T V_col_min;
		Vec_delta_Data_T dX_2_1 = V[2].x_px - V[1].x_px;
		Vec_delta_Data_T dY_2_1 = V[2].y_px - V[1].y_px;

		u2_Data_T V_col_max;
		u2_Data_T V_row_min;
		u2_Data_T V_row_max;

		bound_Data_T col_min = find_min(V[0].x_px, V[1].x_px, V[2].x_px,
				V_col_min);
		bound_Data_T col_max = find_max(V[0].x_px, V[1].x_px, V[2].x_px,
				V_col_max);
		bound_Data_T row_min = find_min(V[0].y_px, V[1].y_px, V[2].y_px,
				V_row_min);
		bound_Data_T row_max = find_max(V[0].y_px, V[1].y_px, V[2].y_px,
				V_row_max);

		// check if all of the triangle is outside the boundaries
		if (col_max >= WIDTH || row_max >= HEIGHT || col_max < 0 || row_max < 0
				|| col_min >= WIDTH || row_min >= HEIGHT || row_min < 0
				|| col_min < 0 || col_max < col_BB.min || row_max < row_BB.min
				|| col_min > col_BB.max || row_min > row_BB.max) {
		} else {

			// dX_stable_centre
			// dY_stable_centre
			// OPTIMISED FOR THE Wi EVALUaATION NOT FOR AREA
			Vec_delta_Data_T dX_1_0 = V[1].x_px - V[0].x_px;
			Vec_delta_Data_T dY_0_2 = V[0].y_px - V[2].y_px;
			Vec_Norm_Data_T A_partial1 = (dY_0_2 * dX_1_0);
			Vec_delta_Data_T dY_1_0 = V[1].y_px - V[0].y_px;
			Vec_delta_Data_T dX_0_2 = V[0].x_px - V[2].x_px;
			Vec_Norm_Data_T A_partial2 = (dX_0_2 * dY_1_0);
			Vec_Norm_Data_T Area = A_partial1 - A_partial2;

			if (!Area.is_neg() && !Area.is_zero()) {

#ifdef NDEBUG

				std::cout << " V[0].x_px " << V[0].x_px << std::endl;
				std::cout << " V[0].y_px " << V[0].y_px << std::endl;
				std::cout << " V[1].x_px " << V[1].x_px << std::endl;
				std::cout << " V[1].y_px " << V[1].y_px << std::endl;
				std::cout << " V[2].x_px " << V[2].x_px << std::endl;
				std::cout << " V[2].y_px " << V[2].y_px << std::endl;
				std::cout << std::endl;
				std::cout << " V_col_min " << V_col_min << std::endl;
				std::cout << " V_col_max " << V_col_max << std::endl;
				std::cout << " V_row_min " << V_row_min << std::endl;
				std::cout << " V_row_max " << V_row_max << std::endl;
				std::cout << " col_min " << col_min << std::endl;
				std::cout << " col_max " << col_max << std::endl;
				std::cout << " row_min " << row_min << std::endl;
				std::cout << " row_max " << row_max << std::endl;

				for (int row = row_min; row < row_max; row++) {
					for (int col = col_min; col < col_max; col++) {
						bool flag = false;
						if (row == V[2].y_px.to_int()
								&& col == V[2].x_px.to_int()) {
							flag = true;
							std::cout << "T";
						}
						if (row == V[1].y_px.to_int()
								&& col == V[1].x_px.to_int()) {

							flag = true;

							std::cout << "D";

						}
						if (row == V[0].y_px.to_int()
								&& col == V[0].x_px.to_int()) {
							flag = true;
							std::cout << "U";

						}
						if (!flag) {

							std::cout << "0";
						}
					}
					std::cout << std::endl;
				}

#endif
				position Index;

				Index.actual_row = V[V_row_min].y_px.range(BIT_PIXEL - 1,
				BIT_PIXEL - BIT_PIXEL_INT);
				Index.actual_col = V[V_row_min].x_px.range(BIT_PIXEL - 1,
				BIT_PIXEL - BIT_PIXEL_INT);

				/*
				 * WRITE COMAND FOR THE DEPTH BUFFER
				 */
				comand_stream.write(Read_area);
				Area_stream.write(Area);
				//////////////////////////////////////

				if (row_min < 0) {
					row_min = 0;
				}
				if (row_max > HEIGHT - 1) {
					row_max = HEIGHT - 1;
				} else {
					row_max++;
				}
				if (col_min < 0) {
					col_min = 0;
				}
				if (col_max > WIDTH - 1) {
					col_max = WIDTH - 1;
				} else {
					col_max++;
				}
				if (Index.actual_col > WIDTH - 1) {
					Index.actual_col = WIDTH - 2;
				}

				// THE RASTERISATION ALGORITHM WILL START FROM THE
				// COLMIN VERTICE AND SCAN THE TRIANGLE IN ONLY PLAUSIBLE DIRECTIONS
				// o------> (x)
				// |
				// v (y)
				// SET STARTING POINT

				// SET THE STARTING POINT IN THE MIDDLE OF THE GRID
				Vertice_final P_start = { Index.actual_col + Vxy_T_Data_T(0.5),
						Index.actual_row + Vxy_T_Data_T(0.5), 0 };

				Vec_delta_Data_T dX_P_0 = P_start.x_px - V[0].x_px;
				Vec_Norm_Data_T W_1_0_part1 = (dX_P_0 * dY_1_0);
				Vec_delta_Data_T dY_P_0 = P_start.y_px - V[0].y_px;
				Vec_Norm_Data_T W_1_0_part2 = (dY_P_0 * dX_1_0);
				Vec_Norm_Data_T W_1_0 = W_1_0_part1 - W_1_0_part2;

				Vec_delta_Data_T dY_2_1 = V[2].y_px - V[1].y_px;
				Vec_delta_Data_T dX_P_1 = P_start.x_px - V[1].x_px;
				Vec_Norm_Data_T W_2_1_part1 = (dX_P_1 * dY_2_1);

				Vec_delta_Data_T dX_2_1 = V[2].x_px - V[1].x_px;
				Vec_delta_Data_T dY_P_1 = P_start.y_px - V[1].y_px;
				Vec_Norm_Data_T W_2_1_part2 = (dY_P_1 * dX_2_1);
				Vec_Norm_Data_T W_2_1 = W_2_1_part1 - W_2_1_part2;

				Vec_delta_Data_T dX_P_2 = P_start.x_px - V[2].x_px;
				Vec_Norm_Data_T W_0_2_part1 = (dX_P_2 * dY_0_2);
				Vec_delta_Data_T dY_P_2 = P_start.y_px - V[2].y_px;
				Vec_Norm_Data_T W_0_2_part2 = (dY_P_2 * dX_0_2);
				Vec_Norm_Data_T W_0_2 = W_0_2_part1 - W_0_2_part2;

				// Start to set the basic flags
				u1_Data_T raster_past_flag = no_raster;
				u1_Data_T raster_actual_flag = no_raster;

				u1_Data_T raster_direction = keep;
				u1_Data_T raster_line = keep;
				// striangle_settart going backward

				u1_Data_T raster_orientation;

				// select the raster direction
				if (Index.actual_col == col_min) {
					raster_orientation = forward;
				} else {
					// the max bounding box is +1 so actual col == col max is not possible
					raster_orientation = backword;
				}
				// diagonal disabled
				u1_Data_T raster_diagonal = no_diagonal;
				// do a continue
				u1_Data_T END_flag = continue_raster;

				triangle_set_label0:do {
#pragma HLS LOOP_TRIPCOUNT min=0 max=6000 avg=1000

#ifdef NDEBUG
					if (x == 7369) {
						std::cout << "POINT" << std::endl;
						std::cout << "pont.x_px " << P_start.x_px << std::endl;
						std::cout << "pont.y_px " << P_start.y_px << std::endl;

						for (int row = row_min; row < row_max; row++) {
							for (int col = col_min; col < col_max; col++) {
								bool flag = false;
								if (row == P_start.y_px.to_int()
										&& col == P_start.x_px.to_int()) {
									std::cout << "P";

								} else {
									if (row == V[2].y_px.to_int()
											&& col == V[2].x_px.to_int()) {
										flag = true;
										std::cout << "T";
									}
									if (row == V[1].y_px.to_int()
											&& col == V[1].x_px.to_int()) {

										flag = true;

										std::cout << "D";

									}
									if (row == V[0].y_px.to_int()
											&& col == V[0].x_px.to_int()) {
										flag = true;
										std::cout << "U";

									}
									if (!flag) {

										std::cout << "0";
									}
								}
							}
							std::cout << std::endl;
						}

						std::cout << std::endl;
					}
#endif

					// IF THE POINT IS INSIDE THE TRIANGLE RASTER IT !
					if (!W_1_0.is_neg() && !W_2_1.is_neg() && !W_0_2.is_neg()) {

						Depth_Non_Norm_Data_T z_trunc = (W_1_0 * V[0].z)
								+ (W_2_1 * V[1].z) + (W_0_2 * V[2].z);

						comand_stream.write(Read_d_i);
						z_stream.write(z_trunc);
						index_stream.write(Index);
						//SET THE RASTER FLAG
						raster_actual_flag = yes_raster;

					}

					if ((Index.actual_col != col_max)
							&& (Index.actual_col != col_min)) {
						// Inside this we are sure that we are not on the edge
						// so diagonal movements are allowed
						if (raster_actual_flag == yes_raster) {
							// If I rasterise update the flags
							raster_past_flag = yes_raster;
							raster_actual_flag = no_raster;
							raster_direction = keep;
							raster_line = keep;
							raster_diagonal = no_diagonal;
						} else if (raster_past_flag == no_raster) {
							// make sure that actual flag is no_raster
							raster_actual_flag = no_raster;
							if (Index.actual_col
									== P_start.x_px.range(BIT_PIXEL - 1,
									BIT_PIXEL - BIT_PIXEL_INT)) {// IN THE STARTING POINT WE WANT TO TEST AT LEAST TWO POINTS
								raster_direction = keep;
								raster_line = keep;
								raster_diagonal = no_diagonal;
							}
						}
					} else {
						if (Index.actual_col
								== P_start.x_px.range(BIT_PIXEL - 1,
								BIT_PIXEL - BIT_PIXEL_INT)) { // IN THE STARTING POINT WE WANT TO TEST AT LEAST TWO POINTS
							raster_direction = keep;
							raster_line = keep;
							raster_diagonal = no_diagonal;
						} else {
							// reset the flags for next line
							raster_past_flag = no_raster;
							raster_actual_flag = no_raster;
							// if we hit the wall change line and flip the raster direction
							// on edge diagonal movement is not allowed
							raster_direction = change;
							raster_line = change;
							raster_diagonal = no_diagonal;
						}
					}

					if (raster_line == change) {
						// THIS TO GO TO THE NEXT row
						// WE are forced to flip the raster direction
						W_1_0 -= dX_1_0;
						W_2_1 -= dX_2_1;
						W_0_2 -= dX_0_2;
						if (Index.actual_row != row_max - 1) {
							Index.actual_row++;
							END_flag = continue_raster;
						} else {
							END_flag = end_raster;
						}

						if (raster_diagonal == yes_diagonal) {
							if (raster_orientation == forward) {
								// FOR THE NEXT COLUM
								W_1_0 += dY_1_0;
								W_2_1 += dY_2_1;
								W_0_2 += dY_0_2;
								Index.actual_col++;
							} else {
								// FOR THE PREV COLUM
								W_1_0 -= dY_1_0;
								W_2_1 -= dY_2_1;
								W_0_2 -= dY_0_2;
								Index.actual_col--;
							}

						}
						P_start.x_px = Index.actual_col;
						P_start.y_px = Index.actual_row;
						if (raster_direction == change) {
							raster_orientation = !raster_orientation;
						}
					} else {
						// we keep the same line
						if (raster_orientation == forward) {
							// FOR THE NEXT COLUM
							W_1_0 += dY_1_0;
							W_2_1 += dY_2_1;
							W_0_2 += dY_0_2;
							Index.actual_col++;
						} else {
							// FOR THE PREV COLUM
							W_1_0 -= dY_1_0;
							W_2_1 -= dY_2_1;
							W_0_2 -= dY_0_2;
							Index.actual_col--;
						}
					}

				} while (END_flag == continue_raster);

			}

		}
		if (x % (tri_num_[Obj_Under_Test]) == 0 && x != 0) {
			comand_stream.write(End_raster);
		}
	}
	comand_stream.write(End_raster);

}

void create_offset_logic(bound_Data_T & Offset_coord,
		ap_uint<BIT_CENTRE> & Center_SAMPLE, ap_uint<BIT_CENTRE> MAX_DIM) {
	ap_int<11> bias = Center_SAMPLE - BB_MAX_HALF_SIZE;
	if (bias < 0) {
		// this means that the input is lower than the minimum, so offset = 0;
		Offset_coord = 0;
	} else if (Center_SAMPLE < MAX_DIM - BB_MAX_HALF_SIZE) {
		Offset_coord = bias;
	} else {
		Offset_coord = MAX_DIM - BB_MAX_SIZE;
	}
}

void create_offsets(offset_position & Offset, Center_SAMPLE & Center_SAMPLE) {
	create_offset_logic(Offset.offset_col, Center_SAMPLE.x_px_centre,
	WIDTH);
	create_offset_logic(Offset.offset_row, Center_SAMPLE.y_px_centre,
	HEIGHT);
}

void depth_substitution(stream<Center_SAMPLE> & Center_SAMPLE_stream_dep,
		stream<Vec_Norm_Data_T> & Area_stream,
		stream<Depth_Non_Norm_Data_T> & z_stream,
		stream<position> & index_stream, stream<u2_Data_T> & comand_stream,
		int ID, ObjectName Obj_Under_Test, stream<Depth_Data_T> & Depth_stream,
		stream<size_BB> & Size_BB_stream_dep,
		stream<count_pixel_Data_T> & V_R_stream,
		stream<count_pixel_Data_T> & V_D_stream,
		stream<Inlier_Data_T> &Inlier_stream) {

#ifdef NDEBUG
	Depth_Data_T raster_frange[200][200];
#endif
#ifdef NDEBUG
	Depth_Data_T full_Raster[480][640];

#endif
	Depth_Data_T depth_frange[200][200];

	Depth_Data_T z_dept_frange;
	u2_Data_T Current_comand;
	Vec_Recip_tru_Area_Data_T Area_recip;
	Vec_Recip_Area_Data_T Area_fill;
	offset_position current_Offset;
	position relative_index;
	position absolute_Index;
	Depth_Data_T z_local;
	Depth_Non_Norm_Data_T z_new;

	for (int x = 0; x < Num_sample_x_raster_core; x++) {

		Inlier_Data_T inlier_in_BB = 0;
		count_pixel_Data_T valid_depth_in_BB = 0;
		count_pixel_Data_T valid_raster_in_BB = 0;
//		Inlier_Data_T inlier_out_BB = 0;
//		int valid_depth_out_BB = 0;
//		int valid_raster_out_BB = 0;
		u1_Data_T in_BB_Flag;
		size_BB current_Size_BB_max;
		size_BB current_Size_BB_min;
		size_BB current_Size_BB = Size_BB_stream_dep.read();
		Center_SAMPLE current_Centre_SAMPLE = Center_SAMPLE_stream_dep.read();
		create_offsets(current_Offset, current_Centre_SAMPLE);

		current_Size_BB_min.width = BB_MAX_HALF_SIZE
				- (current_Size_BB.width >> 1);
		current_Size_BB_max.width = BB_MAX_HALF_SIZE
				+ (current_Size_BB.width >> 1);
		current_Size_BB_min.height = BB_MAX_HALF_SIZE
				- (current_Size_BB.height >> 1);
		current_Size_BB_max.height = BB_MAX_HALF_SIZE
				+ (current_Size_BB.height >> 1);

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
#pragma HLS PIPELINE II=1
				Depth_Data_T Depth_tempor = Depth_stream.read();

				if (Depth_tempor <= Depth_Data_T(3.0)
						&& row >= current_Size_BB_min.height
						&& row < current_Size_BB_max.height
						&& col >= current_Size_BB_min.width
						&& col < current_Size_BB_max.width) {
					valid_depth_in_BB++;
				}
//				else if (Depth_tempor <= Depth_Data_T(2.0)) {
//					valid_depth_out_BB++;
//				}

				depth_frange[row][col] = Depth_tempor;
			}
		}

#ifdef NDEBUG
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				raster_frange[row][col] = Depth_Data_T(3.99805);
			}
		}
#endif
#ifdef NDEBUG
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
#pragma HLS PIPELINE II=1
				full_Raster[row][col] = Depth_Data_T(3.99805);
			}
		}

#endif

		do {
#pragma HLS LOOP_TRIPCOUNT min=0 max=6000 avg=1000

			Current_comand = comand_stream.read();
			switch (Current_comand) {
			case Read_area:
				// if new triangle new area
				Area_fill = Area_stream.read();
				Area_recip = Vec_Recip_Area_Data_T(hls::recip(Area_fill));
//				ar_ft = Area_fill.to_float();
//				ar_ft = 1.0 / ar_ft;
//				if (std::abs(ar_ft - Area_recip.to_float()) > 0.0001) {
//					std::cout << "Alert !" << ar_ft << " " << Area_recip
//							<< std::endl;
//				}
				break;
			case Read_d_i:
				z_new = z_stream.read();
				absolute_Index = index_stream.read();
				relative_index.actual_row = absolute_Index.actual_row
						- current_Offset.offset_row;
				relative_index.actual_col = absolute_Index.actual_col
						- current_Offset.offset_col;
				z_dept_frange =
						depth_frange[relative_index.actual_row][relative_index.actual_col];

				if ((relative_index.actual_row < 0
						|| relative_index.actual_row > BB_MAX_SIZE)
						|| ((relative_index.actual_col < 0
								|| relative_index.actual_col > BB_MAX_SIZE))) {
					// if outside the bounds reject
					// kept only to be sure
				} else {
					Depth_Data_T z_rastered = Area_recip * z_new;

					// valid address for the frange
					// so valid raster in the frange
					if (z_rastered <= Depth_Data_T(2.0)) {
						if (relative_index.actual_row
								>= current_Size_BB_min.height
								&& relative_index.actual_row
										< current_Size_BB_max.height
								&& relative_index.actual_col
										>= current_Size_BB_min.height
								&& relative_index.actual_col
										< current_Size_BB_max.width) {

							valid_raster_in_BB++;
							in_BB_Flag = 1;

						} else {
							//valid_raster_out_BB++;
							in_BB_Flag = 0;
						}

						if (z_dept_frange <= Depth_Data_T(3.0)
								&& in_BB_Flag == 1) {
							Depth_DIFF_Data_T z_depth_difference = z_dept_frange
									- z_rastered;

							Depth_DIFF_abs_Data_T z_depth_abs_difference;
							if (z_depth_difference < 0) {
								z_depth_abs_difference = -z_depth_difference;
							} else {
								z_depth_abs_difference = z_depth_difference;
							}
							Inlier_Data_T inlier_Temp;

//							if (absolute_Index.actual_row == 293
//									&& absolute_Index.actual_col == 370) {
//								std::cout << "z_rastered : " << z_rastered
//										<< std::endl;
//								std::cout << "z_rastered float : "
//										<< ar_ft * z_new.to_float()
//										<< std::endl;
//								std::cout << "z_dept_frange : " << z_dept_frange
//										<< std::endl;
//								std::cout << "z_depth_difference : "
//										<< z_depth_difference << std::endl;
//								std::cout << "z_depth_abs_difference : "
//										<< z_depth_abs_difference << std::endl;
//								std::cout << "z_depth_difference float : "
//										<< z_dept_frange.to_float()
//												- ar_ft * z_new.to_float()
//										<< std::endl;
//								std::cout << Depth_Data_T(0.64400005)
//										<< std::endl;
//							}

							if (z_depth_abs_difference <= 0.00390625) {
								// output 1
								inlier_Temp = 1;
							} else if (z_depth_abs_difference < 0.0078125) {
								// renormalise
								inlier_Temp = Depth_DIFF_abs_Data_T(2.0)
										- (z_depth_abs_difference * 256);
							} else {
								inlier_Temp = 0;
							}

							inlier_in_BB += inlier_Temp;

						}
#ifdef NDEBUG
						z_local =
						raster_frange[relative_index.actual_row][relative_index.actual_col];
						if (z_rastered < z_local) {

							raster_frange[relative_index.actual_row][relative_index.actual_col] =
							z_rastered;
						}
#endif
#ifdef NDEBUG
						z_local =
						full_Raster[absolute_Index.actual_row][absolute_Index.actual_col];
						if (z_rastered < z_local) {

							full_Raster[absolute_Index.actual_row][absolute_Index.actual_col] =
							z_rastered;
						}
#endif

					}
				}
				break;
			case End_raster:
				break;
			}

		} while (Current_comand != End_raster);

		/////////////////// EVALUATE INLIER
		// must check the division
		// it goes above 1 because we rasterise twice some pixels
		// because we removed the depth check
		V_R_stream.write(valid_raster_in_BB);
		V_D_stream.write(valid_depth_in_BB);
		Inlier_stream.write(inlier_in_BB);

//		float weight_in_BB = inlier_in_BB.to_float();
//		float weight_out_BB = inlier_out_BB.to_float();
//		weight_in_BB = 0.5 * weight_in_BB / float(valid_raster_in_BB)
//				+ 0.5 * weight_in_BB / float(valid_depth_in_BB);
//		weight_out_BB = 0.5 * weight_out_BB / float(valid_raster_out_BB)
//				+ 0.5 * weight_out_BB / float(valid_depth_out_BB);
//		std::cout << Obj_Under_Test << "_" << ID << "_" << x
//				<< " inlier_in_BB : " << inlier_in_BB
//				<< " valid_raster_in_BB : " << valid_raster_in_BB
//				<< " valid_depth_in_BB : " << valid_depth_in_BB
//				<< " weight_in_BB : " << weight_in_BB << std::endl;
//				std::cout << " inlier_out_BB : " << inlier_out_BB
//				<< " valid_raster_out_BB : " << valid_raster_out_BB
//				<< " valid_depth_out_BB : " << valid_depth_out_BB
//				<< " weight_out_BB : " << weight_out_BB << std::endl;

#ifdef NDEBUG

		int abs_address = ID + x * 10;
#endif
#ifdef NDEBUG

		std::stringstream ss_D_F;
		ss_D_F << Obj_Under_Test;
		ss_D_F << "_D_F_";
		ss_D_F << abs_address;
		ss_D_F << "_OBJ.ppm";
		std::string str_D_F = ss_D_F.str();
		std::ofstream img_D_F(str_D_F.c_str());
		img_D_F << "P2" << std::endl;
		img_D_F << BB_MAX_SIZE << " " << BB_MAX_SIZE << std::endl;
		img_D_F << "65535" << std::endl;

		float max_D_F = 0;
		float min_D_F = 65535;
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (depth_frange[row][col].to_float() > max_D_F
						&& depth_frange[row][col] <= Depth_Data_T(3.0)) {
					max_D_F = depth_frange[row][col].to_float();
				} else if (depth_frange[row][col].to_float() < min_D_F) {
					min_D_F = depth_frange[row][col].to_float();
				}
			}
		}

		float range_D_F = 1.0 / (max_D_F - min_D_F);

		float temp_Depth_frange[200][200];

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (depth_frange[row][col].to_float() >= max_D_F) {
					temp_Depth_frange[row][col] = 0.0;
				} else {
					temp_Depth_frange[row][col] = (max_D_F
							- depth_frange[row][col].to_float()) * range_D_F
					* 65534.0;
				}

			}
		}

		for (int row = current_Size_BB_min.height;
				row < current_Size_BB_max.height; row++) {
			temp_Depth_frange[row][current_Size_BB_min.width] = 65534.0;

			temp_Depth_frange[row][current_Size_BB_max.width - 1] = 65534.0;
		}

		for (int col = current_Size_BB_min.width;
				col < current_Size_BB_max.width; col++) {
			temp_Depth_frange[current_Size_BB_min.height][col] = 65534.0;

			temp_Depth_frange[current_Size_BB_max.height - 1][col] = 65534.0;
		}

		temp_Depth_frange[BB_MAX_HALF_SIZE - 1][BB_MAX_HALF_SIZE - 1] = 65534.0;

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				img_D_F << (int) temp_Depth_frange[row][col] << " ";

			}
			img_D_F << " \n ";
		}

		img_D_F.close();

		std::stringstream ss_R_F;
		ss_R_F << Obj_Under_Test;
		ss_R_F << "_R_F_";
		ss_R_F << abs_address;
		ss_R_F << "_OBJ.ppm";
		std::string str_R_F = ss_R_F.str();
		std::ofstream img_R_F(str_R_F.c_str());
		img_R_F << "P2" << std::endl;
		img_R_F << BB_MAX_SIZE << " " << BB_MAX_SIZE << std::endl;
		img_R_F << "65535" << std::endl;

		float max_R_F = 0;
		float min_R_F = 65535;
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (raster_frange[row][col].to_float() > max_R_F
						&& raster_frange[row][col].to_float() <= 3.0
						&& depth_frange[row][col].to_float() <= 3.0) {
					max_R_F = raster_frange[row][col].to_float();
				} else if (raster_frange[row][col].to_float() < min_R_F) {
					min_R_F = raster_frange[row][col].to_float();
				}
			}
		}

		float range_R_F = 1.0 / (max_R_F - min_R_F);
		float temp_Raster_frange[200][200];

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (raster_frange[row][col].to_float() >= max_R_F) {
					temp_Raster_frange[row][col] = 0.0;
				} else {
					temp_Raster_frange[row][col] = (max_R_F
							- raster_frange[row][col].to_float()) * range_R_F
					* 65534.0;
				}

			}
		}

		// SET__BBOXs
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {

				if (row == 0 || row == BB_MAX_SIZE - 1) {
					temp_Raster_frange[row][col] = 65534;

				} else {
					if (col == 0 || col == BB_MAX_SIZE - 1) {
						temp_Raster_frange[row][col] = 65534;
					}
				}
				if (col == BB_MAX_HALF_SIZE - 1
						&& row == BB_MAX_HALF_SIZE - 1) {
					temp_Raster_frange[row][col] = 65534;
				}
			}
		}

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				img_R_F << (int) temp_Raster_frange[row][col] << " ";

			}
			img_R_F << " \n ";
		}

		img_R_F.close();

		float common_max;
		if (max_D_F > max_R_F) {
			common_max = max_D_F;
		} else {
			common_max = max_R_F;
		}

		float common_min;
		if (min_D_F < min_R_F) {
			common_min = min_D_F;
		} else {
			common_min = min_R_F;
		}

		float common_range = 1.0 / (common_max - common_min);

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (depth_frange[row][col].to_float() >= common_max) {
					temp_Depth_frange[row][col] = 0.0;
				} else {
					temp_Depth_frange[row][col] = (common_max
							- depth_frange[row][col].to_float()) * common_range
					* 65534.0;
				}

			}
		}

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (raster_frange[row][col].to_float() >= common_max) {
					temp_Raster_frange[row][col] = 0.0;
				} else {
					temp_Raster_frange[row][col] = (common_max
							- raster_frange[row][col].to_float()) * common_range
					* 65534.0;
				}

			}
		}

		float max_error = 0;
		float min_error = 1000;
		float error[200][200];
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (depth_frange[row][col].to_float() <= 2.0
						&& raster_frange[row][col].to_float() <= 2.0) {
					error[row][col] = std::abs(
							depth_frange[row][col].to_float()
							- raster_frange[row][col].to_float());
				} else {
					error[row][col] = 3.99;
				}
				if (error[row][col] > max_error && error[row][col] <= 2.0) {
					max_error = error[row][col];
				} else if (error[row][col] < min_error) {
					min_error = error[row][col];
				}
			}
		}
		float error_range = 1.0 / (max_error - min_error);

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (error[row][col] >= max_error) {
					error[row][col] = 0.0;
				} else {
					error[row][col] = (max_error - error[row][col])
					* error_range * 65534.0;
				}

			}
		}

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (raster_frange[row][col].to_float() >= max_R_F) {
					temp_Raster_frange[row][col] = 0.0;
				} else {
					temp_Raster_frange[row][col] = (max_R_F
							- raster_frange[row][col].to_float()) * range_R_F
					* 65534.0;
				}

			}
		}

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				if (depth_frange[row][col].to_float() >= max_D_F) {
					temp_Depth_frange[row][col] = 0.0;
				} else {
					temp_Depth_frange[row][col] = (max_D_F
							- depth_frange[row][col].to_float()) * range_D_F
					* 65534.0;
				}

			}
		}
//		std::cout << "max_error : " << max_error << std::endl;
//		std::cout << "min_error : " << min_error << std::endl << std::endl;

		std::stringstream ss_error;
		ss_error << Obj_Under_Test;
		ss_error << "_error_";
		ss_error << abs_address;;
		ss_error << "_OBJ.ppm";
		std::string str_error = ss_error.str();
		std::ofstream img_error(str_error.c_str());
		img_error << "P2" << std::endl;
		img_error << BB_MAX_SIZE << " " << BB_MAX_SIZE << std::endl;
		img_error << "65535" << std::endl;

		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {
				img_error << (int) error[row][col] << " ";

			}
			img_error << " \n ";
		}
		img_error.close();
		// SET__BBOXs
		for (int row = 0; row < BB_MAX_SIZE; row++) {
			for (int col = 0; col < BB_MAX_SIZE; col++) {

				if (row == 0 || row == BB_MAX_SIZE - 1) {
					temp_Raster_frange[row][col] = 65534;

				} else {
					if (col == 0 || col == BB_MAX_SIZE - 1) {
						temp_Raster_frange[row][col] = 65534;
					}
				}
				if (col == BB_MAX_HALF_SIZE - 1
						&& row == BB_MAX_HALF_SIZE - 1) {
					temp_Raster_frange[row][col] = 65534;
				}
			}
		}

		for (int row = current_Size_BB_min.height;
				row < current_Size_BB_max.height; row++) {
			temp_Depth_frange[row][current_Size_BB_min.width] = 65534.0;

			temp_Depth_frange[row][current_Size_BB_max.width - 1] = 65534.0;
		}

		for (int col = current_Size_BB_min.width;
				col < current_Size_BB_max.width; col++) {
			temp_Depth_frange[current_Size_BB_min.height][col] = 65534.0;

			temp_Depth_frange[current_Size_BB_max.height - 1][col] = 65534.0;
		}

		temp_Depth_frange[BB_MAX_HALF_SIZE - 1][BB_MAX_HALF_SIZE - 1] = 65534.0;
#endif
#ifdef NDEBUG

//		std::stringstream ss_F_F;
//		ss_F_F << Obj_Under_Test;
//		ss_F_F << "_F_F_";
//		ss_F_F << abs_address;
//		ss_F_F << "_OBJ.ppm";
//		std::string str_F_F = ss_F_F.str();
//		std::ofstream img_F_F(str_F_F.c_str());
//		img_F_F << "P2" << std::endl;
//		img_F_F << WIDTH << " " << HEIGHT << std::endl;
//		img_F_F << "65535" << std::endl;

		float max_F_F = 0;
		float min_F_F = 65535;
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (full_Raster[row][col].to_float() > max_F_F
						&& full_Raster[row][col].to_float() <= 3.0
						&& depth_frange[row][col].to_float() <= 3.0) {
					max_F_F = full_Raster[row][col].to_float();
				} else if (full_Raster[row][col].to_float() < min_F_F) {
					min_F_F = full_Raster[row][col].to_float();
				}
			}
		}

		float range_F_F = 1.0 / (max_F_F - min_F_F);
		float temp_RasteF_Frange[480][640];

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (full_Raster[row][col].to_float() >= max_F_F) {
					temp_RasteF_Frange[row][col] = 0.0;
				} else {
					temp_RasteF_Frange[row][col] = (max_F_F
							- full_Raster[row][col].to_float()) * range_F_F
					* 65534.0;
				}

			}
		}

		// SET__BBOXs
		for (int row = current_Centre_SAMPLE.y_px_centre
				- current_Size_BB.height / 2;
				row
				< current_Centre_SAMPLE.y_px_centre
				+ current_Size_BB.height / 2; row++) {
			for (int col = current_Centre_SAMPLE.x_px_centre
					- current_Size_BB.width / 2;
					col
					< current_Centre_SAMPLE.x_px_centre
					+ current_Size_BB.width / 2; col++) {

				if (row
						== current_Centre_SAMPLE.y_px_centre
						- current_Size_BB.height / 2
						|| row
						== current_Centre_SAMPLE.y_px_centre
						+ current_Size_BB.height / 2 - 1) {
					temp_RasteF_Frange[row][col] = 65534;

				} else {
					if (col
							== current_Centre_SAMPLE.x_px_centre
							- current_Size_BB.width / 2
							|| col
							== current_Centre_SAMPLE.x_px_centre
							+ current_Size_BB.width / 2 - 1) {
						temp_RasteF_Frange[row][col] = 65534;
					}
				}
				if (col == current_Centre_SAMPLE.x_px_centre - 1
						&& row == current_Centre_SAMPLE.y_px_centre - 1) {
					temp_RasteF_Frange[row][col] = 65534;
				}
			}
		}

//		for (int row = 0; row < HEIGHT; row++) {
//			for (int col = 0; col < WIDTH; col++) {
//				img_F_F << (int) temp_RasteF_Frange[row][col] << " ";
//
//			}
//			img_F_F << " \n ";
//		}
//
//		img_F_F.close();

#include "./TB_FILES/nonetf_withouttable_Z_ch.hpp"
		std::stringstream ss_all;
		ss_all << Obj_Under_Test;
		ss_all << "_Scene_";
		ss_all << abs_address;
		ss_all << "_OBJ.ppm";
		std::string str_all = ss_all.str();
		std::ofstream img_all(str_all.c_str());
		img_all << "P3" << std::endl;
		img_all << WIDTH << " " << HEIGHT << std::endl;
		img_all << "65535" << std::endl;

		float max_depth = 0;
		float min_depth = 6000;
		float temp_depth_scene[HEIGHT][WIDTH];
		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (nonetf_withouttable_Z_ch[row * WIDTH + col] >= max_depth
						&& nonetf_withouttable_Z_ch[row * WIDTH + col] <= 3) {
					max_depth = nonetf_withouttable_Z_ch[row * WIDTH + col];
				} else if (nonetf_withouttable_Z_ch[row * WIDTH + col]
						< min_depth) {
					min_depth = nonetf_withouttable_Z_ch[row * WIDTH + col];
				}
			}
		}

		float range_depth = 1.0 / (max_depth - min_depth);

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
				if (nonetf_withouttable_Z_ch[row * WIDTH + col] >= max_depth) {
					temp_depth_scene[row][col] = 0.0;
				} else {
					temp_depth_scene[row][col] = (max_depth
							- nonetf_withouttable_Z_ch[row * WIDTH + col])
					* range_depth * 65534.0;
				}

			}
		}

		ap_uint<BIT_CENTRE> y_begin;
		ap_uint<BIT_CENTRE> y_final;
		ap_uint<BIT_CENTRE> x_begin;
		ap_uint<BIT_CENTRE> x_final;

		if (current_Centre_SAMPLE.x_px_centre > WIDTH - BB_MAX_HALF_SIZE) {
			// BECAUSE IF THE MAX SATURATE THE BOUNDARIES WE FIX THE DEPTH AND LET THE CENTER MOVE
			x_begin = WIDTH - BB_MAX_SIZE;
			x_final = WIDTH;
		} else {
			ap_int<11> xmin = current_Centre_SAMPLE.x_px_centre
			- BB_MAX_HALF_SIZE;
			if (xmin < 0) {
				// if the y is below the minimum range we correct
				x_begin = 0;
				x_final = BB_MAX_SIZE;
			} else {
				x_begin = xmin;
				x_final = xmin + BB_MAX_SIZE;
			}
		}
		if (current_Centre_SAMPLE.y_px_centre > HEIGHT - BB_MAX_HALF_SIZE) {
			// BECAUSE IF THE MAX SATURATE THE BOUNDARIES WE FIX THE DEPTH AND LET THE CENTER MOVE
			y_begin = HEIGHT - BB_MAX_SIZE;
			y_final = HEIGHT;
		} else {
			ap_int<11> ymin = current_Centre_SAMPLE.y_px_centre
			- BB_MAX_HALF_SIZE;
			if (ymin < 0) {
				// if the y is below the minimum range we correct
				y_begin = 0;
				y_final = BB_MAX_SIZE;
			} else {
				y_begin = ymin;
				y_final = ymin + BB_MAX_SIZE;
			}
		}

		for (int row = 0; row < HEIGHT; row++) {
			for (int col = 0; col < WIDTH; col++) {
//
//				if (col >= x_begin && col < x_final && row < y_final
//						&& row >= y_begin) {
//					img_all
//							<< (int) temp_Depth_frange[row
//									- current_Offset.offset_row][col
//									- current_Offset.offset_col] << " "
//							<< (int) temp_Raster_frange[row
//									- current_Offset.offset_row][col
//									- current_Offset.offset_col] << " "
//							<< (int) temp_depth_scene[row][col] << " ";
//				} else {
				img_all << (int) temp_RasteF_Frange[row][col] << " "
				<< (int) temp_RasteF_Frange[row][col] << " "
				<< (int) temp_depth_scene[row][col] << " ";
//				}

			}
			img_all << " \n ";
		}

		img_all.close();
#endif
	}
}

void inlier_evaluator(int ID, stream<count_pixel_Data_T> & V_R_stream,
		stream<count_pixel_Data_T> & V_D_stream,
		stream<Inlier_Data_T> &Inlier_stream,
		stream<Raster_Core_Output> & Serial_weights) {
	count_pixel_Data_T valid_raster_in_BB;
	count_pixel_Data_T valid_depth_in_BB;
	Inlier_Data_T inlier_in_BB;
	for (int x = 0; x < Num_sample_x_raster_core; x++) {
		valid_raster_in_BB = V_R_stream.read();
		valid_depth_in_BB = V_D_stream.read();
		inlier_in_BB = Inlier_stream.read();
		Raster_Core_Output output_fill;

//		float weight_in_BB = inlier_in_BB.to_float();
//		weight_in_BB = 0.5 * weight_in_BB / float(valid_raster_in_BB)
//				+ 0.5 * weight_in_BB / float(valid_depth_in_BB);
//		std::cout << ID << "_" << x << " inlier_in_BB : " << inlier_in_BB
//				<< " valid_raster_in_BB : " << valid_raster_in_BB
//				<< " valid_depth_in_BB : " << valid_depth_in_BB
//				<< " weight_in_BB : " << weight_in_BB << std::endl;

		if (valid_depth_in_BB <= 400 || valid_raster_in_BB <= 100
				|| inlier_in_BB == 0) {
			output_fill.Numerator = 0;
			output_fill.Denominator = 1;
		} else {
			output_fill.Numerator = (inlier_in_BB
					* (valid_raster_in_BB + (valid_depth_in_BB) << 1));	//
			output_fill.Denominator = (valid_depth_in_BB * valid_raster_in_BB);
		}
		Serial_weights.write(output_fill);
	}
}

void C_BB_duplicate(stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<size_BB> & Size_BB_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream_tri,
		stream<size_BB> & Size_BB_stream_tri,
		stream<Center_SAMPLE> & Center_SAMPLE_stream_dep,
		stream<size_BB> & Size_BB_stream_dep) {

	for (int x = 0; x < Num_sample_x_raster_core; x++) {

		Center_SAMPLE centre_fill = Center_SAMPLE_stream.read();
		size_BB Size_fill = Size_BB_stream.read();

		Center_SAMPLE_stream_tri.write(centre_fill);
		Size_BB_stream_tri.write(Size_fill);
		Center_SAMPLE_stream_dep.write(centre_fill);
		Size_BB_stream_dep.write(Size_fill);
	}
}
