#pragma once

#ifndef _RASTER_CORE_HPP_
#define _RASTER_CORE_HPP_

#include "Define.hpp"
#include "hls_stream.h"
#include "hls_math.h"

#include <fstream>
#include <string>

using namespace hls;

void RC_FT_Storing(stream<MatFT_Data_T> & FT_stream_distr,
		stream<MatFT_Data_T> (&FT_stream_SEQ)[M_DIM][M_DIM]);

void Vector_Transformation(stream<MatFT_Data_T> (&FT_stream_SEQ)[M_DIM][M_DIM],
		ObjectName Obj_Under_Test, stream<Vertice> & Vertice_stream,
		stream<Vec_4D_Data_T> & V_w_stream,
		stream<Vec_4D_Data_T> & V_zyx_stream);

void reciprocal(stream<Vec_4D_Data_T> & V_w_stream, ObjectName Obj_Under_Test,
		stream<V_w_rec_Data_T> & V_w_recipr_stream);

void Vector_normalisation(stream<Vec_4D_Data_T> & V_zyx_stream,
		ObjectName Obj_Under_Test, stream<V_w_rec_Data_T> & V_w_recipr_stream,
		stream<Vertice_final> & Vertice_final);
void Vector_Z_recover(stream<Vertice_final> & Vertice_final_stream,
		ObjectName Obj_Under_Test,
		stream<Vertice_final> & Vertice_z_correct_stream);

bound_Data_T find_min(Vxy_T_Data_T & in0, Vxy_T_Data_T & in1,
		Vxy_T_Data_T & in2);

bound_Data_T find_max(Vxy_T_Data_T & in0, Vxy_T_Data_T & in1,
		Vxy_T_Data_T & in2);

void triangle_set(stream<Vertice_final> & Vertice_final_stream,
		ObjectName Obj_Under_Test, stream<Vec_Norm_Data_T> & Area_stream,
		stream<Depth_Non_Norm_Data_T> & z_stream,
		stream<position> & index_stream, stream<u2_Data_T> & comand_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<size_BB> & Size_BB_stream);
void create_offset_logic(bound_Data_T & Offset_coord,
		ap_uint<BIT_CENTRE> & Center_SAMPLE);
void create_offsets(offset_position & Offset, Center_SAMPLE & Center_SAMPLE);
void depth_substitution(stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<Vec_Norm_Data_T> & Area_stream,
		stream<Depth_Non_Norm_Data_T> & z_stream,
		stream<position> & index_stream, stream<u2_Data_T> & comand_stream,
		int ID, ObjectName Obj_Under_Test, stream<Depth_Data_T> & Depth_stream,
		stream<size_BB> & Size_BB_stream,
		stream<count_pixel_Data_T> & V_R_stream,
		stream<count_pixel_Data_T> & V_D_stream,
		stream<Inlier_Data_T> &Inlier_stream);
void inlier_evaluator(int ID, stream<count_pixel_Data_T> & V_R_stream,
		stream<count_pixel_Data_T> & V_D_stream,
		stream<Inlier_Data_T> &Inlier_stream,
		stream<Raster_Core_Output> & Serial_weights);
void C_BB_duplicate(stream<Center_SAMPLE> & Center_SAMPLE_stream,
		stream<size_BB> & Size_BB_stream,
		stream<Center_SAMPLE> & Center_SAMPLE_stream_tri,
		stream<size_BB> & Size_BB_stream_tri,
		stream<Center_SAMPLE> & Center_SAMPLE_stream_dep,
		stream<size_BB> & Size_BB_stream_dep);

#endif
