from struct import unpack
import numpy as np
import cv2
from PIL import Image


outBuffer = np.fromfile("./exp001_B_int_output.txt", dtype='int8')
outBuffer2 = np.fromfile("./exp001_B_int_output2.txt", dtype='int8')
outBuffer3 = np.fromfile("./exp001_B_int_output3.txt", dtype='int8')

f = open('tfed_withouttable.pcd', 'r')
out_f_xmin = open("heuristic_xmin.hpp", "w")
out_f_xmin.write('float heuristic_xmin[] = { \n')
out_f_xmax = open("heuristic_xmax.hpp", "w")
out_f_xmax.write('float heuristic_xmax[] = { \n')
out_f_ymin = open("heuristic_ymin.hpp", "w")
out_f_ymin.write('float heuristic_ymin[] = { \n')
out_f_ymax = open("heuristic_ymax.hpp", "w")
out_f_ymax.write('float heuristic_ymax[] = { \n')
out_f_zmin = open("heuristic_zmin.hpp", "w")
out_f_zmin.write('float heuristic_zmin[] = { \n')
out_f_zmax = open("heuristic_zmax.hpp", "w")
out_f_zmax.write('float heuristic_zmax[] = { \n')

#read header
for i in range(11):
	f.readline();

data = f.read().splitlines()
pc = np.zeros((640*480, 3))
counter = 0
for line in data:
	x, y , z = line.split(' ');
	if ( x != "nan" or y != "nan" or z != "nan"):
		# pc.append( [float(x), float(y), float(z)])
		pc[counter][0] = float(x)
		pc[counter][1] = float(y)
		pc[counter][2] = float(z)
	else:
		pc[counter] = np.zeros(3)
	counter += 1;

print(len(pc))
anchor_shape = 224;
class_probability = []
bounding_box = []
SoftmaxTable_test = []
def CreateSoftmaxTable():
	step = 8;
	for i in range(-128,128):
		SoftmaxTable_test.append(np.exp(i/float(step)));

def lookupSM_test(x):
	return SoftmaxTable_test[int(x+128)]

W = 20;
H = 15;
W2 = 40;
H2 = 30;
W3 = 80;
H3 = 60;
image = cv2.imread("scenergb.jpg")
CreateSoftmaxTable()

def post_process(W_, H_, S, S_eq, outBuffer):
	counter = 0;
	for h in range(H_):
		for w in range(W_):
			exp_sum = 0;
			index = 26*(h*W_+w)

			
			box_center_x = (w+1)*640/(W_+1) + outBuffer[index+22]/8.0 * anchor_shape/S;
			box_center_y = (h+1)*480/(H_+1) + outBuffer[index+23]/8.0 * anchor_shape/S;

			box_width = anchor_shape/S * lookupSM_test(outBuffer[index+24])
			box_height = anchor_shape/S* lookupSM_test(outBuffer[index+25])

			if box_width > 200:
				box_width  =200;
			if box_height > 200:
				box_height = 200;

			# print(h*W_+w, outBuffer[index+22]/8.0, outBuffer[index+23]/8.0 )
			# print(box_center_x, box_center_y, box_width, box_height)
		
			bbox = [0, 0, 0, 0]
			if((box_center_x - box_width/2) <  0.0):
				bbox[0] =  0
			else:
				bbox[0] = int (box_center_x - box_width/2);
			if ((box_center_x + box_width/2) > 640.0):
				bbox[1] = 639
			else:
				bbox[1] = int (box_center_x + box_width/2);
			if((box_center_y - box_height/2) < 0.0):
				bbox[2] = 0
			else:
				bbox[2] = int (box_center_y - box_height/2);
			if ((box_center_y + box_height/2) > 480.0):
				bbox[3] = 479
			else:
				bbox[3] = int (box_center_y + box_height/2);

			top_left = int(bbox[2]*640+bbox[0]);
			bottom_right = int(bbox[3]*640+bbox[1]);

			# xmin, ymin, _ = pc[top_left];
			# xmax, ymax, _ = pc[bottom_right];

			# print(xmin, ymin, xmax, ymax)
			x_depth=[]
			y_depth = []
			z_depth = []
			for i in range(bbox[2], bbox[3]):
				for j in range(bbox[0], bbox[1]):
					ind = i*640+j
					x_depth.append(pc[ind][0])
					y_depth.append(pc[ind][1])
					z_depth.append(pc[ind][2])
			x_depth = np.array(x_depth)
			y_depth = np.array(y_depth)
			z_depth = np.array(z_depth)

			# sub_depth = pc[top_left:bottom_right][:]

 
			if (len(x_depth[np.nonzero(x_depth)]) == 0):
				xmin = 0;
			else:
				xmin = np.amin(x_depth[np.nonzero(x_depth)])
			xmax = np.amax(x_depth)

			if (len(y_depth[np.nonzero(y_depth)]) == 0):
				ymin = 0;
			else:
				ymin = np.amin(y_depth[np.nonzero(y_depth)])
			ymax = np.amax(y_depth)

			if (len(z_depth[np.nonzero(z_depth)]) == 0):
				zmin = 0;
			else:
				zmin = np.amin(z_depth[np.nonzero(z_depth)])
			zmax = np.amax(z_depth)

			# if (h ==2 and w == 4):
			# 	print(len(y_depth[np.nonzero(y_depth)]))
			# 	print("bbox: " ,box_center_x, box_center_y, box_width, box_height)
			# 	print("xmin: ", xmin, " xmax: ", xmax, " ymin: ", ymin, " ymax: ", ymax, " zmin: ", zmin, " zmax: ", zmax)


			out_f_xmin.write(str(xmin) + ", // " +  str(box_center_x) +" " + str(box_center_y) +  "\n")
			out_f_xmax.write(str(xmax) + ",\n")
			out_f_ymin.write(str(ymin) + ", // " +  str(box_center_x) +" " + str(box_center_y) +  "\n")
			out_f_ymax.write(str(ymax) + ",\n")
			out_f_zmin.write(str(zmin) + ", //" +  str(box_center_x) +" " + str(box_center_y) +  "\n")
			out_f_zmax.write(str(zmax) + ",\n")
			counter += 1
			# for c in range(21):
			# 	prob = lookupSM_test(outBuffer[index+c]) * conf / exp_sum;
			# 	class_probability.append(prob);
			# 	if (c ==9 and prob > 0.5):
			# 		cv2.rectangle(image, (bbox[0], bbox[2]), (bbox[1], bbox[3]), (0,0,255), 1);



			bounding_box.append(bbox);
	print(counter)

post_process(W, H, 1, 1, outBuffer)
post_process(W2, H2, 2, 4, outBuffer2)
post_process(W3, H3, 4, 16, outBuffer3)

out_f_xmin.write("};")
out_f_xmax.write("};")
out_f_ymin.write("};")
out_f_ymax.write("};")
out_f_zmin.write("};")
out_f_zmax.write("};")

# z_depth_image = pc[:,2]
# image = np.array(z_depth_image).reshape((480,640))
# max = np.amax(image)
# image = image/max * 255.0
# img = Image.fromarray(image)
# img.show()

# print(image)
# cv2.imshow("window", image)
# cv2.waitKey(0)

