#pragma once

#ifndef _TYPES_HPP_
#define _TYPES_HPP_

#include "ap_int.h"
#include "ap_fixed.h"
#include "Define.hpp"
#include <ap_axi_sdata.h>
#include <hls_stream.h>
#ifndef __SYNTHESIS__
#include <iostream>
#endif
// SPECIFIC TYPES
typedef ap_axis<8, 1, 1, 1> AXI_VAL;
typedef hls::stream<AXI_VAL> AXI_STREAM;
typedef ap_axis<8, 1, 1, 1> AP_VAL;
typedef hls::stream<AP_VAL> AP_STREAM;

// TYPES UINT
typedef ap_uint<1> u1_Data_T;
typedef ap_uint<2> u2_Data_T;
typedef ap_uint<3> u3_Data_T;
typedef ap_uint<4> u4_Data_T;
typedef ap_uint<5> u5_Data_T;
typedef ap_uint<6> u6_Data_T;
typedef ap_uint<7> u7_Data_T;
typedef ap_uint<8> u8_Data_T;
typedef ap_uint<9> u9_Data_T;
typedef ap_uint<10> u10_Data_T;
typedef ap_uint<11> u11_Data_T;
typedef ap_uint<12> u12_Data_T;
typedef ap_uint<13> u13_Data_T;
typedef ap_uint<14> u14_Data_T;
typedef ap_uint<15> u15_Data_T;
typedef ap_uint<16> u16_Data_T;
typedef ap_uint<17> u17_Data_T;
typedef ap_uint<18> u18_Data_T;
typedef ap_uint<19> u19_Data_T;
typedef ap_uint<20> u20_Data_T;
typedef ap_uint<21> u21_Data_T;
typedef ap_uint<22> u22_Data_T;
typedef ap_uint<23> u23_Data_T;
typedef ap_uint<24> u24_Data_T;
typedef ap_uint<25> u25_Data_T;
typedef ap_uint<26> u26_Data_T;
typedef ap_uint<27> u27_Data_T;
typedef ap_uint<28> u28_Data_T;
typedef ap_uint<29> u29_Data_T;
typedef ap_uint<30> u30_Data_T;
typedef ap_uint<31> u31_Data_T;
typedef ap_uint<32> u32_Data_T;
typedef ap_uint<33> u33_Data_T;
typedef ap_uint<34> u34_Data_T;
typedef ap_uint<35> u35_Data_T;
typedef ap_uint<36> u36_Data_T;
typedef ap_uint<37> u37_Data_T;
typedef ap_uint<38> u38_Data_T;
typedef ap_uint<39> u39_Data_T;
typedef ap_uint<40> u40_Data_T;
typedef ap_uint<41> u41_Data_T;
typedef ap_uint<42> u42_Data_T;
typedef ap_uint<43> u43_Data_T;
typedef ap_uint<44> u44_Data_T;
typedef ap_uint<45> u45_Data_T;
typedef ap_uint<46> u46_Data_T;
typedef ap_uint<47> u47_Data_T;
typedef ap_uint<48> u48_Data_T;
typedef ap_uint<49> u49_Data_T;
typedef ap_uint<50> u50_Data_T;
typedef ap_uint<51> u51_Data_T;
typedef ap_uint<52> u52_Data_T;
typedef ap_uint<53> u53_Data_T;
typedef ap_uint<54> u54_Data_T;
typedef ap_uint<55> u55_Data_T;
typedef ap_uint<56> u56_Data_T;
typedef ap_uint<57> u57_Data_T;
typedef ap_uint<58> u58_Data_T;
typedef ap_uint<59> u59_Data_T;

/*
 *
 *
 * TYPES FOR INITIALIZER
 *
 */
typedef ap_ufixed<18, 0> randZ01;

// THESE ARE FOR THE DISTRIBUTION CREATION
#define MAX_INIT_BIT   BIT_SUM_INIT	// MAX BETWEEN BIT_WEIGHT_FS and BIT_SUM_INIT
#define BIT_WEIGHT_FS 8  // FOR AXI MUST BE A MULTIPLE OF 8

/////////////////////////////////////////////////////////////////////////
//WARNING!!! if you change this you must change also the index of the loop
// OTHERWISE ENDLESS LOOP
#define BIT_SUM_INIT 13 // 13 for the pyramid 6300
//WARNING!!!
/////////////////////////////////////////////////////////////////////////

#define BIT_WEIGHT_NORM 18 // the truncated version

#define ONE_TRUNC_INIT 262143 // 2^18 -1

//256 isthe max  8 bits
//1/4938 = 0.000202511 ->  13 bit
#define BIT_NORM_COEFF_FS (BIT_SUM_INIT+BIT_WEIGHT_FS)

// THE PRODUCT OF TWO VARIABLE NEEDS IN EXACT CALUCLUS THE SUM OF THE BITS
#define BIT_FULL_RES_NORM (BIT_NORM_COEFF_FS + BIT_WEIGHT_FS)

typedef ap_uint<BIT_WEIGHT_FS> FS_Weight_Data_T;
typedef ap_ufixed<BIT_WEIGHT_FS, 0> FS_W_fix_Data_T;

typedef ap_ufixed<BIT_SUM_INIT + BIT_WEIGHT_FS, BIT_SUM_INIT> Full_Res_Sum_Data_T; // need 13 bit to the sum 6300 is bounded with 13 bit
// I need one extra for the LSB
//

typedef ap_ufixed<BIT_NORM_COEFF_FS, BIT_WEIGHT_FS> Norm_coeff_Data_T;

typedef ap_ufixed<BIT_FULL_RES_NORM, BIT_WEIGHT_FS> Full_Res_Norm_Sum_Data_T;

typedef ap_ufixed<BIT_WEIGHT_NORM, 0> Norm_weights_Data_T;

// THESE ARE FOR THE THRESHOLD ANALYZER

#define BIT_RANDOM_NUMBER 18
#define BIT_THR 5  // 2^5 = 32
#define SIZE_ARR_THR 32

typedef ap_uint<BIT_THR> THR_Data_T;
typedef ap_uint<BIT_THR + 1> THR_P_Data_T;
typedef ap_uint<BIT_THR + BIT_SUM_INIT> THR_INFO_Data_T;

typedef ap_uint<BIT_RANDOM_NUMBER + BIT_SUM_INIT + BIT_SUM_INIT> BOUNDS_RAND_Data_T;

typedef ap_uint<BIT_THR> THR_Resample_Data_;
typedef ap_uint<BIT_THR + 10> THR_Resample_INFO_Data_T;

typedef ap_uint<BIT_RANDOM_NUMBER + 10 + 10> BOUNDS_Resample_RAND_Data_T;

// This are the types for the Sample generator

// ASSUME THE BOUNDED TO +-7
#define BIT_POSE_FRAC 10 // 1 mm of resolution
#define BIT_POSE_INT 3 // with a maximum of 4 m of farness with the sign bit
#define BIT_ANGLE_FRAC 8 // 0.1 degree of resolution for sure because its bounded between +-1.57 (bit sign included)
#define BIT_ANGLE_INT 4
#define BIT_CENTRE 10 //640
#define BIT_BB_IMG 8 //256

#define BIT_POSE (BIT_POSE_FRAC+BIT_POSE_INT)
#define BIT_ANGLE (BIT_ANGLE_FRAC+BIT_ANGLE_INT)
typedef ap_fixed<BIT_POSE, BIT_POSE_INT> xyz_Data_T; // the bit sign
typedef ap_fixed<BIT_ANGLE, BIT_ANGLE_INT> angle_Data_T; // +-256 max with 3 bitof decimal must be limited to +-180
typedef ap_uint<BIT_CENTRE> BB_centre_Data_T;
typedef ap_uint<BIT_BB_IMG> BB_dim_Data_T;
typedef ap_uint<BIT_CENTRE + BIT_BB_IMG> BB_Data_T;
typedef ap_uint<BIT_SUM_INIT> Sample_abs_indx_Data_T;

struct BBOX {
	BB_Data_T x_centre_width;
	BB_Data_T y_centre_height;
	BB_Data_T h_index_w_index;
};

struct Mem_SAMPLE {
	xyz_Data_T x_S;
	xyz_Data_T y_S;
	xyz_Data_T z_S;
	angle_Data_T xroll_S; // on x
	angle_Data_T ypitch_S; // on y
	angle_Data_T zyaw_S; // on z
};

struct Mem_Heuristic {
	xyz_Data_T x_min;
	xyz_Data_T y_min;
	xyz_Data_T z_min;
	xyz_Data_T x_max;
	xyz_Data_T y_max;
	xyz_Data_T z_max;
};
struct Center_SAMPLE {
	ap_uint<BIT_CENTRE> x_px_centre;
	ap_uint<BIT_CENTRE> y_px_centre;
};

// SPECIFIC FOR THE FT CALCULATOR
#define BIT_P_INT 3
#define BIT_P_FRAC 12
#define BIT_P (BIT_P_FRAC+BIT_P_INT)
typedef ap_fixed<BIT_P, BIT_P_INT> MatP_Data_T;

#define BIT_C_INT 2
#define BIT_C_FRAC 13
#define BIT_C (BIT_C_FRAC+BIT_C_INT)
typedef ap_fixed<BIT_C, BIT_C_INT> MatC_Data_T;

#define BIT_PC_INT (BIT_P_INT+BIT_C_INT + 1 )
#define BIT_PC_FRAC (BIT_C_FRAC+BIT_P_FRAC)
#define BIT_PC_TRUNC_FRAC 13
#define BIT_PC (BIT_PC_FRAC+BIT_PC_INT)
#define BIT_PC_TR (BIT_PC_TRUNC_FRAC+BIT_PC_INT)
typedef ap_fixed<BIT_PC, BIT_PC_INT> MatPC_Data_T;
typedef ap_fixed<BIT_PC_TR, BIT_PC_INT> MatPC_Trunc_Data_T;

#define BIT_TRIG_FRAC 10
#define BIT_TRIG_INT 1
#define BIT_TRIG (BIT_TRIG_FRAC + BIT_TRIG_INT)
typedef ap_fixed<BIT_TRIG, BIT_TRIG_INT> trigono_Data_T;

struct RowTrRz_Mat_Data_T {
	trigono_Data_T row_0;
	trigono_Data_T row_1;
	ap_ufixed<1, 1> row_2; // 0nly 0 or 1
	xyz_Data_T row_3;
};

struct sincos_Struct {
	trigono_Data_T cosine;
	trigono_Data_T sine;
};

struct FR_Row_Mat_Data_T {
	ap_fixed<BIT_TRIG + BIT_PC_TR + 1, BIT_TRIG_INT + BIT_PC_INT - 1 + 2> row_0;
	ap_fixed<BIT_TRIG + BIT_PC_TR + 1, BIT_TRIG_INT + BIT_PC_INT - 1 + 2> row_1;
	ap_fixed<BIT_PC_TR + 2, BIT_PC_INT + 2> row_2;
	ap_fixed<BIT_POSE + BIT_PC_TR + 1, BIT_POSE_INT + BIT_PC_INT - 1 + 2> row_3;
};

// TRUNC ON 13 BITS on frac
#define row_0_BIT_TR (13 + BIT_TRIG_INT + BIT_PC_INT - 1 + 2)
#define row_1_BIT_TR (13 + BIT_TRIG_INT + BIT_PC_INT - 1 + 2)
#define row_2_BIT_TR (BIT_PC_TR + 2)
#define row_3_BIT_TR (13 + BIT_POSE_INT + BIT_PC_INT - 1 + 2)

struct Row_MatPCTrRz_Data_T {
	ap_fixed<row_0_BIT_TR, BIT_TRIG_INT + BIT_PC_INT - 1 + 2> row_0;
	ap_fixed<row_1_BIT_TR, BIT_TRIG_INT + BIT_PC_INT - 1 + 2> row_1;
	ap_fixed<row_2_BIT_TR, BIT_PC_INT + 2> row_2;
	ap_fixed<row_3_BIT_TR, BIT_POSE_INT + BIT_PC_INT - 1 + 2> row_3;
};

struct FR_Col_MatRyRx_Data_T {
	ap_fixed<BIT_TRIG + BIT_TRIG, BIT_TRIG_INT> col_0; // 2 times bit trigo
	ap_fixed<BIT_TRIG, BIT_TRIG_INT> col_1; // 1 time trigo
	ap_fixed<BIT_TRIG + BIT_TRIG, BIT_TRIG_INT> col_2; // 2 times bit trigo
	ap_ufixed<1, 1> col_3; //
};

struct Col_MatRyRx_Data_T {
	// all of these elements are lower or equal to 1
	ap_fixed<BIT_TRIG + BIT_TRIG_INT, BIT_TRIG_INT + BIT_TRIG_INT> col_0; // 2 times bit trigo
	ap_fixed<BIT_TRIG, BIT_TRIG_INT> col_1; // 1 time trigo
	ap_fixed<BIT_TRIG + BIT_TRIG_INT, BIT_TRIG_INT + BIT_TRIG_INT> col_2; // 2 times bit trigo
	ap_ufixed<1, 1> col_3; //
};

struct FR_result {
	ap_fixed<row_0_BIT_TR + BIT_TRIG, BIT_TRIG_INT + BIT_PC_INT> result_0;
	ap_fixed<row_1_BIT_TR + BIT_TRIG, BIT_TRIG_INT + BIT_PC_INT> result_1;
	ap_fixed<row_2_BIT_TR + BIT_TRIG, BIT_PC_INT + 2 - 1> result_2;
	ap_fixed<row_3_BIT_TR, BIT_POSE_INT + BIT_PC_INT> result_3;
};
#define BIT_FT_INT  (BIT_TRIG_INT + BIT_PC_INT)
#define BIT_FT_FRAC  14
#define BIT_FT_TRU (BIT_FT_FRAC+ BIT_FT_INT)
typedef ap_fixed<BIT_FT_TRU, BIT_FT_INT> MatFT_Data_T;

//
// Specific for the GPU
//
// NUM PARTICLES = 510
const u4_Data_T Num_Core_Raster = 10;
const u10_Data_T Num_sample_x_raster_core = 51; //Num_Particles / NUM_RENDER_CORES;
const u12_Data_T Num_raster_core_tri = Num_sample_x_raster_core * 3; //Num_Particles / NUM_RENDER_CORES;

#define NUM_RENDER_CORES (Num_Core_Raster)
#define NUM_SAMPLE_X_RASTER_CORE Num_sample_x_raster_core

#define BIT_DEPTH_INT 2
#define BIT_DEPTH_FRAC 10
typedef ap_ufixed<BIT_DEPTH_FRAC + BIT_DEPTH_INT, BIT_DEPTH_INT> Depth_Data_T;
typedef ap_fixed<BIT_DEPTH_FRAC + 2 + BIT_DEPTH_INT, BIT_DEPTH_INT + 2> Depth_DIFF_Data_T;
typedef ap_ufixed<BIT_DEPTH_FRAC + 1 + BIT_DEPTH_INT, BIT_DEPTH_INT + 1> Depth_DIFF_abs_Data_T;

#define FT_STREAM_DEPTH Num_sample_x_raster_core*_2DIM
#define BIT_VERT_INT 3
#define BIT_VERT_FRAC 10
#define BIT_VERT (BIT_VERT_INT+BIT_VERT_FRAC)
typedef ap_fixed<BIT_VERT, BIT_VERT_INT> Vertice_Data_T; // THIS REPRESENT THE MODEL express in meter

struct Vertice {
	Vertice_Data_T x;
	Vertice_Data_T y;
	Vertice_Data_T z;
};

// SPECIFIC FOR THE RASTER CIRE

typedef ap_fixed<BIT_VERT + BIT_FT_TRU, BIT_VERT_INT + BIT_FT_INT - 1> FR_Vec_4D_Data_T;
// TRUNCATED VERSION
#define BIT_VEC4D_FRAC_TRU 15
#define BIT_VEC4D_TRU (BIT_VEC4D_FRAC_TRU +BIT_VERT_INT+BIT_FT_INT-1)
typedef ap_fixed<BIT_VEC4D_TRU, BIT_VERT_INT + BIT_FT_INT - 1> Vec_4D_Data_T;

typedef ap_fixed<BIT_VEC4D_FRAC_TRU + BIT_VEC4D_FRAC_TRU, BIT_VEC4D_FRAC_TRU> V_w_rec_full_Data_T;

#define BIT_REC_W_TRUNC (BIT_VEC4D_FRAC_TRU+ BIT_VEC4D_FRAC_TRU)

typedef ap_fixed<BIT_REC_W_TRUNC, BIT_VEC4D_FRAC_TRU> V_w_rec_Data_T;

typedef ap_fixed<BIT_REC_W_TRUNC + 4,
BIT_VEC4D_FRAC_TRU + BIT_VERT_INT + BIT_FT_INT - 2> FRV_final_Data_T;

#define BIT_VEC_INT_TRU 2 // saturate on +-1 meter
#define BIT_VEC_FRAC_TRU 11
typedef ap_fixed<BIT_VEC_FRAC_TRU + BIT_VEC_INT_TRU, BIT_VEC_INT_TRU> V_final_Data_T; // should be ap_fixed<49, 26> due to the product
#define BIT_VEC_Z_INT_TRU 2 // saturate on 2 meter
#define BIT_VEC_Z_FRAC_TRU 11
typedef ap_ufixed<BIT_VEC_Z_FRAC_TRU + BIT_VEC_Z_INT_TRU + 1,
BIT_VEC_Z_INT_TRU + 1> Vz_T_Data_T;
// but the reality is that it's limited between -1 and 1
#define BIT_PIXEL_INT 11
#define BIT_PIXEL_FRAC 6
#define BIT_PIXEL (BIT_PIXEL_FRAC+BIT_PIXEL_INT)
typedef ap_fixed<BIT_PIXEL, BIT_PIXEL_INT> Vxy_T_Data_T;
typedef ap_int<BIT_PIXEL_INT> bound_Data_T;

struct Vertice_final {
	Vxy_T_Data_T x_px;
	Vxy_T_Data_T y_px;
	Vz_T_Data_T z;
};

typedef ap_fixed<BIT_PIXEL + 2, BIT_PIXEL_INT + 1> Vec_delta_Data_T;
typedef ap_fixed<BIT_PIXEL + BIT_PIXEL + 2, BIT_PIXEL_INT + BIT_PIXEL_INT + 2> Vec_Norm_Data_T;

typedef ap_fixed<4 * BIT_PIXEL_INT + 4,
BIT_PIXEL_INT + BIT_PIXEL_INT + 2> Vec_Recip_Area_Data_T;
typedef ap_ufixed<BIT_PIXEL + BIT_PIXEL + 2,
BIT_PIXEL_FRAC + BIT_PIXEL_FRAC> Vec_Recip_tru_Area_Data_T;

typedef ap_fixed<
BIT_PIXEL + BIT_PIXEL_INT + 3 + BIT_VEC_Z_FRAC_TRU + BIT_VEC_Z_INT_TRU,
BIT_PIXEL_INT + BIT_PIXEL_INT + 2 + BIT_VEC_Z_INT_TRU> Depth_Non_Norm_Data_T;

struct position {
	bound_Data_T actual_row;
	bound_Data_T actual_col;
};

struct offset_position {
	bound_Data_T offset_row;
	bound_Data_T offset_col;
};
struct intervals {
	ap_uint<BIT_CENTRE> min;
	ap_uint<BIT_CENTRE> max;
};
struct size_BB {
	ap_uint<BIT_BB_IMG> width;
	ap_uint<BIT_BB_IMG> height;
};

#define BIT_WEIGHT_INT 1
#define BIT_WEIGHT_FRAC 8
#define BIT_WEIGHT (BIT_WEIGHT_INT+BIT_WEIGHT_FRAC)
#define BIT_ADDRESS 9 // log2(510)
typedef ap_ufixed<BIT_WEIGHT, BIT_WEIGHT_INT> weight_Data_T;
typedef ap_uint<BIT_ADDRESS> weight_address_Data_T;
#define BIT_COUNT_SIZE 16
typedef ap_uint<BIT_COUNT_SIZE> count_pixel_Data_T;
typedef ap_ufixed<4 + BIT_COUNT_SIZE, BIT_COUNT_SIZE> Inlier_Data_T;
typedef ap_ufixed<BIT_COUNT_SIZE + BIT_COUNT_SIZE + 9,
BIT_COUNT_SIZE + BIT_COUNT_SIZE + 1> Numerator_Data_T;
typedef ap_ufixed<BIT_COUNT_SIZE + BIT_COUNT_SIZE + 1,
BIT_COUNT_SIZE + BIT_COUNT_SIZE> Denominator_Data_T;

struct Raster_Core_Output {
	Numerator_Data_T Numerator;
	Denominator_Data_T Denominator;
};

struct Inlier_Output {
	weight_Data_T weight;
	weight_address_Data_T address;
};

struct Struct_Sorter {
	weight_Data_T weight;
	weight_address_Data_T address;
	u1_Data_T flush;
};

typedef ap_ufixed<BIT_WEIGHT + BIT_ADDRESS, BIT_WEIGHT_INT + BIT_ADDRESS> FR_SUM_Data_T; // BIT address is the log 2 of the number of sample
typedef ap_ufixed<BIT_WEIGHT + BIT_ADDRESS + BIT_WEIGHT + BIT_ADDRESS,
BIT_WEIGHT + BIT_ADDRESS> FR_SUM_RECIPR_Data_T; // BIT address is the log 2 of the number of sample

typedef ap_ufixed<BIT_WEIGHT + BIT_ADDRESS, BIT_WEIGHT_FRAC> FR_Norm_Data_T; // BIT address is the log 2 of the number of sample

typedef ap_ufixed<BIT_WEIGHT + BIT_ADDRESS + BIT_WEIGHT + BIT_ADDRESS,
BIT_WEIGHT_INT + BIT_ADDRESS + BIT_WEIGHT_FRAC> FR_WN_Data_T;

struct Struct_Resampler {
	Norm_weights_Data_T weight;
	weight_address_Data_T address;
};

/*
 * BOX MULLER
 */
typedef ap_ufixed<18, 0> Usquare_Data_T;
typedef ap_fixed<14 + 5, 5> Gauss_Data_T;
typedef ap_fixed<14 + 5, 5> std_dev_Data_T;
typedef ap_fixed<14 + 5, 5> mean_Data_T;

#endif
