#include "m_initializer.hpp"

/*
 *
 * Init_load_sum_prob (2)
 *
 */

void Init_load_sum_prob(FS_W_fix_Data_T all_prob[6300],
		Norm_coeff_Data_T norm_fill,
		stream<Norm_weights_Data_T> & Norm_weights) {

	Full_Res_Sum_Data_T full_res_sum;


#ifdef NDEBUG
	std::string fileFS_S = "FS_Prob.txt";
	std::ofstream FS_PROB(fileFS_S.c_str());
	FS_PROB << "FS_Prob = np.array([";
	for (int index = 0; index < PYRAMID_PIXELS; index++) {
		if (index < PYRAMID_PIXELS - 1) {
			FS_PROB << all_prob[index] << ", ";
		} else {
			FS_PROB << all_prob[index] << "])" << std::endl;
		}
	}
	FS_PROB.close();
#endif


#ifdef NDEBUG
	///////////////////////////////WARNING////////////////////////////////////////
	std::string fileFS = "CS.txt";
	std::ofstream CS(fileFS.c_str());
	CS << "CS = np.array([";
	///////////////////////////////////////////////////////////////////////
#endif
	Initialize_Norm: for (u13_Data_T c = 0; c < PYRAMID_PIXELS; c++) {
#pragma HLS PIPELINE II=1

		FS_W_fix_Data_T new_weight = all_prob[c];

		//with this condition we limits the lower bound of the sum to 0.0753632 = 2^-16 * PYRAMID_PIXELS

		FS_W_fix_Data_T new_add;

		new_add = new_weight;

		if (!c.or_reduce()) { // if we  are in the first iteration
							  // no need of power on initialization
			full_res_sum = new_add;
		} else {
			full_res_sum += new_add;
		}

		Full_Res_Norm_Sum_Data_T full_res_norm = full_res_sum * norm_fill;
		Norm_weights_Data_T weights2nsgen_fill;
		if (c == PYRAMID_PIXELS - 1) {
			weights2nsgen_fill.range() = ONE_TRUNC_INIT;		// set to one
		} else {
			weights2nsgen_fill = full_res_norm;
		}

		Norm_weights.write(weights2nsgen_fill);
#ifdef NDEBUG
		///////////////////////////////////////////////////////////////////////
		if (c < PYRAMID_PIXELS - 1) {
			CS << full_res_sum << ", ";
		} else {
			CS << full_res_sum << "])" << std::endl;
		}
#endif
		///////////////////////////////////////////////////////////////////////
#ifdef PRINT_INIT
		std::cout << c << std::endl;
		std::cout << "\tw_curr   : " << full_res_sum << " \t *" << std::endl;
		std::cout << "\new   : " << new_add << std::endl;
		std::cout << "\tnorm     : " << norm_fill << " \t =" << std::endl;
		std::cout << "\t---------------------------- " << std::endl;
		std::cout << "\tRes full : " << full_res_norm << std::endl;
		std::cout << "\tRes trun : " << weights2nsgen_fill << std::endl;
		std::cout << "---------------------------- " << std::endl;
#endif
	}
#ifdef NDEBUG

	///////////////////////////////////////////////////////////////////////
	CS.close();
	///////////////////////////////////////////////////////////////////////
#endif
}

void INIT(FS_W_fix_Data_T all_prob[6300], BBOX all_box[6300],
		Norm_coeff_Data_T norm_fill, u18_Data_T seed,
		Mem_SAMPLE Samples[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES],
		Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES],
		Norm_weights_Data_T acc_norm_weights_[6300],
		Mem_Heuristic Heuristics[6300]) {

#pragma HLS DATAFLOW
	static hls::stream<Norm_weights_Data_T> Norm_weights;
#pragma HLS STREAM variable=Norm_weights depth=1 dim=1
	static hls::stream<Norm_weights_Data_T> Norm_weights_CPY;
#pragma HLS STREAM variable=Norm_weights_CPY depth=1 dim=1
	static hls::stream<THR_INFO_Data_T> THR_INFO;
#pragma HLS STREAM variable=THR_INFO depth=1 dim=1
	static hls::stream<BOUNDS_RAND_Data_T> Bounds_stream;
#pragma HLS STREAM variable=Bounds_stream depth=1 dim=1
	static hls::stream<u18_Data_T> RAND_stream;
#pragma HLS STREAM variable=RAND_stream depth=1 dim=1
	static stream<FS_W_fix_Data_T> weights2acc_stream;
#pragma HLS STREAM variable=weights2acc_stream depth=1 dim=1

	static stream<u13_Data_T> sample_indx_stream;
#pragma HLS STREAM variable=sample_indx_stream depth=1 dim=1

	static stream<angle_Data_T> x_angle_stream;
#pragma HLS STREAM variable=x_angle_stream depth=1 dim=1
	static stream<angle_Data_T> y_angle_stream;
#pragma HLS STREAM variable=y_angle_stream depth=1 dim=1
	static stream<angle_Data_T> z_angle_stream;
#pragma HLS STREAM variable=z_angle_stream depth=1 dim=1
	static stream<randZ01> random_z01;
#pragma HLS STREAM variable=random_z01 depth=1 dim=1

	std::cout << " Init_load_sum_prob" << std::endl;
	Init_load_sum_prob(all_prob, norm_fill, Norm_weights);

	std::cout << " ANGLES" << std::endl;
	Angle_Genx(x_angle_stream);
	Angle_Geny(y_angle_stream);
	Angle_Genz(z_angle_stream);
	RandZ(random_z01);

	std::cout << " LFSR" << std::endl;
	LFSR18_init(seed, RAND_stream);

	std::cout << " THR" << std::endl;
	Thr_Analizer(Norm_weights, Norm_weights_CPY, THR_INFO);

	std::cout << " GEN_RANDBOUND" << std::endl;
	Init_gen_rand_bound(THR_INFO, RAND_stream, Bounds_stream);

	std::cout << " GEN INDX" << std::endl;
	Init_gen_sampleindx(Norm_weights_CPY, Bounds_stream, sample_indx_stream,
			acc_norm_weights_);

	std::cout << " GEN_SAMPLE" << std::endl;
	Gen_Sample(sample_indx_stream, x_angle_stream, y_angle_stream,
			z_angle_stream, Samples, Sample_abs_indx, Sample_abs_indx_CPY,
			all_box, Heuristics, random_z01);
}
