#include "m_initializer_resample.hpp"

void Thr_Analizer(stream<Norm_weights_Data_T> & Norm_weights,
		stream<Norm_weights_Data_T> & Norm_weights_out,
		stream<THR_INFO_Data_T> & THR_INFO) {

	THR_Data_T past_thr = 0;
	THR_P_Data_T Sent_cnt = 0;
	Init_wr_weights: for (u13_Data_T norm_ind = 0; norm_ind < PYRAMID_PIXELS;
			norm_ind++) {
#pragma HLS PIPELINE II=1
		Norm_weights_Data_T weights2nsgen_fill;

		// Just copy temporary the information
		Norm_weights.read(weights2nsgen_fill);
		Norm_weights_out.write(weights2nsgen_fill);

		THR_Data_T curr_thr = weights2nsgen_fill.range(BIT_WEIGHT_NORM - 1,
		BIT_WEIGHT_NORM - BIT_THR);
#ifdef PRINT_INIT
		std::cout << norm_ind << std::endl;
		std::cout << "\tSto fx : " << weights2nsgen_fill << std::endl;
		std::cout << "\tcurthr : " << curr_thr << std::endl;
		std::cout << "\tpast_thr : " << past_thr << std::endl;
		std::cout << "---------------------------- " << std::endl;
#endif
		if (curr_thr - past_thr >= 1) {

			// AGGIUNGI UN COUNTER DI QUANTI THR HAI COSI"' SE PER CASO SONO TROPPI
			// POCHI LO DICI AL PROSSIMO MODULO
			THR_INFO_Data_T THR_INFO_fill = curr_thr.concat(norm_ind);
			THR_INFO.write(THR_INFO_fill);
			past_thr = curr_thr;
			Sent_cnt++;
		}

	}

	for (; Sent_cnt < SIZE_ARR_THR; Sent_cnt++) {
#pragma HLS PIPELINE II=1
#pragma HLS LOOP_TRIPCOUNT min=1 max=32 avg=16
		THR_INFO.write(0);
	}

}

/*
 *
 * LFSR18 ( 5.0 )
 *
 */

void LFSR18_init(u18_Data_T & seed, stream<u18_Data_T> & RAND_stream) {
	u18_Data_T lfsr;
	if (seed == 0) {
		lfsr = 68148;
	} else {
		lfsr = seed;
	}
#ifdef NDEBUG
	std::string fileFS = "RAND_NUMBERS.txt";
	std::ofstream RAND_NUMBERS(fileFS.c_str());
	RAND_NUMBERS << "RAND_NUMBERS = np.array([";
#endif
//these one are needed otherwise they will be sinth as 32 or 64 bit constant !
	for (u10_Data_T i = 0; i < NUM_PARTICLES; i++) {
#pragma HLS PIPELINE II=1
		u1_Data_T b_18 = lfsr.get_bit(18 - 18);
		u1_Data_T b_11 = lfsr.get_bit(18 - 11);
		u1_Data_T new_bit = b_18 ^ b_11;
		lfsr = lfsr >> 1;
		lfsr.set_bit(17, new_bit);
		RAND_stream.write(lfsr);
#ifdef NDEBUG
		if (i < NUM_PARTICLES - 1) {
			ap_ufixed<18, 0> temp;
			temp.range(17, 0) = lfsr;
			RAND_NUMBERS << temp << ", ";
		} else {
			ap_ufixed<18, 0> temp;
			temp.range(17, 0) = lfsr;
			RAND_NUMBERS << temp << "])" << std::endl;
		}
#endif

	}
#ifdef NDEBUG
	RAND_NUMBERS.close();
#endif

}

/*
 *
 * Init_gen_rand_bound ( 5.1 )
 *
 */

void Init_gen_rand_bound(stream<THR_INFO_Data_T> & THR_INFO,
		stream<u18_Data_T> & RAND_stream,
		stream<BOUNDS_RAND_Data_T> & Bounds_stream) {

	// CURRENT THR concat to the address  ( 5 + 13 )
	THR_INFO_Data_T thr_array[SIZE_ARR_THR];
#pragma HLS ARRAY_PARTITION variable=thr_array cyclic factor=2 dim=1

	THR_P_Data_T zero_thr_counter;
	for (THR_P_Data_T counter = 0; counter < SIZE_ARR_THR; counter++) {
#pragma HLS PIPELINE II=1
		THR_INFO_Data_T THR_INFO_fill;
		THR_INFO.read(THR_INFO_fill);
		thr_array[counter] = THR_INFO_fill;
		// THE FIRST THR CAN HAPPEN IN THE ZERO POSITION BUT NOT THE ZERO THR
		if (!counter.or_reduce()) {
			zero_thr_counter = 0;
		} else if (!THR_INFO_fill.or_reduce()) { // THIS IS THE CONDITION TO MARK
			zero_thr_counter++;
		}

	}
#ifdef NDEBUG
	std::string thr_value_s = "thr_value.txt";
	std::ofstream thr_value(thr_value_s.c_str());
	thr_value << "thr_value = np.array([";
	for (int index = 0; index < SIZE_ARR_THR; index++) {
		if (index < SIZE_ARR_THR - 1) {
			ap_ufixed<BIT_THR, 0> temp;
			temp.range() = thr_array[index].range(
			BIT_WEIGHT_NORM - 1,
			BIT_WEIGHT_NORM - BIT_THR);
			thr_value << temp << ", ";
		} else {
			ap_ufixed<BIT_THR, 0> temp;
			temp.range() = thr_array[index].range(
			BIT_WEIGHT_NORM - 1,
			BIT_WEIGHT_NORM - BIT_THR);
			thr_value << temp << "])" << std::endl;
		}
	}
	thr_value.close();

	std::string thr_index_s = "thr_index.txt";
	std::ofstream thr_index(thr_index_s.c_str());
	thr_index << "thr_index = np.array([";
	for (int index = 0; index < SIZE_ARR_THR; index++) {
		if (index < SIZE_ARR_THR - 1) {
			thr_index << thr_array[index].range(BIT_SUM_INIT - 1, 0) << ", ";
		} else {
			thr_index << thr_array[index].range(BIT_SUM_INIT - 1, 0) << "])"
					<< std::endl;
		}
	}
	thr_index.close();
#endif
	Init_new_sampl_generation: for (u10_Data_T i = 0; i < NUM_PARTICLES; i++) {
#pragma HLS PIPELINE II=1

		u18_Data_T rand_numb_fill;
		u13_Data_T bottom_stream_fill;
		u13_Data_T top_stream_fill;
		rand_numb_fill = RAND_stream.read();

		THR_Data_T thr_local = rand_numb_fill.range(BIT_WEIGHT_NORM - 1,
		BIT_WEIGHT_NORM - BIT_THR);
		if (!thr_local.or_reduce()) { // this fix the lower intervall
			bottom_stream_fill = 0;
			top_stream_fill = thr_array[0].range(BIT_SUM_INIT - 1, 0);
		} else if (thr_local == 31) { // this fix the upper intervall
			bottom_stream_fill =
					thr_array[SIZE_ARR_THR - 1 - zero_thr_counter].range(
					BIT_SUM_INIT - 1, 0); //from 31 downto
			top_stream_fill = PYRAMID_PIXELS - 1;
		} else {

			Init_gen_rand_bound_trk: for (THR_P_Data_T counter = 2;
					counter < SIZE_ARR_THR; counter++) {
#pragma HLS UNROLL
				THR_INFO_Data_T temporaneo_Prec = thr_array[counter - 1];
				THR_INFO_Data_T temporaneo_act = thr_array[counter];
				if (thr_local < temporaneo_act.range(BIT_THR + BIT_SUM_INIT - 1,
				BIT_SUM_INIT)) {
#ifdef PRINT_INIT

					std::cout << " \t thr_array_val "
					<< temporaneo_act.range(BIT_THR + BIT_SUM_INIT - 1,
							BIT_SUM_INIT); // VALUE
					std::cout << " \t thr_local " << thr_local;
					std::cout << " \t Address_array THR "
					<< temporaneo_act.range(BIT_SUM_INIT - 1, 0);
#endif
					bottom_stream_fill = temporaneo_Prec.range(
					BIT_SUM_INIT - 1, 0);
					top_stream_fill = temporaneo_act.range(
					BIT_SUM_INIT - 1, 0);
					break;
				} else if (counter == SIZE_ARR_THR - zero_thr_counter - 1) {
					break;
				}

			}
		}
#ifdef PRINT_INIT
		std::cout << " \t u_rand " << rand_numb_fill; // ADDRESS
		std::cout << " \t bottom " << bottom_stream_fill;
		std::cout << " \t top " << top_stream_fill << std::endl;// WEIGHTS

#endif

		BOUNDS_RAND_Data_T FIll;
		FIll.range(BIT_RANDOM_NUMBER + BIT_SUM_INIT + BIT_SUM_INIT - 1,
		BIT_RANDOM_NUMBER + BIT_SUM_INIT) = top_stream_fill;
		FIll.range(BIT_RANDOM_NUMBER + BIT_SUM_INIT - 1, BIT_RANDOM_NUMBER) =
				bottom_stream_fill;
		FIll.range(BIT_RANDOM_NUMBER - 1, 0) = rand_numb_fill;
		Bounds_stream.write(FIll);
	}

}

/*
 *
 * Init_gen_sampleindx ( 5.2 )
 *
 */

void Init_gen_sampleindx(stream<Norm_weights_Data_T> & Norm_weights,
		stream<BOUNDS_RAND_Data_T> & Bounds_stream,
		stream<u13_Data_T> & sample_indx_stream,
		Norm_weights_Data_T acc_norm_weights_[6300]) {

	u10_Data_T saver_counter = 0;
	Init_wr_weights: for (u13_Data_T norm_ind = 0; norm_ind < PYRAMID_PIXELS;
			norm_ind++) {

#pragma HLS PIPELINE II=1

		Norm_weights_Data_T Norm_weights_fill;
		Norm_weights.read(Norm_weights_fill);
		acc_norm_weights_[norm_ind] = Norm_weights_fill;

	}
#ifdef NDEBUG
	std::string fileFS = "CSN.txt";
	std::ofstream CSN(fileFS.c_str());
	CSN << "CSN = np.array([";
	for (int index = 0; index < PYRAMID_PIXELS; index++) {
		if (index < PYRAMID_PIXELS - 1) {
			CSN << acc_norm_weights_[index] << ", ";
		} else {
			CSN << acc_norm_weights_[index] << "])" << std::endl;
		}
	}
	CSN.close();
	std::string Sampl_indx_s = "Sampl_indx.txt";
	std::ofstream Sampl_indx(Sampl_indx_s.c_str());
	Sampl_indx << "Sampl_indx = np.array([";
#endif

	Init_new_sampl_generation: for (u10_Data_T i = 0; i < NUM_PARTICLES; i++) {
		BOUNDS_RAND_Data_T Bounds_stream_fill;
		Bounds_stream.read(Bounds_stream_fill);

		ap_uint<BIT_SUM_INIT> TOP = Bounds_stream_fill.range(
		BIT_RANDOM_NUMBER + BIT_SUM_INIT + BIT_SUM_INIT - 1,
		BIT_RANDOM_NUMBER + BIT_SUM_INIT);
		ap_uint<BIT_SUM_INIT> BOTTOM = Bounds_stream_fill.range(
		BIT_RANDOM_NUMBER + BIT_SUM_INIT - 1, BIT_RANDOM_NUMBER);
		ap_ufixed<BIT_RANDOM_NUMBER, 0> RAND;
		RAND.range() = Bounds_stream_fill.range(BIT_RANDOM_NUMBER - 1, 0);

// To reduce the loop iterations from PYRAMID_PIXELS to PYRAMID_PIXELS/4
		for (u13_Data_T index = BOTTOM; index <= TOP; index++) {
#pragma HLS PIPELINE II=1
#pragma HLS LOOP_TRIPCOUNT min=1 max=6300 avg=16

			Norm_weights_Data_T temp_value = acc_norm_weights_[index];
			if (temp_value >= RAND) {
				saver_counter++;
				sample_indx_stream.write(index);
#ifdef NDEBUG
				if (i < NUM_PARTICLES - 1) {
					Sampl_indx << index << ", ";
				} else {
					Sampl_indx << index << "])" << std::endl;
				}
#endif
				break;
			}
		}
	}
#ifdef NDEBUG
	Sampl_indx.close();
#endif

	for (; saver_counter < NUM_PARTICLES; saver_counter++) {
		sample_indx_stream.write(0);
	}

}

