 #include "postprocess.hpp"

float SftmaxTable[256];
float SftmaxTable2[256];

void TOP(volatile int8_t* SHARED_DRAM, volatile int8_t* SHARED_DRAM2,
		volatile int8_t* SHARED_DRAM3) {
#pragma HLS INTERFACE m_axi depth=HEATMAP1_DEPTH port=SHARED_DRAM offset=slave bundle=memorybus register
#pragma HLS INTERFACE m_axi depth=HEATMAP2_DEPTH port=SHARED_DRAM2 offset=slave bundle=memorybus register
#pragma HLS INTERFACE m_axi depth=HEATMAP3_DEPTH port=SHARED_DRAM3 offset=slave bundle=memorybus register

//#pragma HLS INTERFACE m_axi depth=6144000 port=object_RAM offset=slave bundle=object
#pragma HLS INTERFACE s_axilite port=return bundle=axilite register

	createSoftmaxTable();
	Mem_Heuristic Heuristics[6300];
	Mem_SAMPLE Samples[2][NUM_PARTICLES];
	Sample_abs_indx_Data_T Sample_abs_indx[NUM_PARTICLES];
	Sample_abs_indx_Data_T Sample_abs_indx_CPY[NUM_PARTICLES];
	Depth_Data_T Depth_scene[480][640];
	FS_W_fix_Data_T all_prob[21][6300];
	BBOX all_box[6300];
	Full_Res_Sum_Data_T all_sum[21];

	for (int c = 0; c < 21; c++) {
		all_sum[c] = 0;
	}

	Norm_weights_Data_T acc_norm_weights_[6300];
	weight_address_Data_T Resampled_Addresses[510];

	u30_Data_T Tri_Mem[OBJMODEL_F_MAX];
	Vertice_Data_T V_Mem[3][OBJMODEL_V_MAX];
	postprocess_stream_top(SHARED_DRAM, all_prob, all_box, all_sum, HEATMAP_W1,
			HEATMAP_H1, 1, 1);
//	printf("--------------heatmap2--------------------\n");
	postprocess_stream_top(SHARED_DRAM2, all_prob, all_box, all_sum, HEATMAP_W2,
			HEATMAP_H2, 2, 4);
//	printf("--------------heatmap3--------------------\n");
	postprocess_stream_top(SHARED_DRAM3, all_prob, all_box, all_sum, HEATMAP_W3,
			HEATMAP_H3, 4, 16);

//////////////////////////////////////////////////////////////////////////////////

	float object_RAM[OBJMODEL_MAXSIZE];
	load_heuristics(Heuristics);

//	std_dev_Data_T std_rot = 1.2;
//	std_dev_Data_T std_pos = 10;
//	stream<Gauss_Data_T> G_Rand_pos;
//	stream<Gauss_Data_T> G_Rand_rot;
//	Box_muller(std_rot, std_pos, G_Rand_pos, G_Rand_rot);
//	for (u11_Data_T i = 0; i < Gauss_number_needed; i++) {
//		G_Rand_rot.read();
//		G_Rand_pos.read();
//	}
//////////////////////////////////////////////////////////////////////////////////

#include "./TB_FILES/nonetf_withouttable_Z_ch.hpp"
	for (int row = 0; row < HEIGHT; row++) {
		for (int col = 0; col < WIDTH; col++) {
			Depth_scene[row][col] = Depth_Data_T(
			// depth from the camera  withouth the table
					nonetf_withouttable_Z_ch[row * WIDTH + col]);
		}
	}

#ifdef NDEBUG

	std::stringstream ss;
	ss << "ALL_BOUNDING_OBJ.ppm";
	std::string str = ss.str();
	std::ofstream img(str.c_str());
	img << "P1" << std::endl;
	img << WIDTH << " " << HEIGHT << std::endl;
	int BB_MAP[HEIGHT][WIDTH];
	for (int row = 0; row < 480; row++) {
		for (int col = 0; col < 640; col++) {

			BB_MAP[row][col] = 0;

		}
	}
	for (int sample = 0; sample < Num_Particles; sample++) {
		int centre_y = all_box[heatmap[sample]].y_centre_height.range(17, 8);
		int centre_x = all_box[heatmap[sample]].x_centre_width.range(17, 8);

		int Height_y = all_box[heatmap[sample]].y_centre_height.range(7, 0);
		int Width_x = all_box[heatmap[sample]].x_centre_width.range(7, 0);

		int col_start = centre_x - Width_x / 2;
		int col_end = centre_x + Width_x / 2;
		int row_start = centre_y - Height_y / 2;
		int row_end = centre_y + Height_y / 2;
		for (int row = row_start; row < row_end; row++) {
			for (int col = col_start; col < col_end; col++) {
				if (row == row_start || row == row_end - 1) {
					BB_MAP[row][col] = 1;

				} else {
					if (col == col_start || col == col_end - 1) {
						BB_MAP[row][col] = 1;
					}
				}
			}
		}
	}

//img_color.close();
	for (int row = 0; row < 480; row++) {
		for (int col = 0; col < 640; col++) {

			img << BB_MAP[row][col] << " ";

		}
		img << "\n";
	}

	img.close();

#endif

	u18_Data_T rand_seed = 9462;
	u18_Data_T rand_seed2 = 453;

	for (int object_index = 9; object_index < 10; object_index++) {

		if (object_index == mustard_bottle || object_index == tomato_soup_can
				|| object_index == banana || object_index == bleach_cleanser
				|| object_index == cracker_box
				|| object_index == potted_meat_can) {
			std_dev_Data_T trans_var = 0.07;
			std_dev_Data_T rot_var = 0.3;
			ap_ufixed<BIT_SUM_INIT + MAX_INIT_BIT + 1, MAX_INIT_BIT + 1> norm_bef_fill =
					all_sum[object_index];
			//std::cout << norm_bef_fill << " " << all_sum[object_index] << std::endl;
			norm_bef_fill = hls::recip(norm_bef_fill);
			Norm_coeff_Data_T norm_fill = norm_bef_fill;
			int iteration_count = 0;
			Inlier_Output winner;
			// RASTER ALL OF THE OBJECTS

			ap_uint<1> in = 0;
			ap_uint<1> out = 1;

			Preload_OBJ(object_RAM, object_index);
			INIT(all_prob[object_index], all_box, norm_fill, rand_seed,
					Samples[in], Sample_abs_indx, Sample_abs_indx_CPY,
					acc_norm_weights_, Heuristics);

		std::cout << " LOAD OBJECT MODEL " << object_index << std::endl;
			Load_ObjectModel(object_RAM, object_index, Tri_Mem, V_Mem);
			//Preload_Pos(Samples, object_index);

	//		do {
				Inlier(Samples[in], Tri_Mem, V_Mem, object_index, Depth_scene,
						Sample_abs_indx, Sample_abs_indx_CPY,
						all_prob[object_index], all_box, Resampled_Addresses,
						rand_seed2, acc_norm_weights_, winner);
#ifndef __SYNTHESIS__
				std::cout << iteration_count << ") \n" << "WINNER : "
						<< winner.weight << " Address : " << winner.address
						<< std::endl;
#endif
				if (winner.weight <= 0.75) {

					trans_var = std_dev_Data_T(0.07) * (1 - winner.weight);
					rot_var = std_dev_Data_T(0.75) * (1 - winner.weight);
#ifndef __SYNTHESIS__
					std::cout << " Samples[" << iteration_count << "].x_S = "
							<< Samples[in][winner.address].x_S << "; \n"
							<< " Samples[" << iteration_count << "].y_S = "
							<< Samples[in][winner.address].y_S << "; \n"
							<< " Samples[" << iteration_count << "].z_S = "
							<< Samples[in][winner.address].z_S << "; \n"
							<< " Samples[" << iteration_count << "].xroll_S = "
							<< Samples[in][winner.address].xroll_S << "; \n"
							<< " Samples[" << iteration_count << "].ypitch_S = "
							<< Samples[in][winner.address].ypitch_S << "; \n"
							<< " Samples[" << iteration_count << "].zyaw_S = "
							<< Samples[in][winner.address].zyaw_S << "; "
							<< std::endl;
					std::cout << " Sample_abs_indx[" << iteration_count << "]= "
							<< Sample_abs_indx[winner.address] << "; \n"
							<< all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
									17, 8) << " "
							<< all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
									17, 8) << " "
							<< all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
									7, 0) << " "
							<< all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
									7, 0) << std::endl;
#endif
					Diffuse(Resampled_Addresses, Samples[in], Samples[out],
							Sample_abs_indx, Sample_abs_indx_CPY, Heuristics,
							all_box, trans_var, rot_var);

					for (int i = 0; i < Num_Particles; i++) {
						Sample_abs_indx[i] = Sample_abs_indx_CPY[i];
					}
					in = out;
					out = ~out;
					iteration_count++;
				}

		//	} while (winner.weight <= 0.75);
#ifndef __SYNTHESIS__
			std::cout << " Samples[" << iteration_count << "].x_S = "
					<< Samples[out][winner.address].x_S << " \n" << " Samples["
					<< iteration_count << "].y_S = "
					<< Samples[out][winner.address].y_S << " \n" << " Samples["
					<< iteration_count << "].z_S = "
					<< Samples[out][winner.address].z_S << " \n" << " Samples["
					<< iteration_count << "].xroll_S = "
					<< Samples[out][winner.address].xroll_S << " \n"
					<< " Samples[" << iteration_count << "].ypitch_S = "
					<< Samples[out][winner.address].ypitch_S << " \n"
					<< " Samples[" << iteration_count << "].zyaw_S = "
					<< Samples[out][winner.address].zyaw_S << std::endl;
			std::cout << " Sample_abs_indx[" << iteration_count << "]= "
					<< Sample_abs_indx[winner.address] << " \n"
					<< all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
							17, 8) << " "
					<< all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
							17, 8) << " "
					<< all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
							7, 0) << " "
					<< all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
							7, 0) << std::endl;
#endif

			int x_C = all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
										17, 8) ;
			int y_C =  all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
										17, 8) ;
			int w = all_box[Sample_abs_indx[winner.address]].x_centre_width.range(
										7, 0);
			int h = all_box[Sample_abs_indx[winner.address]].y_centre_height.range(
										7, 0);

			for (int row = y_C - h/2; row < y_C + h/2; row++) {
					for (int col = x_C - w/2; col < x_C+w/2; col++) {
						Depth_scene[row][col] =  Depth_Data_T(3.99805);
					}
				}
		}
	}

}
void createSoftmaxTable() {
	float step = 8;
	for (int i = -128; i < 128; i++) {
//range 1.12*10^-7 ~ 8.8*10^6
		SftmaxTable[i + 128] = hls::exp(float(i) / step);
		SftmaxTable2[i + 128] = hls::exp(float(i) / step) + 1.0f;
	}
}

float lookupSM(int8_t x) {
	return SftmaxTable[(x + 128)];
}

float lookupSM2(int8_t x) {
	return SftmaxTable2[(-x + 128)];
}

void accumulate_sum(hls::stream<float>& sum,
		hls::stream<float> &accu_sum_stream, int W, int H) {

	for (int h = 0; h < H; h++) {
#pragma HLS loop_tripcount min=15 max=60 avg=30
		for (int w = 0; w < W; w++) {
#pragma HLS loop_tripcount min=20 max=80 avg=40
			float accu_sum = 0;
			accu_sum: for (int c = 0; c < 21; c++) {
#pragma HLS PIPELINE
				float accu = accu_sum_stream.read();
				accu_sum += accu;
			}
//#ifndef SYNTHESIS
//			printf("accu_sum: %f\n", accu_sum);
//#endif
			sum.write(accu_sum);
		}
	}
}

void calc_bbox(hls::stream<float> & bbox_stream, BBOX all_box[6300],
		ap_uint<8> W, ap_uint<8> H, ap_uint<8> S, ap_uint<8> S_eq) {
	ap_uint<8> anchor_shape = 224 / S;
	ap_ufixed<20, 8> reci_w, reci_h;
	reci_w = (W + 1);
	reci_w = hls::recip(reci_w);
	ap_ufixed<12, 0> reci_w_trunc = reci_w;
	reci_h = (H + 1);
	reci_h = hls::recip(reci_h);
	ap_ufixed<12, 0> reci_h_trunc = reci_h;
	static ap_uint<15> counter = 0;
	ap_uint<8> width;
	ap_uint<8> height;

	ap_fixed<8, 5> bbox1;
	ap_fixed<8, 5> bbox2;

	ap_uint<10> x;
	ap_uint<10> y;
	ap_ufixed<30, 20, SC_TRN, SC_SAT> bbox_calc;
	float bbox1_f;
	float bbox2_f;

	for (ap_uint<8> h = 0; h < H; h++) {
#pragma HLS loop_tripcount min=15 max=60 avg=30
		for (ap_uint<8> w = 0; w < W; w++) {
#pragma HLS loop_tripcount min=20 max=80 avg=40
//PROBLEM HERE!!!!
			for (ap_uint<3> i = 0; i < 4; i++) {
#pragma HLS PIPELINE
				float temp = bbox_stream.read();

				switch (i) {
				case 0:
					bbox1 = temp;
					bbox_calc = ap_ufixed<32, 20, SC_TRN, SC_SAT>(
							((w + 1) * 640) * reci_w_trunc
									+ bbox1 * anchor_shape);

					bbox1_f =
							(((w + 1) * 640) / (W + 1) + bbox1 * anchor_shape);
					x = bbox_calc.range(19, 10);

					break;
				case 1:
					bbox2 = temp;
					bbox_calc = ap_ufixed<32, 20, SC_TRN, SC_SAT>(
							(h + 1) * 480 * reci_h_trunc
									+ bbox2 * anchor_shape);
					bbox2_f = ((h + 1) * 480 / (H + 1) + bbox2 * anchor_shape);
					y = bbox_calc.range(19, 10);
					if (y > 379) {
						y = 379;
					} else if (y < 99) {
						y = 99;
					}
					break;
				case 2:
					width = ap_ufixed<8, 8, SC_TRN, SC_SAT>(
							anchor_shape * temp);
					if (width > 200) {
						width = 200;
					}
					if ((x - width / 2) < 0) {
						x = width / 2;
					} else if ((x + width / 2) > 639) {
						x = 639 - width / 2;
					}
					break;
				case 3:
					height = ap_ufixed<8, 8, SC_TRN, SC_SAT>(
							anchor_shape * temp);
					if (height > 200) {
						height = 200;
					}
					if ((y - height / 2) < 0) {
						y = height / 2;
					} else if ((y + height / 2) > 479) {
						y = 479 - height / 2;
					}
					all_box[counter].y_centre_height.range(17, 8) = y;
					all_box[counter].y_centre_height.range(7, 0) = height;
					all_box[counter].x_centre_width.range(17, 8) = x;
					all_box[counter].x_centre_width.range(7, 0) = width;
					all_box[counter].h_index_w_index.range(17, 9) = h;
					all_box[counter].h_index_w_index.range(8, 0) = w;
					break;
				}
			}
			counter++;
#ifdef NDEBUG
			std::cout<< "float reci: " << float(1/float(W+1)) << " fixed reci" << reci_w_trunc.to_float() << "float reci: " << float(1/float(H+1)) << " fixed reci" << reci_h_trunc.to_float() <<std::endl;

			std::cout <<"bbox: " << bbox1 << " " << bbox2 << " " << x << " " << y << " " << bbox1_f << " "
			<< bbox2_f << " h*w " << h*W+w << " counter: " << counter -1 << "scale: "<< S << std::endl;
#endif
		}

	}
}

void spliter(volatile int8_t* NN_OUTPUT, hls::stream<float> &accu_sum_stream,
		hls::stream<float> &buffer_stream, hls::stream<float> &conf_stream,
		hls::stream<float> &bbox_stream, ap_uint<8> W, ap_uint<8> H) {
	int counter = 0;
	for (ap_uint<17> h = 0; h < H * W; h++) {
#pragma HLS loop_tripcount min=300 max=4800 avg=1200
		//confidence
		conf_stream.write(lookupSM2(NN_OUTPUT[counter++]));
		//bbox
//			for (int c = 0; c< 4; c++){
//				bbox_stream.write(in.data);
//			}

		ap_fixed<8, 5> int_val;
		int_val.range(7, 0) = NN_OUTPUT[counter++];
		bbox_stream.write(int_val.to_float());
		int_val.range(7, 0) = NN_OUTPUT[counter++];
		bbox_stream.write(int_val.to_float());
		bbox_stream.write(lookupSM(NN_OUTPUT[counter++]));
		bbox_stream.write(lookupSM(NN_OUTPUT[counter++]));

		//classification
		class_splitter: for (int c = 0; c < 21; c++) {
#pragma HLS PIPELINE II=1
			int8_t in = NN_OUTPUT[counter++];

			accu_sum_stream.write(lookupSM(in));
			buffer_stream.write(lookupSM(in));
		}

	}

}

void calc_probablity(hls::stream<float>& sum, hls::stream<float> &buffer_stream,
		hls::stream<float> &conf_stream, FS_W_fix_Data_T all_prob[21][6300],
		Full_Res_Sum_Data_T all_sum[21], ap_uint<8> W, ap_uint<8> H) {
	static ap_uint<17> counter = 0;
	for (ap_uint<17> h = 0; h < H * W; h++) {
#pragma HLS loop_tripcount min=300 max=4800 avg=1200
		float conf = conf_stream.read();

		float sum_rev = float(1.0f / float(sum.read() * conf));
		for (int c = 0; c < 21; c++) {
#pragma HLS PIPELINE
			float buffer = buffer_stream.read();
			FS_W_fix_Data_T prob = (float) (buffer * sum_rev);
//				ap_uint<8> prob_int = prob.range(7,0);
//					printf("index: %d prob: %f, %d\n", counter, prob.to_float(), (uint8_t)prob_int);
//				prob_stream.write(prob_int);
			all_prob[c][counter] = prob;

			all_sum[c] += prob;

		}
		counter++;
	}


}

void postprocess_stream_top(volatile int8_t* NN_OUTPUT,
		FS_W_fix_Data_T all_prob[21][6300], BBOX all_box[6300],
		Full_Res_Sum_Data_T all_sum[21], ap_uint<8> W, ap_uint<8> H,
		ap_uint<8> S, ap_uint<8> S_sq) {
#pragma HLS DATAFLOW

	static hls::stream<float> accu_sum_stream;
#pragma HLS STREAM variable=accu_sum_stream depth=2 dim=1
	static hls::stream<float> buffer_stream;
#pragma HLS RESOURCE variable=buffer_stream core=FIFO_LUTRAM
#pragma HLS STREAM variable=buffer_stream depth=23 dim=1
	static hls::stream<float> sum_stream;
#pragma HLS STREAM variable=sum_stream depth=2 dim=1

	static hls::stream<float> conf_stream;
#pragma HLS STREAM variable=conf_stream depth=2 dim=1
	static hls::stream<float> bbox_stream;
#pragma HLS STREAM variable=bbox_stream depth=2 dim=1

	spliter(NN_OUTPUT, accu_sum_stream, buffer_stream, conf_stream, bbox_stream,
			W, H);
	calc_bbox(bbox_stream, all_box, W, H, S, S_sq);
	accumulate_sum(sum_stream, accu_sum_stream, W, H);

	calc_probablity(sum_stream, buffer_stream, conf_stream, all_prob, all_sum,
			W, H);

}
void load_heuristics(Mem_Heuristic Heuristics[6300]) {

#include "./TB_FILES/heuristic_xmin.hpp"
#include "./TB_FILES/heuristic_xmax.hpp"
#include "./TB_FILES/heuristic_ymin.hpp"
#include "./TB_FILES/heuristic_ymax.hpp"
#include "./TB_FILES/heuristic_zmin.hpp"
#include "./TB_FILES/heuristic_zmax.hpp"
	for (int i = 0; i < 6300; i++) {
		Heuristics[i].x_min = heuristic_xmin[i];
		Heuristics[i].x_max = heuristic_xmax[i];
		Heuristics[i].y_min = heuristic_ymin[i];
		Heuristics[i].y_max = heuristic_ymax[i];
		Heuristics[i].z_min = heuristic_zmin[i];
		Heuristics[i].z_max = heuristic_zmax[i];
	}

}
